=== modified file 'client/drizzle.c'
--- client/drizzle.c	2008-08-05 04:10:42 +0000
+++ client/drizzle.c	2008-08-06 00:04:45 +0000
@@ -197,7 +197,7 @@
 unsigned short terminal_width= 80;
 
 static uint opt_protocol= DRIZZLE_PROTOCOL_TCP;
-static CHARSET_INFO *charset_info= &my_charset_latin1;
+static const CHARSET_INFO *charset_info= &my_charset_latin1;
 
 const char *default_dbug_option="d:t:o,/tmp/drizzle.trace";
 int drizzle_real_query_for_lazy(const char *buf, int length);
@@ -2662,7 +2662,7 @@
 com_charset(DYNAMIC_STRING *buffer __attribute__((unused)), char *line)
 {
   char buff[256], *param;
-  CHARSET_INFO * new_cs;
+  const CHARSET_INFO * new_cs;
   strmake(buff, line, sizeof(buff) - 1);
   param= get_arg(buff, 0);
   if (!param || !*param)

=== modified file 'client/drizzlecheck.c'
--- client/drizzlecheck.c	2008-07-30 18:03:54 +0000
+++ client/drizzlecheck.c	2008-08-06 00:04:45 +0000
@@ -42,7 +42,7 @@
 static int first_error = 0;
 DYNAMIC_ARRAY tables4repair;
 static uint opt_protocol=0;
-static CHARSET_INFO *charset_info= &my_charset_latin1;
+static const CHARSET_INFO *charset_info= &my_charset_latin1;
 
 enum operations { DO_CHECK, DO_REPAIR, DO_ANALYZE, DO_OPTIMIZE, DO_UPGRADE };
 

=== modified file 'client/drizzledump.c'
--- client/drizzledump.c	2008-08-05 02:31:51 +0000
+++ client/drizzledump.c	2008-08-06 00:04:45 +0000
@@ -147,7 +147,7 @@
 static const char *drizzle_universal_client_charset=
   MYSQL_UNIVERSAL_CLIENT_CHARSET;
 static char *default_charset;
-static CHARSET_INFO *charset_info= &my_charset_latin1;
+static const CHARSET_INFO *charset_info= &my_charset_latin1;
 const char *default_dbug_option="d:t:o,/tmp/drizzledump.trace";
 /* have we seen any VIEWs during table scanning? */
 bool seen_views= 0;

=== modified file 'client/drizzleimport.c'
--- client/drizzleimport.c	2008-07-29 21:59:54 +0000
+++ client/drizzleimport.c	2008-08-06 00:04:45 +0000
@@ -54,7 +54,7 @@
 static uint     opt_drizzle_port= 0, opt_protocol= 0;
 static char * opt_drizzle_unix_port=0;
 static int64_t opt_ignore_lines= -1;
-static CHARSET_INFO *charset_info= &my_charset_latin1;
+static const CHARSET_INFO *charset_info= &my_charset_latin1;
 
 static struct my_option my_long_options[] =
 {

=== modified file 'client/drizzletest.cc'
--- client/drizzletest.cc	2008-08-05 02:31:51 +0000
+++ client/drizzletest.cc	2008-08-06 00:04:45 +0000
@@ -121,7 +121,7 @@
 static struct st_test_file* file_stack_end;
 
 
-static CHARSET_INFO *charset_info= &my_charset_latin1; /* Default charset */
+static const CHARSET_INFO *charset_info= &my_charset_latin1; /* Default charset */
 
 static int embedded_server_arg_count=0;
 static char *embedded_server_args[MAX_EMBEDDED_SERVER_ARGS];

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2008-08-05 02:31:51 +0000
+++ drizzled/drizzled.cc	2008-08-06 00:04:45 +0000
@@ -417,9 +417,9 @@
 MY_TMPDIR mysql_tmpdir_list;
 MY_BITMAP temp_pool;
 
-CHARSET_INFO *system_charset_info, *files_charset_info ;
-CHARSET_INFO *national_charset_info, *table_alias_charset;
-CHARSET_INFO *character_set_filesystem;
+const CHARSET_INFO *system_charset_info, *files_charset_info ;
+const CHARSET_INFO *national_charset_info, *table_alias_charset;
+const CHARSET_INFO *character_set_filesystem;
 
 MY_LOCALE *my_default_lc_time_names;
 
@@ -2139,8 +2139,8 @@
 
   if (default_collation_name)
   {
-    CHARSET_INFO *default_collation;
-    default_collation= get_charset_by_name(default_collation_name, MYF(0));
+    const CHARSET_INFO * const default_collation=
+	   get_charset_by_name(default_collation_name, MYF(0));
     if (!default_collation)
     {
       sql_print_error(ER(ER_UNKNOWN_COLLATION), default_collation_name);

=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field.cc	2008-08-06 00:04:45 +0000
@@ -554,7 +554,8 @@
 */
 
 static bool
-test_if_important_data(CHARSET_INFO *cs, const char *str, const char *strend)
+test_if_important_data(const CHARSET_INFO * const cs, const char *str,
+                       const char *strend)
 {
   if (cs != &my_charset_bin)
     str+= cs->cset->scan(cs, str, strend, MY_SEQ_SPACES);
@@ -647,7 +648,7 @@
     2   error: garbage at the end of string.
 */
 
-int Field_num::check_int(CHARSET_INFO *cs, const char *str, int length, 
+int Field_num::check_int(const CHARSET_INFO * const cs, const char *str, int length, 
                          const char *int_end, int error)
 {
   /* Test if we get an empty string or wrong integer */
@@ -696,7 +697,7 @@
     1   error
 */
 
-bool Field_num::get_int(CHARSET_INFO *cs, const char *from, uint len,
+bool Field_num::get_int(const CHARSET_INFO * const cs, const char *from, uint len,
                         int64_t *rnd, uint64_t unsigned_max, 
                         int64_t signed_min, int64_t signed_max)
 {
@@ -767,7 +768,7 @@
 
 
 #ifdef NOT_USED
-static bool test_if_real(const char *str,int length, CHARSET_INFO *cs)
+static bool test_if_real(const char *str,int length, const CHARSET_INFO * const cs)
 {
   cs= system_charset_info; // QQ move test_if_real into CHARSET_INFO struct
 
@@ -829,7 +830,7 @@
 
 String *Field::val_int_as_str(String *val_buffer, my_bool unsigned_val)
 {
-  CHARSET_INFO *cs= &my_charset_bin;
+  const CHARSET_INFO * const cs= &my_charset_bin;
   uint length;
   int64_t value= val_int();
 
@@ -872,7 +873,7 @@
   else
   {
     uint len= pack_length();
-    CHARSET_INFO *cs= charset();
+    const CHARSET_INFO * const cs= charset();
     cs->coll->hash_sort(cs, ptr, len, nr, nr2);
   }
 }
@@ -927,7 +928,7 @@
 }
 
 
-int Field::store(const char *to, uint length, CHARSET_INFO *cs,
+int Field::store(const char *to, uint length, const CHARSET_INFO * const cs,
                  enum_check_fields check_level)
 {
   int res;
@@ -1180,7 +1181,7 @@
 
 Field_str::Field_str(uchar *ptr_arg,uint32_t len_arg, uchar *null_ptr_arg,
                      uchar null_bit_arg, utype unireg_check_arg,
-                     const char *field_name_arg, CHARSET_INFO *charset_arg)
+                     const char *field_name_arg, const CHARSET_INFO * const charset_arg)
   :Field(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
          unireg_check_arg, field_name_arg)
 {
@@ -1354,7 +1355,7 @@
 ** tiny int
 ****************************************************************************/
 
-int Field_tiny::store(const char *from,uint len,CHARSET_INFO *cs)
+int Field_tiny::store(const char *from,uint len, const CHARSET_INFO * const cs)
 {
   int error;
   int64_t rnd;
@@ -1470,7 +1471,7 @@
 String *Field_tiny::val_str(String *val_buffer,
 			    String *val_ptr __attribute__((unused)))
 {
-  CHARSET_INFO *cs= &my_charset_bin;
+  const CHARSET_INFO * const cs= &my_charset_bin;
   uint length;
   uint mlength=max(field_length+1,5*cs->mbmaxlen);
   val_buffer->alloc(mlength);
@@ -1512,7 +1513,7 @@
 
 void Field_tiny::sql_type(String &res) const
 {
-  CHARSET_INFO *cs=res.charset();
+  const CHARSET_INFO * const cs=res.charset();
   res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(),
 			  "tinyint(%d)",(int) field_length));
   add_unsigned(res);
@@ -1550,7 +1551,7 @@
                         const char *well_formed_error_pos,
                         const char *cannot_convert_error_pos,
                         const char *end,
-                        CHARSET_INFO *cs)
+                        const CHARSET_INFO * const cs)
 {
   const char *pos, *end_orig;
   char tmp[64], *t;
@@ -1774,7 +1775,7 @@
     (if there isn't a empty value in the enum)
 */
 
-int Field_enum::store(const char *from,uint length,CHARSET_INFO *cs)
+int Field_enum::store(const char *from, uint length, const CHARSET_INFO * const cs)
 {
   int err= 0;
   uint32_t not_used;
@@ -2130,7 +2131,7 @@
                         uint fld_type_modifier, Item *fld_default_value,
                         Item *fld_on_update_value, LEX_STRING *fld_comment,
                         char *fld_change, List<String> *fld_interval_list,
-                        CHARSET_INFO *fld_charset,
+                        const CHARSET_INFO * const fld_charset,
                         uint fld_geom_type __attribute__((unused)),
                         enum column_format_type column_format)
 {
@@ -2446,7 +2447,7 @@
 		  uchar *null_pos, uchar null_bit,
 		  uint pack_flag,
 		  enum_field_types field_type,
-		  CHARSET_INFO *field_charset,
+		  const CHARSET_INFO * field_charset,
 		  Field::utype unireg_check,
 		  TYPELIB *interval,
 		  const char *field_name)

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2008-08-04 23:58:04 +0000
+++ drizzled/field.h	2008-08-06 00:04:45 +0000
@@ -103,12 +103,12 @@
         const char *field_name_arg);
   virtual ~Field() {}
   /* Store functions returns 1 on overflow and -1 on fatal error */
-  virtual int  store(const char *to, uint length,CHARSET_INFO *cs)=0;
+  virtual int  store(const char *to, uint length, const CHARSET_INFO * const cs)=0;
   virtual int  store(double nr)=0;
   virtual int  store(int64_t nr, bool unsigned_val)=0;
   virtual int  store_decimal(const my_decimal *d)=0;
   virtual int store_time(DRIZZLE_TIME *ltime, timestamp_type t_type);
-  int store(const char *to, uint length, CHARSET_INFO *cs,
+  int store(const char *to, uint length, const CHARSET_INFO * const cs,
             enum_check_fields check_level);
   virtual double val_real(void)=0;
   virtual int64_t val_int(void)=0;
@@ -319,10 +319,10 @@
       null_ptr=ADD_TO_PTR(null_ptr,ptr_diff,uchar*);
   }
   virtual void get_image(uchar *buff, uint length,
-                         CHARSET_INFO *cs __attribute__((unused)))
+                         const CHARSET_INFO * const cs __attribute__((unused)))
     { memcpy(buff,ptr,length); }
   virtual void set_image(const uchar *buff,uint length,
-                         CHARSET_INFO *cs __attribute__((unused)))
+                         const CHARSET_INFO * const cs __attribute__((unused)))
     { memcpy(ptr,buff,length); }
 
 
@@ -445,10 +445,10 @@
   uint fill_cache_field(struct st_cache_field *copy);
   virtual bool get_date(DRIZZLE_TIME *ltime,uint fuzzydate);
   virtual bool get_time(DRIZZLE_TIME *ltime);
-  virtual CHARSET_INFO *charset(void) const { return &my_charset_bin; }
-  virtual CHARSET_INFO *sort_charset(void) const { return charset(); }
+  virtual const CHARSET_INFO *charset(void) const { return &my_charset_bin; }
+  virtual const CHARSET_INFO *sort_charset(void) const { return charset(); }
   virtual bool has_charset(void) const { return false; }
-  virtual void set_charset(CHARSET_INFO *charset_arg __attribute__((unused)))
+  virtual void set_charset(const CHARSET_INFO * const charset_arg __attribute__((unused)))
   { }
   virtual enum Derivation derivation(void) const
   { return DERIVATION_IMPLICIT; }
@@ -560,9 +560,9 @@
   int store_decimal(const my_decimal *);
   my_decimal *val_decimal(my_decimal *);
   uint is_equal(Create_field *new_field);
-  int check_int(CHARSET_INFO *cs, const char *str, int length,
+  int check_int(const CHARSET_INFO * const cs, const char *str, int length,
                 const char *int_end, int error);
-  bool get_int(CHARSET_INFO *cs, const char *from, uint len, 
+  bool get_int(const CHARSET_INFO * const cs, const char *from, uint len, 
                int64_t *rnd, uint64_t unsigned_max, 
                int64_t signed_min, int64_t signed_max);
 };
@@ -571,21 +571,21 @@
 
 class Field_str :public Field {
 protected:
-  CHARSET_INFO *field_charset;
+  const CHARSET_INFO *field_charset;
   enum Derivation field_derivation;
 public:
   Field_str(uchar *ptr_arg,uint32_t len_arg, uchar *null_ptr_arg,
 	    uchar null_bit_arg, utype unireg_check_arg,
-	    const char *field_name_arg, CHARSET_INFO *charset);
+	    const char *field_name_arg, const CHARSET_INFO * const charset);
   Item_result result_type () const { return STRING_RESULT; }
   uint decimals() const { return NOT_FIXED_DEC; }
   int  store(double nr);
   int  store(int64_t nr, bool unsigned_val)=0;
   int  store_decimal(const my_decimal *);
-  int  store(const char *to,uint length,CHARSET_INFO *cs)=0;
+  int  store(const char *to,uint length, const CHARSET_INFO * const cs)=0;
   uint size_of() const { return sizeof(*this); }
-  CHARSET_INFO *charset(void) const { return field_charset; }
-  void set_charset(CHARSET_INFO *charset_arg) { field_charset= charset_arg; }
+  const CHARSET_INFO *charset(void) const { return field_charset; }
+  void set_charset(const CHARSET_INFO * const charset_arg) { field_charset= charset_arg; }
   enum Derivation derivation(void) const { return field_derivation; }
   virtual void set_derivation(enum Derivation derivation_arg)
   { field_derivation= derivation_arg; }
@@ -608,7 +608,7 @@
 public:
   Field_longstr(uchar *ptr_arg, uint32_t len_arg, uchar *null_ptr_arg,
                 uchar null_bit_arg, utype unireg_check_arg,
-                const char *field_name_arg, CHARSET_INFO *charset_arg)
+                const char *field_name_arg, const CHARSET_INFO * const charset_arg)
     :Field_str(ptr_arg, len_arg, null_ptr_arg, null_bit_arg, unireg_check_arg,
                field_name_arg, charset_arg)
     {}
@@ -656,7 +656,7 @@
   enum_field_types type() const { return DRIZZLE_TYPE_TINY;}
   enum ha_base_keytype key_type() const
     { return unsigned_flag ? HA_KEYTYPE_BINARY : HA_KEYTYPE_INT8; }
-  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(const char *to,uint length, const CHARSET_INFO * const charset);
   int store(double nr);
   int store(int64_t nr, bool unsigned_val);
   int reset(void) { ptr[0]=0; return 0; }
@@ -698,7 +698,7 @@
              enum utype unireg_check_arg, const char *field_name_arg,
              uint packlength_arg,
              TYPELIB *typelib_arg,
-             CHARSET_INFO *charset_arg)
+             const CHARSET_INFO * const charset_arg)
     :Field_str(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
 	       unireg_check_arg, field_name_arg, charset_arg),
     packlength(packlength_arg),typelib(typelib_arg)
@@ -710,7 +710,7 @@
   enum Item_result cmp_type () const { return INT_RESULT; }
   enum Item_result cast_to_int_type () const { return INT_RESULT; }
   enum ha_base_keytype key_type() const;
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(const char *to,uint length, const CHARSET_INFO * const charset);
   int  store(double nr);
   int  store(int64_t nr, bool unsigned_val);
   double val_real(void);
@@ -733,7 +733,7 @@
   bool eq_def(Field *field);
   bool has_charset(void) const { return true; }
   /* enum and set are sorted as integers */
-  CHARSET_INFO *sort_charset(void) const { return &my_charset_bin; }
+  const CHARSET_INFO *sort_charset(void) const { return &my_charset_bin; }
 private:
   int do_save_field_metadata(uchar *first_byte);
 };
@@ -767,7 +767,7 @@
   TYPELIB *save_interval;               // Temporary copy for the above
                                         // Used only for UCS2 intervals
   List<String> interval_list;
-  CHARSET_INFO *charset;
+  const CHARSET_INFO *charset;
   Field *field;				// For alter table
 
   uint8_t row,col,sc_length,interval_id;	// For rea_create_table
@@ -793,7 +793,7 @@
   bool init(THD *thd, char *field_name, enum_field_types type, char *length,
             char *decimals, uint type_modifier, Item *default_value,
             Item *on_update_value, LEX_STRING *comment, char *change,
-            List<String> *interval_list, CHARSET_INFO *cs,
+            List<String> *interval_list, const CHARSET_INFO * const cs,
             uint uint_geom_type,
             enum column_format_type column_format);
 };
@@ -847,7 +847,7 @@
 Field *make_field(TABLE_SHARE *share, uchar *ptr, uint32_t field_length,
 		  uchar *null_pos, uchar null_bit,
 		  uint pack_flag, enum_field_types field_type,
-		  CHARSET_INFO *cs,
+		  const CHARSET_INFO * cs,
 		  Field::utype unireg_check,
 		  TYPELIB *interval, const char *field_name);
 uint pack_length_to_packflag(uint type);
@@ -861,7 +861,7 @@
                         const char *well_formed_error_pos,
                         const char *cannot_convert_error_pos,
                         const char *end,
-                        CHARSET_INFO *cs);
+                        const CHARSET_INFO * const cs);
 
 /*
   Field subclasses

=== modified file 'drizzled/field/blob.cc'
--- drizzled/field/blob.cc	2008-08-01 08:25:32 +0000
+++ drizzled/field/blob.cc	2008-08-06 00:04:45 +0000
@@ -36,7 +36,7 @@
 Field_blob::Field_blob(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
 		       enum utype unireg_check_arg, const char *field_name_arg,
                        TABLE_SHARE *share, uint blob_pack_length,
-		       CHARSET_INFO *cs)
+		       const CHARSET_INFO * const cs)
   :Field_longstr(ptr_arg, BLOB_PACK_LENGTH_TO_MAX_LENGH(blob_pack_length),
                  null_ptr_arg, null_bit_arg, unireg_check_arg, field_name_arg,
                  cs),
@@ -149,7 +149,7 @@
 }
 
 
-int Field_blob::store(const char *from,uint length,CHARSET_INFO *cs)
+int Field_blob::store(const char *from,uint length, const CHARSET_INFO * const cs)
 {
   uint copy_length, new_length;
   const char *well_formed_error_pos;
@@ -225,7 +225,7 @@
 
 int Field_blob::store(double nr)
 {
-  CHARSET_INFO *cs=charset();
+  const CHARSET_INFO * const cs=charset();
   value.set_real(nr, NOT_FIXED_DEC, cs);
   return Field_blob::store(value.ptr(),(uint) value.length(), cs);
 }
@@ -233,7 +233,7 @@
 
 int Field_blob::store(int64_t nr, bool unsigned_val)
 {
-  CHARSET_INFO *cs=charset();
+  const CHARSET_INFO * const cs=charset();
   value.set_int(nr, unsigned_val, cs);
   return Field_blob::store(value.ptr(), (uint) value.length(), cs);
 }
@@ -244,7 +244,7 @@
   int not_used;
   char *end_not_used, *blob;
   uint32_t length;
-  CHARSET_INFO *cs;
+  const CHARSET_INFO *cs;
 
   memcpy(&blob,ptr+packlength,sizeof(char*));
   if (!blob)
@@ -382,7 +382,7 @@
   uchar *blob1;
   uint blob_length=get_length(ptr);
   memcpy(&blob1,ptr+packlength,sizeof(char*));
-  CHARSET_INFO *cs= charset();
+  const CHARSET_INFO * const cs= charset();
   uint local_char_length= max_key_length / cs->mbmaxlen;
   local_char_length= my_charpos(cs, blob1, blob1+blob_length,
                                 local_char_length);

=== modified file 'drizzled/field/blob.h'
--- drizzled/field/blob.h	2008-08-05 02:31:51 +0000
+++ drizzled/field/blob.h	2008-08-06 00:04:45 +0000
@@ -30,9 +30,9 @@
 public:
   Field_blob(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
 	     enum utype unireg_check_arg, const char *field_name_arg,
-	     TABLE_SHARE *share, uint blob_pack_length, CHARSET_INFO *cs);
+	     TABLE_SHARE *share, uint blob_pack_length, const CHARSET_INFO * const cs);
   Field_blob(uint32_t len_arg,bool maybe_null_arg, const char *field_name_arg,
-             CHARSET_INFO *cs)
+             const CHARSET_INFO * const cs)
     :Field_longstr((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
                    NONE, field_name_arg, cs),
     packlength(4)
@@ -40,7 +40,7 @@
     flags|= BLOB_FLAG;
   }
   Field_blob(uint32_t len_arg,bool maybe_null_arg, const char *field_name_arg,
-	     CHARSET_INFO *cs, bool set_packlength)
+	     const CHARSET_INFO * const cs, bool set_packlength)
     :Field_longstr((uchar*) 0,len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
                    NONE, field_name_arg, cs)
   {
@@ -60,7 +60,7 @@
   enum_field_types type() const { return DRIZZLE_TYPE_BLOB;}
   enum ha_base_keytype key_type() const
     { return binary() ? HA_KEYTYPE_VARBINARY2 : HA_KEYTYPE_VARTEXT2; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(const char *to,uint length, const CHARSET_INFO * const charset);
   int  store(double nr);
   int  store(int64_t nr, bool unsigned_val);
   double val_real(void);

=== modified file 'drizzled/field/date.cc'
--- drizzled/field/date.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field/date.cc	2008-08-06 00:04:45 +0000
@@ -51,7 +51,7 @@
 
 int Field_newdate::store(const char *from,
                          uint len,
-                         CHARSET_INFO *cs __attribute__((unused)))
+                         const CHARSET_INFO * const cs __attribute__((unused)))
 {
   long tmp;
   DRIZZLE_TIME l_time;

=== modified file 'drizzled/field/date.h'
--- drizzled/field/date.h	2008-07-31 18:25:59 +0000
+++ drizzled/field/date.h	2008-08-06 00:04:45 +0000
@@ -27,19 +27,19 @@
 public:
   Field_newdate(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
 		enum utype unireg_check_arg, const char *field_name_arg,
-		CHARSET_INFO *cs)
+		const CHARSET_INFO * const cs)
     :Field_str(ptr_arg, 10, null_ptr_arg, null_bit_arg,
 	       unireg_check_arg, field_name_arg, cs)
     {}
   Field_newdate(bool maybe_null_arg, const char *field_name_arg,
-                CHARSET_INFO *cs)
+                const CHARSET_INFO * const cs)
     :Field_str((uchar*) 0,10, maybe_null_arg ? (uchar*) "": 0,0,
                NONE, field_name_arg, cs) {}
   enum_field_types type() const { return DRIZZLE_TYPE_NEWDATE;}
   enum_field_types real_type() const { return DRIZZLE_TYPE_NEWDATE; }
   enum ha_base_keytype key_type() const { return HA_KEYTYPE_UINT24; }
   enum Item_result cmp_type () const { return INT_RESULT; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(const char *to,uint length, const CHARSET_INFO * const charset);
   int  store(double nr);
   int  store(int64_t nr, bool unsigned_val);
   int store_time(DRIZZLE_TIME *ltime, timestamp_type type);

=== modified file 'drizzled/field/datetime.cc'
--- drizzled/field/datetime.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field/datetime.cc	2008-08-06 00:04:45 +0000
@@ -33,7 +33,7 @@
 
 int Field_datetime::store(const char *from,
                           uint len,
-                          CHARSET_INFO *cs __attribute__((unused)))
+                          const CHARSET_INFO * const cs __attribute__((unused)))
 {
   DRIZZLE_TIME time_tmp;
   int error;

=== modified file 'drizzled/field/datetime.h'
--- drizzled/field/datetime.h	2008-07-31 18:25:59 +0000
+++ drizzled/field/datetime.h	2008-08-06 00:04:45 +0000
@@ -27,19 +27,19 @@
 public:
   Field_datetime(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
 		 enum utype unireg_check_arg, const char *field_name_arg,
-		 CHARSET_INFO *cs)
+		 const CHARSET_INFO * const cs)
     :Field_str(ptr_arg, 19, null_ptr_arg, null_bit_arg,
 	       unireg_check_arg, field_name_arg, cs)
     {}
   Field_datetime(bool maybe_null_arg, const char *field_name_arg,
-		 CHARSET_INFO *cs)
+		 const CHARSET_INFO * const cs)
     :Field_str((uchar*) 0,19, maybe_null_arg ? (uchar*) "": 0,0,
 	       NONE, field_name_arg, cs) {}
   enum_field_types type() const { return DRIZZLE_TYPE_DATETIME;}
   enum ha_base_keytype key_type() const { return HA_KEYTYPE_ULONGLONG; }
   enum Item_result cmp_type () const { return INT_RESULT; }
   uint decimals() const { return DATETIME_DEC; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(const char *to,uint length, const CHARSET_INFO * const charset);
   int  store(double nr);
   int  store(int64_t nr, bool unsigned_val);
   int store_time(DRIZZLE_TIME *ltime, timestamp_type type);

=== modified file 'drizzled/field/double.cc'
--- drizzled/field/double.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field/double.cc	2008-08-06 00:04:45 +0000
@@ -29,7 +29,7 @@
   double precision floating point numbers
 ****************************************************************************/
 
-int Field_double::store(const char *from,uint len,CHARSET_INFO *cs)
+int Field_double::store(const char *from,uint len, const CHARSET_INFO * const cs)
 {
   int error;
   char *end;
@@ -287,7 +287,7 @@
 
 void Field_double::sql_type(String &res) const
 {
-  CHARSET_INFO *cs=res.charset();
+  const CHARSET_INFO * const cs=res.charset();
   if (dec == NOT_FIXED_DEC)
   {
     res.set_ascii(STRING_WITH_LEN("double"));

=== modified file 'drizzled/field/double.h'
--- drizzled/field/double.h	2008-07-30 19:17:49 +0000
+++ drizzled/field/double.h	2008-08-06 00:04:45 +0000
@@ -45,7 +45,7 @@
     {not_fixed= not_fixed_arg; }
   enum_field_types type() const { return DRIZZLE_TYPE_DOUBLE;}
   enum ha_base_keytype key_type() const { return HA_KEYTYPE_DOUBLE; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(const char *to,uint length, const CHARSET_INFO * const charset);
   int  store(double nr);
   int  store(int64_t nr, bool unsigned_val);
   int reset(void) { memset(ptr, 0, sizeof(double)); return 0; }

=== modified file 'drizzled/field/fdecimal.cc'
--- drizzled/field/fdecimal.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field/fdecimal.cc	2008-08-06 00:04:45 +0000
@@ -134,7 +134,7 @@
 
 
 int Field_new_decimal::store(const char *from, uint length,
-                             CHARSET_INFO *charset_arg)
+                             const CHARSET_INFO * const charset_arg)
 {
   int err;
   my_decimal decimal_value;
@@ -304,7 +304,7 @@
 
 void Field_new_decimal::sql_type(String &str) const
 {
-  CHARSET_INFO *cs= str.charset();
+  const CHARSET_INFO * const cs= str.charset();
   str.length(cs->cset->snprintf(cs, (char*) str.ptr(), str.alloced_length(),
                                 "decimal(%d,%d)", precision, (int)dec));
   add_unsigned(str);

=== modified file 'drizzled/field/fdecimal.h'
--- drizzled/field/fdecimal.h	2008-07-31 18:25:59 +0000
+++ drizzled/field/fdecimal.h	2008-08-06 00:04:45 +0000
@@ -50,7 +50,7 @@
   int  reset(void);
   bool store_value(const my_decimal *decimal_value);
   void set_value_on_overflow(my_decimal *decimal_value, bool sign);
-  int  store(const char *to, uint length, CHARSET_INFO *charset);
+  int  store(const char *to, uint length, const CHARSET_INFO * const charset);
   int  store(double nr);
   int  store(int64_t nr, bool unsigned_val);
   int store_time(DRIZZLE_TIME *ltime, timestamp_type t_type);

=== modified file 'drizzled/field/fstring.cc'
--- drizzled/field/fstring.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field/fstring.cc	2008-08-06 00:04:45 +0000
@@ -34,7 +34,7 @@
 ****************************************************************************/
 
 /* Copy a string and fill with space */
-int Field_string::store(const char *from,uint length,CHARSET_INFO *cs)
+int Field_string::store(const char *from,uint length, const CHARSET_INFO * const cs)
 {
   uint copy_length;
   const char *well_formed_error_pos;
@@ -70,7 +70,7 @@
 {
   char buff[64];
   int  l;
-  CHARSET_INFO *cs=charset();
+  const CHARSET_INFO * const cs= charset();
   l= (cs->cset->int64_t10_to_str)(cs,buff,sizeof(buff),
                                    unsigned_val ? 10 : -10, nr);
   return Field_string::store(buff,(uint)l,cs);
@@ -81,7 +81,7 @@
 {
   int error;
   char *end;
-  CHARSET_INFO *cs= charset();
+  const CHARSET_INFO * const cs= charset();
   double result;
   
   result=  my_strntod(cs,(char*) ptr,field_length,&end,&error);
@@ -106,7 +106,7 @@
 {
   int error;
   char *end;
-  CHARSET_INFO *cs= charset();
+  const CHARSET_INFO * const cs= charset();
   int64_t result;
 
   result= my_strntoll(cs, (char*) ptr,field_length,10,&end,&error);
@@ -151,7 +151,7 @@
   if (!table->in_use->no_errors && err)
   {
     char buf[DECIMAL_TO_STRING_CONVERSION_BUFFER_SIZE];
-    CHARSET_INFO *cs= charset();
+    const CHARSET_INFO * const cs= charset();
     String tmp(buf, sizeof(buf), cs);
     tmp.copy((char*) ptr, field_length, cs);
     push_warning_printf(current_thd, DRIZZLE_ERROR::WARN_LEVEL_WARN,
@@ -199,7 +199,7 @@
 void Field_string::sql_type(String &res) const
 {
   THD *thd= table->in_use;
-  CHARSET_INFO *cs=res.charset();
+  const CHARSET_INFO * const cs= res.charset();
   ulong length;
 
   length= cs->cset->snprintf(cs,(char*) res.ptr(),

=== modified file 'drizzled/field/fstring.h'
--- drizzled/field/fstring.h	2008-07-31 19:57:34 +0000
+++ drizzled/field/fstring.h	2008-08-06 00:04:45 +0000
@@ -29,12 +29,12 @@
   Field_string(uchar *ptr_arg, uint32_t len_arg,uchar *null_ptr_arg,
 	       uchar null_bit_arg,
 	       enum utype unireg_check_arg, const char *field_name_arg,
-	       CHARSET_INFO *cs)
+	       const CHARSET_INFO * const cs)
     :Field_longstr(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
                    unireg_check_arg, field_name_arg, cs),
      can_alter_field_type(1) {};
   Field_string(uint32_t len_arg,bool maybe_null_arg, const char *field_name_arg,
-               CHARSET_INFO *cs)
+               const CHARSET_INFO * const cs)
     :Field_longstr((uchar*) 0, len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
                    NONE, field_name_arg, cs),
      can_alter_field_type(1) {};
@@ -52,7 +52,7 @@
                           (has_charset() ? ' ' : 0));
     return 0;
   }
-  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(const char *to,uint length, const CHARSET_INFO * const charset);
   int store(int64_t nr, bool unsigned_val);
   int store(double nr) { return Field_str::store(nr); } /* QQ: To be deleted */
   double val_real(void);

=== modified file 'drizzled/field/int64_t.cc'
--- drizzled/field/int64_t.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field/int64_t.cc	2008-08-06 00:04:45 +0000
@@ -28,7 +28,7 @@
  Field type int64_t int (8 bytes)
 ****************************************************************************/
 
-int Field_int64_t::store(const char *from,uint len,CHARSET_INFO *cs)
+int Field_int64_t::store(const char *from,uint len, const CHARSET_INFO * const cs)
 {
   int error= 0;
   char *end;
@@ -175,7 +175,7 @@
 String *Field_int64_t::val_str(String *val_buffer,
 				String *val_ptr __attribute__((unused)))
 {
-  CHARSET_INFO *cs= &my_charset_bin;
+  const CHARSET_INFO * const cs= &my_charset_bin;
   uint length;
   uint mlength=max(field_length+1,22*cs->mbmaxlen);
   val_buffer->alloc(mlength);
@@ -260,7 +260,7 @@
 
 void Field_int64_t::sql_type(String &res) const
 {
-  CHARSET_INFO *cs=res.charset();
+  const CHARSET_INFO * const cs=res.charset();
   res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(), "bigint"));
   add_unsigned(res);
 }

=== modified file 'drizzled/field/int64_t.h'
--- drizzled/field/int64_t.h	2008-07-30 19:17:49 +0000
+++ drizzled/field/int64_t.h	2008-08-06 00:04:45 +0000
@@ -43,7 +43,7 @@
   enum_field_types type() const { return DRIZZLE_TYPE_LONGLONG;}
   enum ha_base_keytype key_type() const
     { return unsigned_flag ? HA_KEYTYPE_ULONGLONG : HA_KEYTYPE_LONGLONG; }
-  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(const char *to,uint length, const CHARSET_INFO * const charset);
   int store(double nr);
   int store(int64_t nr, bool unsigned_val);
   int reset(void)

=== modified file 'drizzled/field/long.cc'
--- drizzled/field/long.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field/long.cc	2008-08-06 00:04:45 +0000
@@ -28,7 +28,7 @@
 ** long int
 ****************************************************************************/
 
-int Field_long::store(const char *from,uint len,CHARSET_INFO *cs)
+int Field_long::store(const char *from,uint len, const CHARSET_INFO * const cs)
 {
   long store_tmp;
   int error;
@@ -180,7 +180,7 @@
 String *Field_long::val_str(String *val_buffer,
 			    String *val_ptr __attribute__((unused)))
 {
-  CHARSET_INFO *cs= &my_charset_bin;
+  const CHARSET_INFO * const cs= &my_charset_bin;
   uint length;
   uint mlength=max(field_length+1,12*cs->mbmaxlen);
   val_buffer->alloc(mlength);
@@ -257,7 +257,7 @@
 
 void Field_long::sql_type(String &res) const
 {
-  CHARSET_INFO *cs=res.charset();
+  const CHARSET_INFO * const cs=res.charset();
   res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(), "int"));
   add_unsigned(res);
 }

=== modified file 'drizzled/field/long.h'
--- drizzled/field/long.h	2008-07-30 19:17:49 +0000
+++ drizzled/field/long.h	2008-08-06 00:04:45 +0000
@@ -42,7 +42,7 @@
   enum_field_types type() const { return DRIZZLE_TYPE_LONG;}
   enum ha_base_keytype key_type() const
     { return unsigned_flag ? HA_KEYTYPE_ULONG_INT : HA_KEYTYPE_LONG_INT; }
-  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(const char *to,uint length, const CHARSET_INFO * const charset);
   int store(double nr);
   int store(int64_t nr, bool unsigned_val);
   int reset(void) { ptr[0]=ptr[1]=ptr[2]=ptr[3]=0; return 0; }

=== modified file 'drizzled/field/null.h'
--- drizzled/field/null.h	2008-07-30 19:17:49 +0000
+++ drizzled/field/null.h	2008-08-06 00:04:45 +0000
@@ -32,14 +32,14 @@
 public:
   Field_null(uchar *ptr_arg, uint32_t len_arg,
 	     enum utype unireg_check_arg, const char *field_name_arg,
-	     CHARSET_INFO *cs)
+	     const CHARSET_INFO * const cs)
     :Field_str(ptr_arg, len_arg, null, 1,
 	       unireg_check_arg, field_name_arg, cs)
     {}
   enum_field_types type() const { return DRIZZLE_TYPE_NULL;}
   int  store(const char *to __attribute__((unused)),
              uint length __attribute__((unused)),
-             CHARSET_INFO *cs __attribute__((unused)))
+             const CHARSET_INFO * const cs __attribute__((unused)))
   { null[0]=1; return 0; }
   int store(double nr __attribute__((unused)))
   { null[0]=1; return 0; }

=== modified file 'drizzled/field/set.cc'
--- drizzled/field/set.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field/set.cc	2008-08-06 00:04:45 +0000
@@ -35,7 +35,7 @@
 
 const char field_separator=',';
 
-int Field_set::store(const char *from,uint length,CHARSET_INFO *cs)
+int Field_set::store(const char *from,uint length, const CHARSET_INFO * const cs)
 {
   bool got_warning= 0;
   int err= 0;

=== modified file 'drizzled/field/set.h'
--- drizzled/field/set.h	2008-07-30 19:17:49 +0000
+++ drizzled/field/set.h	2008-08-06 00:04:45 +0000
@@ -29,7 +29,7 @@
 	    uchar null_bit_arg,
 	    enum utype unireg_check_arg, const char *field_name_arg,
 	    uint32_t packlength_arg,
-	    TYPELIB *typelib_arg, CHARSET_INFO *charset_arg)
+	    TYPELIB *typelib_arg, const CHARSET_INFO * const charset_arg)
     :Field_enum(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
 		    unireg_check_arg, field_name_arg,
                 packlength_arg,
@@ -37,7 +37,7 @@
     {
       flags=(flags & ~ENUM_FLAG) | SET_FLAG;
     }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(const char *to,uint length, const CHARSET_INFO * const charset);
   int  store(double nr) { return Field_set::store((int64_t) nr, false); }
   int  store(int64_t nr, bool unsigned_val);
 

=== modified file 'drizzled/field/short.cc'
--- drizzled/field/short.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field/short.cc	2008-08-06 00:04:45 +0000
@@ -28,7 +28,7 @@
  Field type short int (2 byte)
 ****************************************************************************/
 
-int Field_short::store(const char *from,uint len,CHARSET_INFO *cs)
+int Field_short::store(const char *from,uint len, const CHARSET_INFO * const cs)
 {
   int store_tmp;
   int error;
@@ -181,7 +181,7 @@
 String *Field_short::val_str(String *val_buffer,
 			     String *val_ptr __attribute__((unused)))
 {
-  CHARSET_INFO *cs= &my_charset_bin;
+  const CHARSET_INFO * const cs= &my_charset_bin;
   uint length;
   uint mlength=max(field_length+1,7*cs->mbmaxlen);
   val_buffer->alloc(mlength);
@@ -257,7 +257,7 @@
 
 void Field_short::sql_type(String &res) const
 {
-  CHARSET_INFO *cs=res.charset();
+  const CHARSET_INFO * const cs= res.charset();
   res.length(cs->cset->snprintf(cs,(char*) res.ptr(),res.alloced_length(), "smallint"));
   add_unsigned(res);
 }

=== modified file 'drizzled/field/short.h'
--- drizzled/field/short.h	2008-07-30 19:17:49 +0000
+++ drizzled/field/short.h	2008-08-06 00:04:45 +0000
@@ -42,7 +42,7 @@
   enum_field_types type() const { return DRIZZLE_TYPE_SHORT;}
   enum ha_base_keytype key_type() const
     { return unsigned_flag ? HA_KEYTYPE_USHORT_INT : HA_KEYTYPE_SHORT_INT;}
-  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(const char *to,uint length, const CHARSET_INFO * const charset);
   int store(double nr);
   int store(int64_t nr, bool unsigned_val);
   int reset(void) { ptr[0]=ptr[1]=0; return 0; }

=== modified file 'drizzled/field/timestamp.cc'
--- drizzled/field/timestamp.cc	2008-08-05 02:31:51 +0000
+++ drizzled/field/timestamp.cc	2008-08-06 00:04:45 +0000
@@ -74,7 +74,7 @@
                                  enum utype unireg_check_arg,
                                  const char *field_name_arg,
                                  TABLE_SHARE *share,
-                                 CHARSET_INFO *cs)
+                                 const CHARSET_INFO * const cs)
   :Field_str(ptr_arg, MAX_DATETIME_WIDTH, null_ptr_arg, null_bit_arg,
 	     unireg_check_arg, field_name_arg, cs)
 {
@@ -93,7 +93,7 @@
 
 Field_timestamp::Field_timestamp(bool maybe_null_arg,
                                  const char *field_name_arg,
-                                 CHARSET_INFO *cs)
+                                 const CHARSET_INFO * const cs)
   :Field_str((uchar*) 0, MAX_DATETIME_WIDTH,
              maybe_null_arg ? (uchar*) "": 0, 0,
 	     NONE, field_name_arg, cs)
@@ -142,7 +142,7 @@
 
 int Field_timestamp::store(const char *from,
                            uint len,
-                           CHARSET_INFO *cs __attribute__((unused)))
+                           const CHARSET_INFO * const cs __attribute__((unused)))
 {
   DRIZZLE_TIME l_time;
   my_time_t tmp= 0;

=== modified file 'drizzled/field/timestamp.h'
--- drizzled/field/timestamp.h	2008-07-31 18:25:59 +0000
+++ drizzled/field/timestamp.h	2008-08-06 00:04:45 +0000
@@ -28,13 +28,13 @@
   Field_timestamp(uchar *ptr_arg, uint32_t len_arg,
                   uchar *null_ptr_arg, uchar null_bit_arg,
 		  enum utype unireg_check_arg, const char *field_name_arg,
-		  TABLE_SHARE *share, CHARSET_INFO *cs);
+		  TABLE_SHARE *share, const CHARSET_INFO * const cs);
   Field_timestamp(bool maybe_null_arg, const char *field_name_arg,
-		  CHARSET_INFO *cs);
+		  const CHARSET_INFO * const cs);
   enum_field_types type() const { return DRIZZLE_TYPE_TIMESTAMP;}
   enum ha_base_keytype key_type() const { return HA_KEYTYPE_ULONG_INT; }
   enum Item_result cmp_type () const { return INT_RESULT; }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(const char *to,uint length, const CHARSET_INFO * const charset);
   int  store(double nr);
   int  store(int64_t nr, bool unsigned_val);
   int  reset(void) { ptr[0]=ptr[1]=ptr[2]=ptr[3]=0; return 0; }

=== modified file 'drizzled/field/timetype.cc'
--- drizzled/field/timetype.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field/timetype.cc	2008-08-06 00:04:45 +0000
@@ -34,7 +34,7 @@
 
 int Field_time::store(const char *from,
                       uint len,
-                      CHARSET_INFO *cs __attribute__((unused)))
+                      const CHARSET_INFO * const cs __attribute__((unused)))
 {
   DRIZZLE_TIME ltime;
   long tmp;

=== modified file 'drizzled/field/timetype.h'
--- drizzled/field/timetype.h	2008-07-31 18:25:59 +0000
+++ drizzled/field/timetype.h	2008-08-06 00:04:45 +0000
@@ -27,19 +27,19 @@
 public:
   Field_time(uchar *ptr_arg, uchar *null_ptr_arg, uchar null_bit_arg,
 	     enum utype unireg_check_arg, const char *field_name_arg,
-	     CHARSET_INFO *cs)
+	     const CHARSET_INFO * const cs)
     :Field_str(ptr_arg, 8, null_ptr_arg, null_bit_arg,
 	       unireg_check_arg, field_name_arg, cs)
     {}
   Field_time(bool maybe_null_arg, const char *field_name_arg,
-             CHARSET_INFO *cs)
+             const CHARSET_INFO * const cs)
     :Field_str((uchar*) 0,8, maybe_null_arg ? (uchar*) "": 0,0,
 	       NONE, field_name_arg, cs) {}
   enum_field_types type() const { return DRIZZLE_TYPE_TIME;}
   enum ha_base_keytype key_type() const { return HA_KEYTYPE_INT24; }
   enum Item_result cmp_type () const { return INT_RESULT; }
   int store_time(DRIZZLE_TIME *ltime, timestamp_type type);
-  int store(const char *to,uint length,CHARSET_INFO *charset);
+  int store(const char *to,uint length, const CHARSET_INFO * const charset);
   int store(double nr);
   int store(int64_t nr, bool unsigned_val);
   int reset(void) { ptr[0]=ptr[1]=ptr[2]=0; return 0; }

=== modified file 'drizzled/field/varstring.cc'
--- drizzled/field/varstring.cc	2008-07-29 07:47:38 +0000
+++ drizzled/field/varstring.cc	2008-08-06 00:04:45 +0000
@@ -61,7 +61,7 @@
   return 2;
 }
 
-int Field_varstring::store(const char *from,uint length,CHARSET_INFO *cs)
+int Field_varstring::store(const char *from,uint length, const CHARSET_INFO * const cs)
 {
   uint copy_length;
   const char *well_formed_error_pos;
@@ -247,7 +247,7 @@
 void Field_varstring::sql_type(String &res) const
 {
   THD *thd= table->in_use;
-  CHARSET_INFO *cs=res.charset();
+  const CHARSET_INFO * const cs=res.charset();
   ulong length;
 
   length= cs->cset->snprintf(cs,(char*) res.ptr(),
@@ -601,7 +601,7 @@
   else
   {
     uint len=  length_bytes == 1 ? (uint) *ptr : uint2korr(ptr);
-    CHARSET_INFO *cs= charset();
+    const CHARSET_INFO * const cs= charset();
     cs->coll->hash_sort(cs, ptr + length_bytes, len, nr, nr2);
   }
 }

=== modified file 'drizzled/field/varstring.h'
--- drizzled/field/varstring.h	2008-07-30 19:17:49 +0000
+++ drizzled/field/varstring.h	2008-08-06 00:04:45 +0000
@@ -36,7 +36,7 @@
                   uint32_t len_arg, uint length_bytes_arg,
                   uchar *null_ptr_arg, uchar null_bit_arg,
 		  enum utype unireg_check_arg, const char *field_name_arg,
-		  TABLE_SHARE *share, CHARSET_INFO *cs)
+		  TABLE_SHARE *share, const CHARSET_INFO * const cs)
     :Field_longstr(ptr_arg, len_arg, null_ptr_arg, null_bit_arg,
                    unireg_check_arg, field_name_arg, cs),
      length_bytes(length_bytes_arg)
@@ -45,7 +45,7 @@
   }
   Field_varstring(uint32_t len_arg,bool maybe_null_arg,
                   const char *field_name_arg,
-                  TABLE_SHARE *share, CHARSET_INFO *cs)
+                  TABLE_SHARE *share, const CHARSET_INFO * const cs)
     :Field_longstr((uchar*) 0,len_arg, maybe_null_arg ? (uchar*) "": 0, 0,
                    NONE, field_name_arg, cs),
      length_bytes(len_arg < 256 ? 1 :2)
@@ -65,7 +65,7 @@
     return (uint32_t) field_length + (field_charset == &my_charset_bin ?
                                     length_bytes : 0);
   }
-  int  store(const char *to,uint length,CHARSET_INFO *charset);
+  int  store(const char *to,uint length, const CHARSET_INFO * const charset);
   int  store(int64_t nr, bool unsigned_val);
   int  store(double nr) { return Field_str::store(nr); } /* QQ: To be deleted */
   double val_real(void);

=== modified file 'drizzled/field_conv.cc'
--- drizzled/field_conv.cc	2008-08-04 23:58:04 +0000
+++ drizzled/field_conv.cc	2008-08-06 00:04:45 +0000
@@ -346,7 +346,7 @@
 
 static void do_cut_string(Copy_field *copy)
 {
-  CHARSET_INFO *cs= copy->from_field->charset();
+  const CHARSET_INFO * const cs= copy->from_field->charset();
   memcpy(copy->to_ptr,copy->from_ptr,copy->to_length);
 
   /* Check if we loosed any important characters */
@@ -369,7 +369,7 @@
 static void do_cut_string_complex(Copy_field *copy)
 {						// Shorter string field
   int well_formed_error;
-  CHARSET_INFO *cs= copy->from_field->charset();
+  const CHARSET_INFO * const cs= copy->from_field->charset();
   const uchar *from_end= copy->from_ptr + copy->from_length;
   uint copy_length= cs->cset->well_formed_len(cs,
                                               (char*) copy->from_ptr,
@@ -400,7 +400,7 @@
 
 static void do_expand_binary(Copy_field *copy)
 {
-  CHARSET_INFO *cs= copy->from_field->charset();
+  const CHARSET_INFO * const cs= copy->from_field->charset();
   memcpy(copy->to_ptr,copy->from_ptr,copy->from_length);
   cs->cset->fill(cs, (char*) copy->to_ptr+copy->from_length,
                      copy->to_length-copy->from_length, '\0');
@@ -410,7 +410,7 @@
 
 static void do_expand_string(Copy_field *copy)
 {
-  CHARSET_INFO *cs= copy->from_field->charset();
+  const CHARSET_INFO * const cs= copy->from_field->charset();
   memcpy(copy->to_ptr,copy->from_ptr,copy->from_length);
   cs->cset->fill(cs, (char*) copy->to_ptr+copy->from_length,
                      copy->to_length-copy->from_length, ' ');
@@ -435,7 +435,7 @@
 static void do_varstring1_mb(Copy_field *copy)
 {
   int well_formed_error;
-  CHARSET_INFO *cs= copy->from_field->charset();
+  const CHARSET_INFO * const cs= copy->from_field->charset();
   uint from_length= (uint) *(uchar*) copy->from_ptr;
   const uchar *from_ptr= copy->from_ptr + 1;
   uint to_char_length= (copy->to_length - 1) / cs->mbmaxlen;
@@ -472,7 +472,7 @@
 static void do_varstring2_mb(Copy_field *copy)
 {
   int well_formed_error;
-  CHARSET_INFO *cs= copy->from_field->charset();
+  const CHARSET_INFO * const cs= copy->from_field->charset();
   uint char_length= (copy->to_length - HA_KEY_BLOB_LENGTH) / cs->mbmaxlen;
   uint from_length= uint2korr(copy->from_ptr);
   const uchar *from_beg= copy->from_ptr + HA_KEY_BLOB_LENGTH;

=== modified file 'drizzled/filesort.cc'
--- drizzled/filesort.cc	2008-08-05 02:31:51 +0000
+++ drizzled/filesort.cc	2008-08-06 00:04:45 +0000
@@ -709,7 +709,7 @@
       switch (sort_field->result_type) {
       case STRING_RESULT:
       {
-        CHARSET_INFO *cs=item->collation.collation;
+        const CHARSET_INFO * const cs=item->collation.collation;
         char fill_char= ((cs->state & MY_CS_BINSORT) ? (char) 0 : ' ');
         int diff;
         uint sort_field_length;
@@ -1362,7 +1362,7 @@
            bool *multi_byte_charset)
 {
   register uint length;
-  CHARSET_INFO *cs;
+  const CHARSET_INFO *cs;
   *multi_byte_charset= 0;
 
   length=0;

=== modified file 'drizzled/handler.h'
--- drizzled/handler.h	2008-08-05 06:19:05 +0000
+++ drizzled/handler.h	2008-08-06 00:04:45 +0000
@@ -753,7 +753,7 @@
 
 typedef struct st_ha_create_information
 {
-  CHARSET_INFO *table_charset, *default_table_charset;
+  const CHARSET_INFO *table_charset, *default_table_charset;
   LEX_STRING connect_string;
   LEX_STRING comment;
   const char *data_file_name, *index_file_name;

=== modified file 'drizzled/item.cc'
--- drizzled/item.cc	2008-08-05 02:31:51 +0000
+++ drizzled/item.cc	2008-08-06 00:04:45 +0000
@@ -680,7 +680,7 @@
 }
 
 
-void Item::set_name(const char *str, uint length, CHARSET_INFO *cs)
+void Item::set_name(const char *str, uint length, const CHARSET_INFO * const cs)
 {
   if (!length)
   {
@@ -744,7 +744,7 @@
 }
 
 
-Item *Item::safe_charset_converter(CHARSET_INFO *tocs)
+Item *Item::safe_charset_converter(const CHARSET_INFO * const tocs)
 {
   Item_func_conv_charset *conv= new Item_func_conv_charset(this, tocs, 1);
   return conv->safe ? conv : NULL;
@@ -762,7 +762,7 @@
   the latter returns a non-fixed Item, so val_str() crashes afterwards.
   Override Item_num method, to return a fixed item.
 */
-Item *Item_num::safe_charset_converter(CHARSET_INFO *tocs __attribute__((unused)))
+Item *Item_num::safe_charset_converter(const CHARSET_INFO * const tocs __attribute__((unused)))
 {
   Item_string *conv;
   char buf[64];
@@ -777,7 +777,7 @@
 }
 
 
-Item *Item_static_float_func::safe_charset_converter(CHARSET_INFO *tocs __attribute__((unused)))
+Item *Item_static_float_func::safe_charset_converter(const CHARSET_INFO * const tocs __attribute__((unused)))
 {
   Item_string *conv;
   char buf[64];
@@ -793,7 +793,7 @@
 }
 
 
-Item *Item_string::safe_charset_converter(CHARSET_INFO *tocs)
+Item *Item_string::safe_charset_converter(const CHARSET_INFO * const tocs)
 {
   Item_string *conv;
   uint conv_errors;
@@ -821,7 +821,7 @@
 }
 
 
-Item *Item_param::safe_charset_converter(CHARSET_INFO *tocs)
+Item *Item_param::safe_charset_converter(const CHARSET_INFO * const tocs)
 {
   if (const_item())
   {
@@ -839,7 +839,7 @@
 }
 
 
-Item *Item_static_string_func::safe_charset_converter(CHARSET_INFO *tocs)
+Item *Item_static_string_func::safe_charset_converter(const CHARSET_INFO * const tocs)
 {
   Item_string *conv;
   uint conv_errors;
@@ -935,7 +935,7 @@
   return 0;
 }
 
-CHARSET_INFO *Item::default_charset()
+const CHARSET_INFO *Item::default_charset()
 {
   return current_thd->variables.collation_connection;
 }
@@ -1197,8 +1197,8 @@
         set(dt);
         return 0;
       }
-      CHARSET_INFO *bin= get_charset_by_csname(collation->csname, 
-                                               MY_CS_BINSORT,MYF(0));
+      const CHARSET_INFO * const bin= get_charset_by_csname(collation->csname, 
+                                                            MY_CS_BINSORT,MYF(0));
       set(bin, DERIVATION_NONE);
     }
   }
@@ -1840,7 +1840,7 @@
 
 
 Item_decimal::Item_decimal(const char *str_arg, uint length,
-                           CHARSET_INFO *charset)
+                           const CHARSET_INFO * const charset)
 {
   str2my_decimal(E_DEC_FATAL_ERROR, str_arg, length, charset, &decimal_value);
   name= (char*) str_arg;
@@ -2023,7 +2023,7 @@
   int error;
   char *end, *org_end;
   double tmp;
-  CHARSET_INFO *cs= str_value.charset();
+  const CHARSET_INFO * const cs= str_value.charset();
 
   org_end= (char*) str_value.ptr() + str_value.length();
   tmp= my_strntod(cs, (char*) str_value.ptr(), str_value.length(), &end,
@@ -2054,7 +2054,7 @@
   int64_t tmp;
   char *end= (char*) str_value.ptr()+ str_value.length();
   char *org_end= end;
-  CHARSET_INFO *cs= str_value.charset();
+  const CHARSET_INFO * const cs= str_value.charset();
 
   tmp= (*(cs->cset->strtoll10))(cs, str_value.ptr(), &end, &err);
   /*
@@ -2113,7 +2113,7 @@
 }
 
 
-Item *Item_null::safe_charset_converter(CHARSET_INFO *tocs)
+Item *Item_null::safe_charset_converter(const CHARSET_INFO * const tocs)
 {
   collation.set(tocs);
   return this;
@@ -2335,8 +2335,8 @@
       break;
     case STRING_RESULT:
     {
-      CHARSET_INFO *fromcs= entry->collation.collation;
-      CHARSET_INFO *tocs= thd->variables.collation_connection;
+      const CHARSET_INFO * const fromcs= entry->collation.collation;
+      const CHARSET_INFO * const tocs= thd->variables.collation_connection;
       uint32_t dummy_offset;
 
       value.cs_info.character_set_of_placeholder= 
@@ -3689,7 +3689,7 @@
   return true;
 }
 
-Item *Item_field::safe_charset_converter(CHARSET_INFO *tocs)
+Item *Item_field::safe_charset_converter(const CHARSET_INFO * const tocs)
 {
   no_const_subst= 1;
   return Item::safe_charset_converter(tocs);
@@ -3968,7 +3968,7 @@
 String *Item::check_well_formed_result(String *str, bool send_error)
 {
   /* Check whether we got a well-formed string */
-  CHARSET_INFO *cs= str->charset();
+  const CHARSET_INFO * const cs= str->charset();
   int well_formed_error;
   uint wlen= cs->cset->well_formed_len(cs,
                                        str->ptr(), str->ptr() + str->length(),
@@ -4019,10 +4019,10 @@
     0    otherwise
 */
 
-bool Item::eq_by_collation(Item *item, bool binary_cmp, CHARSET_INFO *cs)
+bool Item::eq_by_collation(Item *item, bool binary_cmp, const CHARSET_INFO * const cs)
 {
-  CHARSET_INFO *save_cs= 0;
-  CHARSET_INFO *save_item_cs= 0;
+  const CHARSET_INFO *save_cs= 0;
+  const CHARSET_INFO *save_item_cs= 0;
   if (collation.collation != cs)
   {
     save_cs= collation.collation;
@@ -4253,7 +4253,7 @@
   if (result_type() == STRING_RESULT)
   {
     String *result;
-    CHARSET_INFO *cs= collation.collation;
+    const CHARSET_INFO * const cs= collation.collation;
     char buff[MAX_FIELD_WIDTH];		// Alloc buffer for small columns
     str_value.set_quick(buff, sizeof(buff), cs);
     result=val_str(&str_value);
@@ -4587,7 +4587,7 @@
 }
 
 
-Item *Item_hex_string::safe_charset_converter(CHARSET_INFO *tocs)
+Item *Item_hex_string::safe_charset_converter(const CHARSET_INFO * const tocs)
 {
   Item_string *conv;
   String tmp, *str= val_str(&tmp);

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2008-07-31 19:57:34 +0000
+++ drizzled/item.h	2008-08-06 00:04:45 +0000
@@ -47,11 +47,11 @@
 
 class DTCollation {
 public:
-  CHARSET_INFO     *collation;
+  const CHARSET_INFO *collation;
   enum Derivation derivation;
   uint repertoire;
   
-  void set_repertoire_from_charset(CHARSET_INFO *cs)
+  void set_repertoire_from_charset(const CHARSET_INFO * const cs)
   {
     repertoire= cs->state & MY_CS_PUREASCII ?
                 MY_REPERTOIRE_ASCII : MY_REPERTOIRE_UNICODE30;
@@ -62,7 +62,7 @@
     derivation= DERIVATION_NONE;
     repertoire= MY_REPERTOIRE_UNICODE30;
   }
-  DTCollation(CHARSET_INFO *collation_arg, Derivation derivation_arg)
+  DTCollation(const CHARSET_INFO * const collation_arg, Derivation derivation_arg)
   {
     collation= collation_arg;
     derivation= derivation_arg;
@@ -74,13 +74,13 @@
     derivation= dt.derivation;
     repertoire= dt.repertoire;
   }
-  void set(CHARSET_INFO *collation_arg, Derivation derivation_arg)
+  void set(const CHARSET_INFO * const collation_arg, Derivation derivation_arg)
   {
     collation= collation_arg;
     derivation= derivation_arg;
     set_repertoire_from_charset(collation_arg);
   }
-  void set(CHARSET_INFO *collation_arg,
+  void set(const CHARSET_INFO * const collation_arg,
            Derivation derivation_arg,
            uint repertoire_arg)
   {
@@ -88,7 +88,7 @@
     derivation= derivation_arg;
     repertoire= repertoire_arg;
   }
-  void set(CHARSET_INFO *collation_arg)
+  void set(const CHARSET_INFO * const collation_arg)
   {
     collation= collation_arg;
     set_repertoire_from_charset(collation_arg);
@@ -509,7 +509,7 @@
     name=0;
 #endif
   }		/*lint -e1509 */
-  void set_name(const char *str, uint length, CHARSET_INFO *cs);
+  void set_name(const char *str, uint length, const CHARSET_INFO * const cs);
   void rename(char *new_name);
   void init_make_field(Send_field *tmp_field,enum enum_field_types type);
   virtual void cleanup();
@@ -828,8 +828,8 @@
   virtual Item *real_item(void) { return this; }
   virtual Item *get_tmp_table_item(THD *thd) { return copy_or_same(thd); }
 
-  static CHARSET_INFO *default_charset();
-  virtual CHARSET_INFO *compare_collation() { return NULL; }
+  static const CHARSET_INFO *default_charset();
+  virtual const CHARSET_INFO *compare_collation() { return NULL; }
 
   virtual bool walk(Item_processor processor __attribute__((unused)),
                     bool walk_subquery __attribute__((unused)),
@@ -928,7 +928,7 @@
 
   virtual Item *neg_transformer(THD *thd __attribute__((unused))) { return NULL; }
   virtual Item *update_value_transformer(uchar *select_arg __attribute__((unused))) { return this; }
-  virtual Item *safe_charset_converter(CHARSET_INFO *tocs);
+  virtual Item *safe_charset_converter(const CHARSET_INFO * const tocs);
   void delete_self()
   {
     cleanup();
@@ -963,7 +963,7 @@
     return test(is_expensive_cache);
   }
   String *check_well_formed_result(String *str, bool send_error= 0);
-  bool eq_by_collation(Item *item, bool binary_cmp, CHARSET_INFO *cs); 
+  bool eq_by_collation(Item *item, bool binary_cmp, const CHARSET_INFO * const cs); 
 };
 
 
@@ -996,7 +996,7 @@
 public:
   Item_num() {}                               /* Remove gcc warning */
   virtual Item_num *neg()= 0;
-  Item *safe_charset_converter(CHARSET_INFO *tocs);
+  Item *safe_charset_converter(const CHARSET_INFO * const tocs);
 };
 
 #define NO_CACHED_FIELD_INDEX ((uint)(-1))
@@ -1168,7 +1168,7 @@
   Item *replace_equal_field(uchar *arg);
   inline uint32_t max_disp_length() { return field->max_display_length(); }
   Item_field *filed_for_view_update() { return this; }
-  Item *safe_charset_converter(CHARSET_INFO *tocs);
+  Item *safe_charset_converter(const CHARSET_INFO * const tocs);
   int fix_outer_field(THD *thd, Field **field, Item **reference);
   virtual Item *update_value_transformer(uchar *select_arg);
   virtual void print(String *str, enum_query_type query_type);
@@ -1210,7 +1210,7 @@
     str->append(STRING_WITH_LEN("NULL"));
   }
 
-  Item *safe_charset_converter(CHARSET_INFO *tocs);
+  Item *safe_charset_converter(const CHARSET_INFO * const tocs);
 };
 
 class Item_null_result :public Item_null
@@ -1265,15 +1265,15 @@
     */
     struct CONVERSION_INFO
     {
-      CHARSET_INFO *character_set_client;
-      CHARSET_INFO *character_set_of_placeholder;
+      const CHARSET_INFO *character_set_client;
+      const CHARSET_INFO *character_set_of_placeholder;
       /*
         This points at character set of connection if conversion
         to it is required (i. e. if placeholder typecode is not BLOB).
         Otherwise it's equal to character_set_client (to simplify
         check in convert_str_value()).
       */
-      CHARSET_INFO *final_character_set_of_str_value;
+      const CHARSET_INFO *final_character_set_of_str_value;
     } cs_info;
     DRIZZLE_TIME     time;
   } value;
@@ -1353,7 +1353,7 @@
     constant, assert otherwise. This method is called only if
     basic_const_item returned true.
   */
-  Item *safe_charset_converter(CHARSET_INFO *tocs);
+  Item *safe_charset_converter(const CHARSET_INFO * const tocs);
   Item *clone_item();
   /*
     Implement by-value equality evaluation if parameter value
@@ -1423,7 +1423,7 @@
 protected:
   my_decimal decimal_value;
 public:
-  Item_decimal(const char *str_arg, uint length, CHARSET_INFO *charset);
+  Item_decimal(const char *str_arg, uint length, const CHARSET_INFO * const charset);
   Item_decimal(const char *str, const my_decimal *val_arg,
                uint decimal_par, uint length);
   Item_decimal(my_decimal *value_par);
@@ -1521,7 +1521,7 @@
     str->append(func_name);
   }
 
-  Item *safe_charset_converter(CHARSET_INFO *tocs);
+  Item *safe_charset_converter(const CHARSET_INFO * const tocs);
 };
 
 
@@ -1529,7 +1529,7 @@
 {
 public:
   Item_string(const char *str,uint length,
-              CHARSET_INFO *cs, Derivation dv= DERIVATION_COERCIBLE,
+              const CHARSET_INFO * const cs, Derivation dv= DERIVATION_COERCIBLE,
               uint repertoire= MY_REPERTOIRE_UNICODE30)
     : m_cs_specified(false)
   {
@@ -1549,7 +1549,7 @@
     fixed= 1;
   }
   /* Just create an item and do not fill string representation */
-  Item_string(CHARSET_INFO *cs, Derivation dv= DERIVATION_COERCIBLE)
+  Item_string(const CHARSET_INFO * const cs, Derivation dv= DERIVATION_COERCIBLE)
     : m_cs_specified(false)
   {
     collation.set(cs, dv);
@@ -1559,7 +1559,7 @@
     fixed= 1;
   }
   Item_string(const char *name_par, const char *str, uint length,
-              CHARSET_INFO *cs, Derivation dv= DERIVATION_COERCIBLE,
+              const CHARSET_INFO * const cs, Derivation dv= DERIVATION_COERCIBLE,
               uint repertoire= MY_REPERTOIRE_UNICODE30)
     : m_cs_specified(false)
   {
@@ -1605,7 +1605,7 @@
     return new Item_string(name, str_value.ptr(), 
     			   str_value.length(), collation.collation);
   }
-  Item *safe_charset_converter(CHARSET_INFO *tocs);
+  Item *safe_charset_converter(const CHARSET_INFO * const tocs);
   inline void append(char *str, uint length)
   {
     str_value.append(str, length);
@@ -1662,11 +1662,11 @@
   const char *func_name;
 public:
   Item_static_string_func(const char *name_par, const char *str, uint length,
-                          CHARSET_INFO *cs,
+                          const CHARSET_INFO * const cs,
                           Derivation dv= DERIVATION_COERCIBLE)
     :Item_string(NullS, str, length, cs, dv), func_name(name_par)
   {}
-  Item *safe_charset_converter(CHARSET_INFO *tocs);
+  Item *safe_charset_converter(const CHARSET_INFO * const tocs);
 
   virtual inline void print(String *str,
                             enum_query_type query_type __attribute__((unused)))
@@ -1709,7 +1709,7 @@
 class Item_empty_string :public Item_string
 {
 public:
-  Item_empty_string(const char *header,uint length, CHARSET_INFO *cs= NULL) :
+  Item_empty_string(const char *header,uint length, const CHARSET_INFO * cs= NULL) :
     Item_string("",0, cs ? cs : &my_charset_utf8_general_ci)
     { name=(char*) header; max_length= cs ? length * cs->mbmaxlen : length; }
   void make_field(Send_field *field);
@@ -1751,7 +1751,7 @@
   enum_field_types field_type() const { return DRIZZLE_TYPE_VARCHAR; }
   virtual void print(String *str, enum_query_type query_type);
   bool eq(const Item *item, bool binary_cmp) const;
-  virtual Item *safe_charset_converter(CHARSET_INFO *tocs);
+  virtual Item *safe_charset_converter(const CHARSET_INFO * const tocs);
 };
 
 
@@ -2405,7 +2405,7 @@
   String* val_str(String *) { assert(fixed == 1); return value; }
   my_decimal *val_decimal(my_decimal *);
   enum Item_result result_type() const { return STRING_RESULT; }
-  CHARSET_INFO *charset() const { return value->charset(); };
+  const CHARSET_INFO *charset() const { return value->charset(); };
   int save_in_field(Field *field, bool no_conversions);
 };
 

=== modified file 'drizzled/item_cmpfunc.cc'
--- drizzled/item_cmpfunc.cc	2008-08-04 23:58:04 +0000
+++ drizzled/item_cmpfunc.cc	2008-08-06 00:04:45 +0000
@@ -3090,7 +3090,7 @@
   return (int) ((*compare)(collation, base+start*size, result) == 0);
 }
 
-in_string::in_string(uint elements,qsort2_cmp cmp_func, CHARSET_INFO *cs)
+in_string::in_string(uint elements,qsort2_cmp cmp_func, const CHARSET_INFO * const cs)
   :in_vector(elements, sizeof(String), cmp_func, cs),
    tmp(buff, sizeof(buff), &my_charset_bin)
 {}
@@ -3120,7 +3120,7 @@
   }
   if (!str->charset())
   {
-    CHARSET_INFO *cs;
+    const CHARSET_INFO *cs;
     if (!(cs= item->collation.collation))
       cs= &my_charset_bin;		// Should never happen for STR items
     str->set_charset(cs);
@@ -3254,7 +3254,7 @@
 
 
 cmp_item* cmp_item::get_comparator(Item_result type,
-                                   CHARSET_INFO *cs)
+                                   const CHARSET_INFO * const cs)
 {
   switch (type) {
   case STRING_RESULT:
@@ -3523,7 +3523,7 @@
 }
 
 
-static int srtcmp_in(CHARSET_INFO *cs, const String *x,const String *y)
+static int srtcmp_in(const CHARSET_INFO * const cs, const String *x,const String *y)
 {
   return cs->coll->strnncollsp(cs,
                                (uchar *) x->ptr(),x->length(),
@@ -4447,7 +4447,7 @@
 
       if (use_mb(cmp.cmp_collation.collation))
       {
-        CHARSET_INFO *cs= escape_str->charset();
+        const CHARSET_INFO * const cs= escape_str->charset();
         my_wc_t wc;
         int rc= cs->cset->mb_wc(cs, &wc,
                                 (const uchar*) escape_str->ptr(),
@@ -4462,7 +4462,7 @@
           code instead of Unicode code as "escape" argument.
           Convert to "cs" if charset of escape differs.
         */
-        CHARSET_INFO *cs= cmp.cmp_collation.collation;
+        const CHARSET_INFO * const cs= cmp.cmp_collation.collation;
         uint32_t unused;
         if (escape_str->needs_conversion(escape_str->length(),
                                          escape_str->charset(), cs, &unused))
@@ -4548,7 +4548,7 @@
   int            f = 0;
   int            g = plm1;
   int *const splm1 = suff + plm1;
-  CHARSET_INFO	*cs= cmp.cmp_collation.collation;
+  const CHARSET_INFO * const cs= cmp.cmp_collation.collation;
 
   *splm1 = pattern_len;
 
@@ -4648,7 +4648,7 @@
   int *end = bmBc + alphabet_size;
   int j;
   const int plm1 = pattern_len - 1;
-  CHARSET_INFO	*cs= cmp.cmp_collation.collation;
+  const CHARSET_INFO *const cs= cmp.cmp_collation.collation;
 
   for (i = bmBc; i < end; i++)
     *i = pattern_len;
@@ -4680,7 +4680,7 @@
   int shift = pattern_len;
   int j     = 0;
   int u     = 0;
-  CHARSET_INFO	*cs= cmp.cmp_collation.collation;
+  const CHARSET_INFO * const cs= cmp.cmp_collation.collation;
 
   const int plm1=  pattern_len - 1;
   const int tlmpl= text_len - pattern_len;

=== modified file 'drizzled/item_cmpfunc.h'
--- drizzled/item_cmpfunc.h	2008-07-29 07:47:38 +0000
+++ drizzled/item_cmpfunc.h	2008-08-06 00:04:45 +0000
@@ -347,7 +347,7 @@
 
   bool is_null() { return test(args[0]->is_null() || args[1]->is_null()); }
   bool is_bool_func() { return 1; }
-  CHARSET_INFO *compare_collation() { return cmp.cmp_collation.collation; }
+  const CHARSET_INFO *compare_collation() { return cmp.cmp_collation.collation; }
   uint decimal_precision() const { return 1; }
   void top_level_item() { abort_on_null= true; }
 
@@ -606,7 +606,7 @@
   void fix_length_and_dec();
   virtual void print(String *str, enum_query_type query_type);
   bool is_bool_func() { return 1; }
-  CHARSET_INFO *compare_collation() { return cmp_collation.collation; }
+  const CHARSET_INFO *compare_collation() { return cmp_collation.collation; }
   uint decimal_precision() const { return 1; }
 };
 
@@ -747,12 +747,12 @@
   char *base;
   uint size;
   qsort2_cmp compare;
-  CHARSET_INFO *collation;
+  const CHARSET_INFO *collation;
   uint count;
   uint used_count;
   in_vector() {}
   in_vector(uint elements,uint element_length,qsort2_cmp cmp_func, 
-  	    CHARSET_INFO *cmp_coll)
+  	    const CHARSET_INFO * const cmp_coll)
     :base((char*) sql_calloc(elements*element_length)),
      size(element_length), compare(cmp_func), collation(cmp_coll),
      count(elements), used_count(elements) {}
@@ -761,7 +761,7 @@
   virtual uchar *get_value(Item *item)=0;
   void sort()
   {
-    my_qsort2(base,used_count,size,compare,collation);
+    my_qsort2(base,used_count,size,compare, (void *) collation);
   }
   int find(Item *item);
   
@@ -799,7 +799,7 @@
   char buff[STRING_BUFFER_USUAL_SIZE];
   String tmp;
 public:
-  in_string(uint elements,qsort2_cmp cmp_func, CHARSET_INFO *cs);
+  in_string(uint elements,qsort2_cmp cmp_func, const CHARSET_INFO * const cs);
   ~in_string();
   void set(uint pos,Item *item);
   uchar *get_value(Item *item);
@@ -926,14 +926,14 @@
 class cmp_item :public Sql_alloc
 {
 public:
-  CHARSET_INFO *cmp_charset;
+  const CHARSET_INFO *cmp_charset;
   cmp_item() { cmp_charset= &my_charset_bin; }
   virtual ~cmp_item() {}
   virtual void store_value(Item *item)= 0;
   virtual int cmp(Item *item)= 0;
   // for optimized IN with row
   virtual int compare(cmp_item *item)= 0;
-  static cmp_item* get_comparator(Item_result type, CHARSET_INFO *cs);
+  static cmp_item* get_comparator(Item_result type, const CHARSET_INFO * const cs);
   virtual cmp_item *make_same()= 0;
   virtual void store_value_by_template(cmp_item *tmpl  __attribute__((unused)),
                                        Item *item)
@@ -948,8 +948,8 @@
   String *value_res;
 public:
   cmp_item_string () {}
-  cmp_item_string (CHARSET_INFO *cs) { cmp_charset= cs; }
-  void set_charset(CHARSET_INFO *cs) { cmp_charset= cs; }
+  cmp_item_string (const CHARSET_INFO * const cs) { cmp_charset= cs; }
+  void set_charset(const CHARSET_INFO * const cs) { cmp_charset= cs; }
   friend class cmp_item_sort_string;
   friend class cmp_item_sort_string_in_static;
 };
@@ -962,7 +962,7 @@
 public:
   cmp_item_sort_string():
     cmp_item_string() {}
-  cmp_item_sort_string(CHARSET_INFO *cs):
+  cmp_item_sort_string(const CHARSET_INFO * const cs):
     cmp_item_string(cs),
     value(value_buff, sizeof(value_buff), cs) {}
   void store_value(Item *item)
@@ -983,7 +983,7 @@
     return sortcmp(value_res, l_cmp->value_res, cmp_charset);
   } 
   cmp_item *make_same();
-  void set_charset(CHARSET_INFO *cs)
+  void set_charset(const CHARSET_INFO * const cs)
   {
     cmp_charset= cs;
     value.set_quick(value_buff, sizeof(value_buff), cs);
@@ -1079,7 +1079,7 @@
  protected:
   String value;
 public:
-  cmp_item_sort_string_in_static(CHARSET_INFO *cs):
+  cmp_item_sort_string_in_static(const CHARSET_INFO * const cs):
     cmp_item_string(cs) {}
   void store_value(Item *item)
   {
@@ -1164,7 +1164,7 @@
   const char *func_name() const { return "case"; }
   virtual void print(String *str, enum_query_type query_type);
   Item *find_item(String *str);
-  CHARSET_INFO *compare_collation() { return cmp_collation.collation; }
+  const CHARSET_INFO *compare_collation() { return cmp_collation.collation; }
   void cleanup();
   void agg_str_lengths(Item *arg);
   void agg_num_lengths(Item *arg);
@@ -1233,7 +1233,7 @@
   const char *func_name() const { return " IN "; }
   bool nulls_in_row();
   bool is_bool_func() { return 1; }
-  CHARSET_INFO *compare_collation() { return cmp_collation.collation; }
+  const CHARSET_INFO *compare_collation() { return cmp_collation.collation; }
 };
 
 class cmp_item_row :public cmp_item
@@ -1304,7 +1304,7 @@
   table_map not_null_tables() const { return 0; }
   optimize_type select_optimize() const { return OPTIMIZE_NULL; }
   Item *neg_transformer(THD *thd);
-  CHARSET_INFO *compare_collation() { return args[0]->collation.collation; }
+  const CHARSET_INFO *compare_collation() { return args[0]->collation.collation; }
 };
 
 /* Functions used by HAVING for rewriting IN subquery */
@@ -1351,7 +1351,7 @@
   { return abort_on_null ? not_null_tables_cache : 0; }
   Item *neg_transformer(THD *thd);
   virtual void print(String *str, enum_query_type query_type);
-  CHARSET_INFO *compare_collation() { return args[0]->collation.collation; }
+  const CHARSET_INFO *compare_collation() { return args[0]->collation.collation; }
   void top_level_item() { abort_on_null=1; }
 };
 
@@ -1552,7 +1552,7 @@
   bool walk(Item_processor processor, bool walk_subquery, uchar *arg);
   Item *transform(Item_transformer transformer, uchar *arg);
   virtual void print(String *str, enum_query_type query_type);
-  CHARSET_INFO *compare_collation() 
+  const CHARSET_INFO *compare_collation() 
   { return fields.head()->collation.collation; }
 }; 
 

=== modified file 'drizzled/item_create.cc'
--- drizzled/item_create.cc	2008-08-01 18:59:55 +0000
+++ drizzled/item_create.cc	2008-08-06 00:04:45 +0000
@@ -2726,7 +2726,7 @@
     The parsed item tree should not depend on
     <code>thd->variables.collation_connection</code>.
   */
-  CHARSET_INFO *cs= thd->variables.collation_connection;
+  const CHARSET_INFO * const cs= thd->variables.collation_connection;
   Item *sp;
 
   if (cs->mbminlen > 1)
@@ -3163,9 +3163,9 @@
 
 
 Item*
-create_func_char_cast(THD *thd, Item *a, int len, CHARSET_INFO *cs)
+create_func_char_cast(THD *thd, Item *a, int len, const CHARSET_INFO * const cs)
 {
-  CHARSET_INFO *real_cs= (cs ? cs : thd->variables.collation_connection);
+  const CHARSET_INFO * const real_cs= (cs ? cs : thd->variables.collation_connection);
   return new (thd->mem_root) Item_char_typecast(a, len, real_cs);
 }
 
@@ -3173,7 +3173,7 @@
 Item *
 create_func_cast(THD *thd, Item *a, Cast_target cast_type,
                  const char *c_len, const char *c_dec,
-                 CHARSET_INFO *cs)
+                 const CHARSET_INFO * const cs)
 {
   Item *res;
   ulong len;

=== modified file 'drizzled/item_create.h'
--- drizzled/item_create.h	2008-08-01 15:12:10 +0000
+++ drizzled/item_create.h	2008-08-06 00:04:45 +0000
@@ -147,7 +147,7 @@
 };
 
 Item*
-create_func_char_cast(THD *thd, Item *a, int len, CHARSET_INFO *cs);
+create_func_char_cast(THD *thd, Item *a, int len, const CHARSET_INFO * const cs);
 
 /**
   Builder for cast expressions.
@@ -161,7 +161,7 @@
 Item *
 create_func_cast(THD *thd, Item *a, Cast_target cast_type,
                  const char *len, const char *dec,
-                 CHARSET_INFO *cs);
+                 const CHARSET_INFO * const cs);
 
 int item_create_init();
 void item_create_cleanup();

=== modified file 'drizzled/item_func.cc'
--- drizzled/item_func.cc	2008-08-05 02:31:51 +0000
+++ drizzled/item_func.cc	2008-08-06 00:04:45 +0000
@@ -828,7 +828,7 @@
       return 0;
 
     char *end= (char*) res->ptr() + res->length();
-    CHARSET_INFO *cs= str_value.charset();
+    const CHARSET_INFO * const cs= str_value.charset();
     return (*(cs->cset->strtoll10))(cs, res->ptr(), &end, &err_not_used);
   }
   default:
@@ -2691,7 +2691,7 @@
   if ((diff=buffer->length() - find->length()) >= 0)
   {
     my_wc_t wc;
-    CHARSET_INFO *cs= cmp_collation.collation;
+    const CHARSET_INFO * const cs= cmp_collation.collation;
     const char *str_begin= buffer->ptr();
     const char *str_end= buffer->ptr();
     const char *real_end= str_end+buffer->length();
@@ -3250,7 +3250,7 @@
 void item_user_lock_init(void)
 {
   pthread_mutex_init(&LOCK_user_locks,MY_MUTEX_INIT_SLOW);
-  hash_init(&hash_user_locks,system_charset_info,
+  hash_init(&hash_user_locks, system_charset_info,
 	    16,0,0,(hash_get_key) ull_get_key,NULL,0);
   item_user_lock_inited= 1;
 }
@@ -3547,7 +3547,7 @@
 
 static bool
 update_hash(user_var_entry *entry, bool set_null, void *ptr, uint length,
-            Item_result type, CHARSET_INFO *cs, Derivation dv,
+            Item_result type, const CHARSET_INFO * const cs, Derivation dv,
             bool unsigned_arg)
 {
   if (set_null)
@@ -3608,7 +3608,7 @@
 bool
 Item_func_set_user_var::update_hash(void *ptr, uint length,
                                     Item_result res_type,
-                                    CHARSET_INFO *cs, Derivation dv,
+                                    const CHARSET_INFO * const cs, Derivation dv,
                                     bool unsigned_arg)
 {
   /*
@@ -4035,7 +4035,7 @@
       (result_type() == REAL_RESULT && field->result_type() == STRING_RESULT))
   {
     String *result;
-    CHARSET_INFO *cs= collation.collation;
+    const CHARSET_INFO * const cs= collation.collation;
     char buff[MAX_FIELD_WIDTH];		// Alloc buffer for small columns
     str_value.set_quick(buff, sizeof(buff), cs);
     result= entry->val_str(&null_value, &str_value, decimals);
@@ -4362,7 +4362,7 @@
 }
 
 
-void Item_user_var_as_out_param::set_null_value(CHARSET_INFO* cs)
+void Item_user_var_as_out_param::set_null_value(const CHARSET_INFO * const cs)
 {
   ::update_hash(entry, true, 0, 0, STRING_RESULT, cs,
                 DERIVATION_IMPLICIT, 0 /* unsigned_arg */);
@@ -4370,7 +4370,7 @@
 
 
 void Item_user_var_as_out_param::set_value(const char *str, uint length,
-                                           CHARSET_INFO* cs)
+                                           const CHARSET_INFO * const cs)
 {
   ::update_hash(entry, false, (void*)str, length, STRING_RESULT, cs,
                 DERIVATION_IMPLICIT, 0 /* unsigned_arg */);

=== modified file 'drizzled/item_func.h'
--- drizzled/item_func.h	2008-08-01 16:16:41 +0000
+++ drizzled/item_func.h	2008-08-06 00:04:45 +0000
@@ -1214,7 +1214,7 @@
   String *str_result(String *str);
   my_decimal *val_decimal_result(my_decimal *);
   bool update_hash(void *ptr, uint length, enum Item_result type,
-  		   CHARSET_INFO *cs, Derivation dv, bool unsigned_arg);
+  		   const CHARSET_INFO * const cs, Derivation dv, bool unsigned_arg);
   bool send(Protocol *protocol, String *str_arg);
   void make_field(Send_field *tmp_field);
   bool check(bool use_result_field);
@@ -1290,8 +1290,8 @@
   /* fix_fields() binds variable name with its entry structure */
   bool fix_fields(THD *thd, Item **ref);
   virtual void print(String *str, enum_query_type query_type);
-  void set_null_value(CHARSET_INFO* cs);
-  void set_value(const char *str, uint length, CHARSET_INFO* cs);
+  void set_null_value(const CHARSET_INFO * const cs);
+  void set_value(const char *str, uint length, const CHARSET_INFO * const cs);
 };
 
 

=== modified file 'drizzled/item_strfunc.cc'
--- drizzled/item_strfunc.cc	2008-08-04 23:58:04 +0000
+++ drizzled/item_strfunc.cc	2008-08-06 00:04:45 +0000
@@ -1252,7 +1252,7 @@
 }
 
 
-Item *Item_func_sysconst::safe_charset_converter(CHARSET_INFO *tocs)
+Item *Item_func_sysconst::safe_charset_converter(const CHARSET_INFO * const tocs)
 {
   Item_string *conv;
   uint conv_errors;
@@ -1298,7 +1298,7 @@
   // For system threads (e.g. replication SQL thread) user may be empty
   if (user)
   {
-    CHARSET_INFO *cs= str_value.charset();
+    const CHARSET_INFO * const cs= str_value.charset();
     uint res_length= (strlen(user)+strlen(host)+2) * cs->mbmaxlen;
 
     if (str_value.alloc(res_length))
@@ -2040,7 +2040,7 @@
 
 void Item_func_set_collation::fix_length_and_dec()
 {
-  CHARSET_INFO *set_collation;
+  const CHARSET_INFO *set_collation;
   const char *colname;
   String tmp, *str= args[1]->val_str(&tmp);
   colname= str->c_ptr();
@@ -2106,7 +2106,7 @@
   assert(fixed == 1);
   uint dummy_errors;
 
-  CHARSET_INFO *cs= args[0]->collation.collation; 
+  const CHARSET_INFO * const cs= args[0]->collation.collation; 
   null_value= 0;
   str->copy(cs->csname, strlen(cs->csname),
 	    &my_charset_latin1, collation.collation, &dummy_errors);
@@ -2117,7 +2117,7 @@
 {
   assert(fixed == 1);
   uint dummy_errors;
-  CHARSET_INFO *cs= args[0]->collation.collation; 
+  const CHARSET_INFO * const cs= args[0]->collation.collation; 
 
   null_value= 0;
   str->copy(cs->name, strlen(cs->name),
@@ -2128,7 +2128,7 @@
 
 void Item_func_weight_string::fix_length_and_dec()
 {
-  CHARSET_INFO *cs= args[0]->collation.collation;
+  const CHARSET_INFO * const cs= args[0]->collation.collation;
   collation.set(&my_charset_bin, args[0]->collation.derivation);
   flags= my_strxfrm_flag_normalize(flags, cs->levels_for_order);
   max_length= cs->mbmaxlen * max(args[0]->max_length, nweights);
@@ -2140,7 +2140,7 @@
 String *Item_func_weight_string::val_str(String *str)
 {
   String *res;
-  CHARSET_INFO *cs= args[0]->collation.collation;
+  const CHARSET_INFO * const cs= args[0]->collation.collation;
   uint tmp_length, frm_length;
   assert(fixed == 1);
 

=== modified file 'drizzled/item_strfunc.h'
--- drizzled/item_strfunc.h	2008-08-01 17:09:24 +0000
+++ drizzled/item_strfunc.h	2008-08-06 00:04:45 +0000
@@ -213,7 +213,7 @@
 public:
   Item_func_sysconst()
   { collation.set(system_charset_info,DERIVATION_SYSCONST); }
-  Item *safe_charset_converter(CHARSET_INFO *tocs);
+  Item *safe_charset_converter(const CHARSET_INFO * const tocs);
   /*
     Used to create correct Item name in new converted item in
     safe_charset_converter, return string representation of this function
@@ -352,7 +352,7 @@
 public:
   Item_func_char(List<Item> &list) :Item_str_func(list)
   { collation.set(&my_charset_bin); }
-  Item_func_char(List<Item> &list, CHARSET_INFO *cs) :Item_str_func(list)
+  Item_func_char(List<Item> &list, const CHARSET_INFO * const cs) :Item_str_func(list)
   { collation.set(cs); }  
   String *val_str(String *);
   void fix_length_and_dec() 
@@ -517,10 +517,10 @@
   bool use_cached_value;
 public:
   bool safe;
-  CHARSET_INFO *conv_charset; // keep it public
-  Item_func_conv_charset(Item *a, CHARSET_INFO *cs) :Item_str_func(a) 
+  const CHARSET_INFO *conv_charset; // keep it public
+  Item_func_conv_charset(Item *a, const CHARSET_INFO * const cs) :Item_str_func(a) 
   { conv_charset= cs; use_cached_value= 0; safe= 0; }
-  Item_func_conv_charset(Item *a, CHARSET_INFO *cs, bool cache_if_const) 
+  Item_func_conv_charset(Item *a, const CHARSET_INFO * const cs, bool cache_if_const) 
     :Item_str_func(a) 
   {
     assert(args[0]->fixed);

=== modified file 'drizzled/item_sum.cc'
--- drizzled/item_sum.cc	2008-08-04 23:58:04 +0000
+++ drizzled/item_sum.cc	2008-08-06 00:04:45 +0000
@@ -3026,7 +3026,7 @@
   if (result->length() > item->max_length)
   {
     int well_formed_error;
-    CHARSET_INFO *cs= item->collation.collation;
+    const CHARSET_INFO * const cs= item->collation.collation;
     const char *ptr= result->ptr();
     uint add_length;
     /*

=== modified file 'drizzled/item_sum.h'
--- drizzled/item_sum.h	2008-08-04 23:58:04 +0000
+++ drizzled/item_sum.h	2008-08-06 00:04:45 +0000
@@ -1059,7 +1059,7 @@
     int err_not_used;
     char *end;
     String *res;
-    CHARSET_INFO *cs;
+    const CHARSET_INFO *cs;
 
     if (!(res= val_str(&str_value)))
       return 0;                                 /* Null value */

=== modified file 'drizzled/item_timefunc.cc'
--- drizzled/item_timefunc.cc	2008-08-05 02:31:51 +0000
+++ drizzled/item_timefunc.cc	2008-08-06 00:04:45 +0000
@@ -57,7 +57,7 @@
 			  String *str)
 {
   char *buff;
-  CHARSET_INFO *cs= &my_charset_bin;
+  const CHARSET_INFO * const cs= &my_charset_bin;
   uint length= MAX_DATE_STRING_REP_LENGTH;
 
   if (str->alloc(length))
@@ -285,7 +285,7 @@
   const char *val_end= val + length;
   const char *ptr= format->format.str;
   const char *end= ptr + format->format.length;
-  CHARSET_INFO *cs= &my_charset_bin;
+  const CHARSET_INFO * const cs= &my_charset_bin;
 
   if (!sub_pattern_end)
     memset(l_time, 0, sizeof(*l_time));
@@ -855,7 +855,7 @@
                          For example, '1.1' -> '1.100000'
 */
 
-static bool get_interval_info(const char *str,uint length,CHARSET_INFO *cs,
+static bool get_interval_info(const char *str,uint length, const CHARSET_INFO * const cs,
                               uint count, uint64_t *values,
                               bool transform_msec)
 {
@@ -1297,7 +1297,7 @@
   int64_t value= 0;
   const char *str= NULL;
   size_t length= 0;
-  CHARSET_INFO *cs=str_value->charset();
+  const CHARSET_INFO * const cs= str_value->charset();
 
   memset(interval, 0, sizeof(*interval));
   if ((int) int_type <= INTERVAL_MICROSECOND)
@@ -1765,7 +1765,7 @@
   Item *arg1= args[1]->this_item();
 
   decimals=0;
-  CHARSET_INFO *cs= thd->variables.collation_connection;
+  const CHARSET_INFO * const cs= thd->variables.collation_connection;
   uint32_t repertoire= arg1->collation.repertoire;
   if (!thd->variables.lc_time_names->is_ascii)
     repertoire|= MY_REPERTOIRE_EXTENDED;

=== modified file 'drizzled/item_timefunc.h'
--- drizzled/item_timefunc.h	2008-07-31 18:25:59 +0000
+++ drizzled/item_timefunc.h	2008-08-06 00:04:45 +0000
@@ -742,11 +742,11 @@
 class Item_char_typecast :public Item_typecast
 {
   int cast_length;
-  CHARSET_INFO *cast_cs, *from_cs;
+  const CHARSET_INFO *cast_cs, *from_cs;
   bool charset_conversion;
   String tmp_value;
 public:
-  Item_char_typecast(Item *a, int length_arg, CHARSET_INFO *cs_arg)
+  Item_char_typecast(Item *a, int length_arg, const CHARSET_INFO * const cs_arg)
     :Item_typecast(a), cast_length(length_arg), cast_cs(cs_arg) {}
   enum Functype functype() const { return CHAR_TYPECAST_FUNC; }
   bool eq(const Item *item, bool binary_cmp) const;

=== modified file 'drizzled/key.cc'
--- drizzled/key.cc	2008-07-28 09:44:49 +0000
+++ drizzled/key.cc	2008-08-06 00:04:45 +0000
@@ -133,7 +133,7 @@
     {
       length= min(key_length, key_part->length);
       Field *field= key_part->field;
-      CHARSET_INFO *cs= field->charset();
+      const CHARSET_INFO * const cs= field->charset();
       uint bytes= field->get_key_image(to_key, length, Field::itRAW);
       if (bytes < length)
         cs->cset->fill(cs, (char*) to_key + bytes, length - bytes, ' ');
@@ -292,7 +292,7 @@
     if (!(key_part->key_type & (FIELDFLAG_NUMBER+FIELDFLAG_BINARY+
                                 FIELDFLAG_PACK)))
     {
-      CHARSET_INFO *cs= key_part->field->charset();
+      const CHARSET_INFO * const cs= key_part->field->charset();
       uint char_length= key_part->length / cs->mbmaxlen;
       const uchar *pos= table->record[0] + key_part->offset;
       if (length > char_length)
@@ -351,7 +351,7 @@
     }
     if ((field=key_part->field))
     {
-      CHARSET_INFO *cs= field->charset();
+      const CHARSET_INFO * const cs= field->charset();
       field->val_str(&tmp);
       if (cs->mbmaxlen > 1 &&
           table->field[key_part->fieldnr - 1]->field_length !=

=== modified file 'drizzled/log.cc'
--- drizzled/log.cc	2008-08-05 02:31:51 +0000
+++ drizzled/log.cc	2008-08-06 00:04:45 +0000
@@ -254,7 +254,7 @@
               uint user_host_len, int thread_id,
               const char *command_type, uint command_type_len,
               const char *sql_text, uint sql_text_len,
-              CHARSET_INFO *client_cs __attribute__((unused)))
+              const CHARSET_INFO * const client_cs __attribute__((unused)))
 {
   return mysql_log.write(event_time, user_host, user_host_len,
                          thread_id, command_type, command_type_len,

=== modified file 'drizzled/log.h'
--- drizzled/log.h	2008-08-01 04:24:45 +0000
+++ drizzled/log.h	2008-08-06 00:04:45 +0000
@@ -406,7 +406,7 @@
                            uint user_host_len, int thread_id,
                            const char *command_type, uint command_type_len,
                            const char *sql_text, uint sql_text_len,
-                           CHARSET_INFO *client_cs)= 0;
+                           const CHARSET_INFO * const client_cs)= 0;
   virtual ~Log_event_handler() {}
 };
 
@@ -437,7 +437,7 @@
                            uint user_host_len, int thread_id,
                            const char *command_type, uint command_type_len,
                            const char *sql_text, uint sql_text_len,
-                           CHARSET_INFO *client_cs);
+                           const CHARSET_INFO * const client_cs);
   void flush();
   void init_pthread_objects();
   MYSQL_QUERY_LOG *get_mysql_slow_log() { return &mysql_slow_log; }

=== modified file 'drizzled/log_event.cc'
--- drizzled/log_event.cc	2008-08-05 04:10:42 +0000
+++ drizzled/log_event.cc	2008-08-06 00:04:45 +0000
@@ -451,7 +451,7 @@
 */
 
 int
-append_query_string(CHARSET_INFO *csinfo,
+append_query_string(const CHARSET_INFO * const csinfo,
                     String const *from, String *to)
 {
   char *beg, *ptr;
@@ -2048,7 +2048,7 @@
       (unlikely(!print_event_info->charset_inited ||
                 memcmp(print_event_info->charset, charset, 6))))
   {
-    CHARSET_INFO *cs_info= get_charset(uint2korr(charset), MYF(MY_WME));
+    const CHARSET_INFO * const cs_info= get_charset(uint2korr(charset), MYF(MY_WME));
     if (cs_info)
     {
       /* for mysql client */
@@ -2252,7 +2252,7 @@
         thd->variables.lc_time_names= &my_locale_en_US;
       if (charset_database_number)
       {
-        CHARSET_INFO *cs;
+        const CHARSET_INFO *cs;
         if (!(cs= get_charset(charset_database_number, MYF(0))))
         {
           char buf[20];
@@ -4341,7 +4341,7 @@
       /* 15 is for 'COLLATE' and other chars */
       buf= (char*) my_malloc(event_len+val_len*2+1+2*MY_CS_NAME_SIZE+15,
                              MYF(MY_WME));
-      CHARSET_INFO *cs;
+      const CHARSET_INFO *cs;
       if (!buf)
         return;
       if (!(cs= get_charset(charset_number, MYF(0))))
@@ -4539,7 +4539,7 @@
         > according to UCS2.
       */
       char *hex_str;
-      CHARSET_INFO *cs;
+      const CHARSET_INFO *cs;
 
       if (!(hex_str= (char *)my_alloca(2*val_len+1+2))) // 2 hex digits / byte
         break; // no error, as we are 'void'
@@ -4581,7 +4581,7 @@
 int User_var_log_event::do_apply_event(Relay_log_info const *rli)
 {
   Item *it= 0;
-  CHARSET_INFO *charset;
+  const CHARSET_INFO *charset;
   if (!(charset= get_charset(charset_number, MYF(MY_WME))))
     return 1;
   LEX_STRING user_var_name;

=== modified file 'drizzled/log_event.h'
--- drizzled/log_event.h	2008-08-01 04:24:45 +0000
+++ drizzled/log_event.h	2008-08-06 00:04:45 +0000
@@ -3742,7 +3742,7 @@
   LEX_STRING m_message;
 };
 
-int append_query_string(CHARSET_INFO *csinfo,
+int append_query_string(const CHARSET_INFO * const csinfo,
                         String const *from, String *to);
 
 static inline bool copy_event_cache_to_file_and_reinit(IO_CACHE *cache,

=== modified file 'drizzled/my_decimal.cc'
--- drizzled/my_decimal.cc	2008-08-04 23:58:04 +0000
+++ drizzled/my_decimal.cc	2008-08-06 00:04:45 +0000
@@ -176,7 +176,7 @@
 */
 
 int str2my_decimal(uint mask, const char *from, uint length,
-                   CHARSET_INFO *charset, my_decimal *decimal_value)
+                   const CHARSET_INFO * charset, my_decimal *decimal_value)
 {
   char *end, *from_end;
   int err;

=== modified file 'drizzled/my_decimal.h'
--- drizzled/my_decimal.h	2008-07-31 18:25:59 +0000
+++ drizzled/my_decimal.h	2008-08-06 00:04:45 +0000
@@ -286,7 +286,7 @@
 
 
 int str2my_decimal(uint mask, const char *from, uint length,
-                   CHARSET_INFO *charset, my_decimal *decimal_value);
+                   const CHARSET_INFO * charset, my_decimal *decimal_value);
 
 #if defined(MYSQL_SERVER)
 inline

=== modified file 'drizzled/mysql_priv.h'
--- drizzled/mysql_priv.h	2008-08-04 23:58:04 +0000
+++ drizzled/mysql_priv.h	2008-08-06 00:04:45 +0000
@@ -100,8 +100,8 @@
 #define PREV_BITS(type,A)	((type) (((type) 1 << (A)) -1))
 #define all_bits_set(A,B) ((A) & (B) != (B))
 
-extern CHARSET_INFO *system_charset_info, *files_charset_info ;
-extern CHARSET_INFO *national_charset_info, *table_alias_charset;
+extern const CHARSET_INFO *system_charset_info, *files_charset_info ;
+extern const CHARSET_INFO *national_charset_info, *table_alias_charset;
 
 enum Derivation
 {
@@ -1000,7 +1000,7 @@
 		       Item *default_value, Item *on_update_value,
 		       LEX_STRING *comment,
 		       char *change, List<String> *interval_list,
-		       CHARSET_INFO *cs);
+		       const CHARSET_INFO * const cs);
 Create_field * new_create_field(THD *thd, char *field_name, enum_field_types type,
 				char *length, char *decimals,
 				uint type_modifier, 
@@ -1252,17 +1252,17 @@
 extern enum_field_types agg_field_type(Item **items, uint nitems);
 
 /* strfunc.cc */
-uint64_t find_set(TYPELIB *lib, const char *x, uint length, CHARSET_INFO *cs,
+uint64_t find_set(TYPELIB *lib, const char *x, uint length, const CHARSET_INFO * const cs,
 		   char **err_pos, uint *err_len, bool *set_warning);
 uint find_type(const TYPELIB *lib, const char *find, uint length,
                bool part_match);
 uint find_type2(const TYPELIB *lib, const char *find, uint length,
-                CHARSET_INFO *cs);
+                const CHARSET_INFO *cs);
 void unhex_type2(TYPELIB *lib);
 uint check_word(TYPELIB *lib, const char *val, const char *end,
 		const char **end_of_word);
 int find_string_in_array(LEX_STRING * const haystack, LEX_STRING * const needle,
-                         CHARSET_INFO * const cs);
+                         const CHARSET_INFO * const cs);
 
 
 bool is_keyword(const char *name, uint len);
@@ -1274,7 +1274,7 @@
 bool load_db_opt(THD *thd, const char *path, HA_CREATE_INFO *create);
 bool load_db_opt_by_name(THD *thd, const char *db_name,
                          HA_CREATE_INFO *db_create_info);
-CHARSET_INFO *get_default_db_collation(THD *thd, const char *db_name);
+const CHARSET_INFO *get_default_db_collation(THD *thd, const char *db_name);
 bool my_dbopt_init(void);
 void my_dbopt_cleanup(void);
 extern int creating_database; // How many database locks are made
@@ -1290,7 +1290,7 @@
 extern uint mysql_data_home_len;
 extern char *mysql_data_home,server_version[SERVER_VERSION_LENGTH],
             mysql_real_data_home[], mysql_unpacked_real_data_home[];
-extern CHARSET_INFO *character_set_filesystem;
+extern const CHARSET_INFO *character_set_filesystem;
 #endif /* MYSQL_SERVER || INNODB_COMPATIBILITY_HOOKS */
 #ifdef MYSQL_SERVER
 extern char *opt_mysql_tmpdir, mysql_charsets_dir[];
@@ -1631,8 +1631,8 @@
 /* Conversion functions */
 #endif /* MYSQL_SERVER */
 #if defined MYSQL_SERVER || defined INNODB_COMPATIBILITY_HOOKS
-uint strconvert(CHARSET_INFO *from_cs, const char *from,
-                CHARSET_INFO *to_cs, char *to, uint to_length, uint *errors);
+uint strconvert(const CHARSET_INFO * const from_cs, const char *from,
+                const CHARSET_INFO * const to_cs, char *to, uint to_length, uint *errors);
 uint filename_to_tablename(const char *from, char *to, uint to_length);
 uint tablename_to_filename(const char *from, char *to, uint to_length);
 #endif /* MYSQL_SERVER || INNODB_COMPATIBILITY_HOOKS */

=== modified file 'drizzled/object_creation_ctx.h'
--- drizzled/object_creation_ctx.h	2008-08-01 02:41:21 +0000
+++ drizzled/object_creation_ctx.h	2008-08-06 00:04:45 +0000
@@ -50,12 +50,12 @@
 class Default_object_creation_ctx : public Object_creation_ctx
 {
 public:
-  CHARSET_INFO *get_client_cs()
+  const CHARSET_INFO *get_client_cs()
   {
     return m_client_cs;
   }
 
-  CHARSET_INFO *get_connection_cl()
+  const CHARSET_INFO *get_connection_cl()
   {
     return m_connection_cl;
   }
@@ -63,8 +63,8 @@
 protected:
   Default_object_creation_ctx(THD *thd);
 
-  Default_object_creation_ctx(CHARSET_INFO *client_cs,
-                              CHARSET_INFO *connection_cl);
+  Default_object_creation_ctx(const CHARSET_INFO * const client_cs,
+                              const CHARSET_INFO * const connection_cl);
 
 protected:
   virtual Object_creation_ctx *create_backup_ctx(THD *thd) const;
@@ -81,7 +81,7 @@
     in order to parse the query properly we have to switch client character
     set on parsing.
   */
-  CHARSET_INFO *m_client_cs;
+  const CHARSET_INFO *m_client_cs;
 
   /**
     connection_cl stores the value of collation_connection session
@@ -91,7 +91,7 @@
     the character set and collation of text literals in internal
     representation of query (item-objects).
   */
-  CHARSET_INFO *m_connection_cl;
+  const CHARSET_INFO *m_connection_cl;
 };
 
 #endif /* DRIZZLE_SERVER_OBJECT_CREATION_CTX_H */

=== modified file 'drizzled/protocol.cc'
--- drizzled/protocol.cc	2008-08-05 20:48:36 +0000
+++ drizzled/protocol.cc	2008-08-06 00:04:45 +0000
@@ -66,7 +66,8 @@
 */
 
 bool Protocol::net_store_data(const uchar *from, size_t length,
-                              CHARSET_INFO *from_cs, CHARSET_INFO *to_cs)
+                              const CHARSET_INFO * const from_cs,
+							  const CHARSET_INFO * const to_cs)
 {
   uint dummy_errors;
   /* Calculate maxumum possible result length */
@@ -489,7 +490,7 @@
   String tmp((char*) buff,sizeof(buff),&my_charset_bin);
   Protocol_text prot(thd);
   String *local_packet= prot.storage_packet();
-  CHARSET_INFO *thd_charset= thd->variables.character_set_results;
+  const CHARSET_INFO * const thd_charset= thd->variables.character_set_results;
 
   if (flags & SEND_NUM_ROWS)
   {				// Packet with number of elements
@@ -500,7 +501,7 @@
   while ((item=it++))
   {
     char *pos;
-    CHARSET_INFO *cs= system_charset_info;
+    const CHARSET_INFO * const cs= system_charset_info;
     Send_field field;
     item->make_field(&field);
 
@@ -601,7 +602,7 @@
     1		error
 */
 
-bool Protocol::store(const char *from, CHARSET_INFO *cs)
+bool Protocol::store(const char *from, const CHARSET_INFO * const cs)
 {
   if (!from)
     return store_null();
@@ -661,7 +662,8 @@
 */
 
 bool Protocol::store_string_aux(const char *from, size_t length,
-                                CHARSET_INFO *fromcs, CHARSET_INFO *tocs)
+                                const CHARSET_INFO * const fromcs,
+								const CHARSET_INFO * const tocs)
 {
   /* 'tocs' is set 0 when client issues SET character_set_results=NULL */
   if (tocs && !my_charset_same(fromcs, tocs) &&
@@ -677,16 +679,17 @@
 
 
 bool Protocol_text::store(const char *from, size_t length,
-                          CHARSET_INFO *fromcs, CHARSET_INFO *tocs)
+                          const CHARSET_INFO * const fromcs,
+						  const CHARSET_INFO * const tocs)
 {
   return store_string_aux(from, length, fromcs, tocs);
 }
 
 
 bool Protocol_text::store(const char *from, size_t length,
-                          CHARSET_INFO *fromcs)
+                          const CHARSET_INFO * const fromcs)
 {
-  CHARSET_INFO *tocs= this->thd->variables.character_set_results;
+  const CHARSET_INFO * const tocs= this->thd->variables.character_set_results;
   return store_string_aux(from, length, fromcs, tocs);
 }
 
@@ -756,7 +759,7 @@
     return store_null();
   char buff[MAX_FIELD_WIDTH];
   String str(buff,sizeof(buff), &my_charset_bin);
-  CHARSET_INFO *tocs= this->thd->variables.character_set_results;
+  const CHARSET_INFO * const tocs= this->thd->variables.character_set_results;
 
   field->val_str(&str);
 

=== modified file 'drizzled/protocol.h'
--- drizzled/protocol.h	2008-07-31 18:25:59 +0000
+++ drizzled/protocol.h	2008-08-06 00:04:45 +0000
@@ -33,9 +33,9 @@
   uint field_count;
   bool net_store_data(const uchar *from, size_t length);
   bool net_store_data(const uchar *from, size_t length,
-                      CHARSET_INFO *fromcs, CHARSET_INFO *tocs);
+                      const CHARSET_INFO * const fromcs, const CHARSET_INFO * const tocs);
   bool store_string_aux(const char *from, size_t length,
-                        CHARSET_INFO *fromcs, CHARSET_INFO *tocs);
+                        const CHARSET_INFO * const fromcs, const CHARSET_INFO * const tocs);
 public:
   Protocol() {}
   Protocol(THD *thd_arg) { init(thd_arg); }
@@ -46,7 +46,7 @@
   virtual bool send_fields(List<Item> *list, uint flags);
 
   bool store(I_List<i_string> *str_list);
-  bool store(const char *from, CHARSET_INFO *cs);
+  bool store(const char *from, const CHARSET_INFO * const cs);
   String *storage_packet() { return packet; }
   inline void free() { packet->free(); }
   virtual bool write();
@@ -76,9 +76,9 @@
   virtual bool store_long(int64_t from)=0;
   virtual bool store_int64_t(int64_t from, bool unsigned_flag)=0;
   virtual bool store_decimal(const my_decimal *)=0;
-  virtual bool store(const char *from, size_t length, CHARSET_INFO *cs)=0;
+  virtual bool store(const char *from, size_t length, const CHARSET_INFO * const cs)=0;
   virtual bool store(const char *from, size_t length, 
-  		     CHARSET_INFO *fromcs, CHARSET_INFO *tocs)=0;
+                     const CHARSET_INFO * const fromcs, const CHARSET_INFO * const tocs)=0;
   virtual bool store(float from, uint32_t decimals, String *buffer)=0;
   virtual bool store(double from, uint32_t decimals, String *buffer)=0;
   virtual bool store(DRIZZLE_TIME *time)=0;
@@ -112,9 +112,9 @@
   virtual bool store_long(int64_t from);
   virtual bool store_int64_t(int64_t from, bool unsigned_flag);
   virtual bool store_decimal(const my_decimal *);
-  virtual bool store(const char *from, size_t length, CHARSET_INFO *cs);
+  virtual bool store(const char *from, size_t length, const CHARSET_INFO * const cs);
   virtual bool store(const char *from, size_t length,
-  		     CHARSET_INFO *fromcs, CHARSET_INFO *tocs);
+                     const CHARSET_INFO * const fromcs,  const CHARSET_INFO * const tocs);
   virtual bool store(DRIZZLE_TIME *time);
   virtual bool store_date(DRIZZLE_TIME *time);
   virtual bool store_time(DRIZZLE_TIME *time);

=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2008-08-04 23:58:04 +0000
+++ drizzled/set_var.cc	2008-08-06 00:04:45 +0000
@@ -59,7 +59,7 @@
 #include <storage/myisam/myisam.h>
 #include <drizzled/drizzled_error_messages.h>
 
-extern CHARSET_INFO *character_set_filesystem;
+extern const CHARSET_INFO *character_set_filesystem;
 
 
 static DYNAMIC_ARRAY fixed_show_vars;
@@ -1748,7 +1748,7 @@
   {	NULL			,	NULL		}
 };
 
-CHARSET_INFO *get_old_charset_by_name(const char *name)
+const CHARSET_INFO *get_old_charset_by_name(const char *name)
 {
   my_old_conv *conv;
  
@@ -1764,7 +1764,7 @@
 bool sys_var_collation::check(THD *thd __attribute__((unused)),
                               set_var *var)
 {
-  CHARSET_INFO *tmp;
+  const CHARSET_INFO *tmp;
 
   if (var->value->result_type() == STRING_RESULT)
   {
@@ -1799,7 +1799,7 @@
 bool sys_var_character_set::check(THD *thd __attribute__((unused)),
                                   set_var *var)
 {
-  CHARSET_INFO *tmp;
+  const CHARSET_INFO *tmp;
 
   if (var->value->result_type() == STRING_RESULT)
   {
@@ -1847,7 +1847,7 @@
 uchar *sys_var_character_set::value_ptr(THD *thd, enum_var_type type,
                                         LEX_STRING *base __attribute__((unused)))
 {
-  CHARSET_INFO *cs= ci_ptr(thd,type)[0];
+  const CHARSET_INFO * const cs= ci_ptr(thd,type)[0];
   return cs ? (uchar*) cs->csname : (uchar*) NULL;
 }
 
@@ -1862,7 +1862,7 @@
     thd->update_charset();
   }
 }
-CHARSET_INFO **sys_var_character_set_sv::ci_ptr(THD *thd, enum_var_type type)
+const CHARSET_INFO **sys_var_character_set_sv::ci_ptr(THD *thd, enum_var_type type)
 {
   if (type == OPT_GLOBAL)
     return &(global_system_variables.*offset);
@@ -1886,7 +1886,7 @@
 }
 
 
-CHARSET_INFO ** sys_var_character_set_database::ci_ptr(THD *thd,
+const CHARSET_INFO ** sys_var_character_set_database::ci_ptr(THD *thd,
 						       enum_var_type type)
 {
   if (type == OPT_GLOBAL)
@@ -1936,7 +1936,7 @@
 uchar *sys_var_collation_sv::value_ptr(THD *thd, enum_var_type type,
                                        LEX_STRING *base __attribute__((unused)))
 {
-  CHARSET_INFO *cs= ((type == OPT_GLOBAL) ?
+  const CHARSET_INFO *cs= ((type == OPT_GLOBAL) ?
 		     global_system_variables.*offset : thd->variables.*offset);
   return cs ? (uchar*) cs->name : (uchar*) "NULL";
 }

=== modified file 'drizzled/set_var.h'
--- drizzled/set_var.h	2008-07-26 18:02:40 +0000
+++ drizzled/set_var.h	2008-08-06 00:04:45 +0000
@@ -710,24 +710,24 @@
   bool update(THD *thd, set_var *var);
   uchar *value_ptr(THD *thd, enum_var_type type, LEX_STRING *base);
   virtual void set_default(THD *thd, enum_var_type type)= 0;
-  virtual CHARSET_INFO **ci_ptr(THD *thd, enum_var_type type)= 0;
+  virtual const CHARSET_INFO **ci_ptr(THD *thd, enum_var_type type)= 0;
 };
 
 class sys_var_character_set_sv :public sys_var_character_set
 {
-  CHARSET_INFO *SV::*offset;
-  CHARSET_INFO **global_default;
+  const CHARSET_INFO *SV::*offset;
+  const CHARSET_INFO **global_default;
 public:
   sys_var_character_set_sv(sys_var_chain *chain, const char *name_arg,
-			   CHARSET_INFO *SV::*offset_arg,
-			   CHARSET_INFO **global_default_arg,
+			   const CHARSET_INFO *SV::*offset_arg,
+			   const CHARSET_INFO **global_default_arg,
                            bool is_nullable= 0,
                            Binlog_status_enum binlog_status_arg= NOT_IN_BINLOG)
     : sys_var_character_set(name_arg, is_nullable, binlog_status_arg),
     offset(offset_arg), global_default(global_default_arg)
   { chain_sys_var(chain); }
   void set_default(THD *thd, enum_var_type type);
-  CHARSET_INFO **ci_ptr(THD *thd, enum_var_type type);
+  const CHARSET_INFO **ci_ptr(THD *thd, enum_var_type type);
 };
 
 
@@ -735,8 +735,8 @@
 {
 public:
   sys_var_character_set_client(sys_var_chain *chain, const char *name_arg,
-                               CHARSET_INFO *SV::*offset_arg,
-                               CHARSET_INFO **global_default_arg,
+                               const CHARSET_INFO *SV::*offset_arg,
+                               const CHARSET_INFO **global_default_arg,
                                Binlog_status_enum binlog_status_arg)
     : sys_var_character_set_sv(chain, name_arg, offset_arg, global_default_arg,
                                0, binlog_status_arg)
@@ -754,17 +754,17 @@
     : sys_var_character_set(name_arg, 0, binlog_status_arg)
   { chain_sys_var(chain); }
   void set_default(THD *thd, enum_var_type type);
-  CHARSET_INFO **ci_ptr(THD *thd, enum_var_type type);
+  const CHARSET_INFO **ci_ptr(THD *thd, enum_var_type type);
 };
 
 class sys_var_collation_sv :public sys_var_collation
 {
-  CHARSET_INFO *SV::*offset;
-  CHARSET_INFO **global_default;
+  const CHARSET_INFO *SV::*offset;
+  const CHARSET_INFO **global_default;
 public:
   sys_var_collation_sv(sys_var_chain *chain, const char *name_arg,
-		       CHARSET_INFO *SV::*offset_arg,
-                       CHARSET_INFO **global_default_arg,
+		       const CHARSET_INFO *SV::*offset_arg,
+                       const CHARSET_INFO **global_default_arg,
                        Binlog_status_enum binlog_status_arg= NOT_IN_BINLOG)
     :sys_var_collation(name_arg, binlog_status_arg),
     offset(offset_arg), global_default(global_default_arg)
@@ -1151,7 +1151,7 @@
   enum_var_type type;
   union
   {
-    CHARSET_INFO *charset;
+    const CHARSET_INFO *charset;
     ulong ulong_value;
     uint64_t uint64_t_value;
     plugin_ref plugin;
@@ -1203,13 +1203,13 @@
 
 class set_var_collation_client: public set_var_base
 {
-  CHARSET_INFO *character_set_client;
-  CHARSET_INFO *character_set_results;
-  CHARSET_INFO *collation_connection;
+  const CHARSET_INFO *character_set_client;
+  const CHARSET_INFO *character_set_results;
+  const CHARSET_INFO *collation_connection;
 public:
-  set_var_collation_client(CHARSET_INFO *client_coll_arg,
-  			   CHARSET_INFO *connection_coll_arg,
-  			   CHARSET_INFO *result_coll_arg)
+  set_var_collation_client(const CHARSET_INFO * const client_coll_arg,
+  			   const CHARSET_INFO * const connection_coll_arg,
+  			   const CHARSET_INFO * const result_coll_arg)
     :character_set_client(client_coll_arg),
      character_set_results(result_coll_arg),
      collation_connection(connection_coll_arg)
@@ -1286,7 +1286,7 @@
 extern sys_var_str sys_init_slave;
 extern sys_var_thd_time_zone sys_time_zone;
 extern sys_var_thd_bit sys_autocommit;
-CHARSET_INFO *get_old_charset_by_name(const char *old_name);
+const CHARSET_INFO *get_old_charset_by_name(const char *old_name);
 uchar* find_named(I_List<NAMED_LIST> *list, const char *name, uint length,
 		NAMED_LIST **found);
 

=== modified file 'drizzled/sql_alloc.h'
--- drizzled/sql_alloc.h	2008-08-01 04:24:45 +0000
+++ drizzled/sql_alloc.h	2008-08-06 00:04:45 +0000
@@ -24,9 +24,9 @@
 void *sql_memdup(const void * ptr, size_t size);
 void sql_element_free(void *ptr);
 char *sql_strmake_with_convert(const char *str, size_t arg_length,
-			       CHARSET_INFO *from_cs,
+			       const CHARSET_INFO * const from_cs,
 			       size_t max_res_length,
-			       CHARSET_INFO *to_cs, size_t *result_length);
+			       const CHARSET_INFO * const to_cs, size_t *result_length);
 void sql_kill(THD *thd, ulong id, bool only_kill_query);
 bool net_request_file(NET* net, const char* fname);
 char* query_table_status(THD *thd,const char *db,const char *table_name);

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2008-08-05 02:31:51 +0000
+++ drizzled/sql_base.cc	2008-08-06 00:04:45 +0000
@@ -1254,7 +1254,7 @@
         close_temporary(table, 1, 1);
       }
       thd->clear_error();
-      CHARSET_INFO *cs_save= thd->variables.character_set_client;
+      const CHARSET_INFO * const cs_save= thd->variables.character_set_client;
       thd->variables.character_set_client= system_charset_info;
       Query_log_event qinfo(thd, s_query.ptr(),
                             s_query.length() - 1 /* to remove trailing ',' */,

=== modified file 'drizzled/sql_class.cc'
--- drizzled/sql_class.cc	2008-08-05 02:31:51 +0000
+++ drizzled/sql_class.cc	2008-08-06 00:04:45 +0000
@@ -1045,9 +1045,9 @@
         In this case to->str will point to 0 and to->length will be 0.
 */
 
-bool THD::convert_string(LEX_STRING *to, CHARSET_INFO *to_cs,
+bool THD::convert_string(LEX_STRING *to, const CHARSET_INFO * const to_cs,
 			 const char *from, uint from_length,
-			 CHARSET_INFO *from_cs)
+			 const CHARSET_INFO * const from_cs)
 {
   size_t new_length= to_cs->mbmaxlen * from_length;
   uint dummy_errors;
@@ -1078,7 +1078,8 @@
    !0   out of memory
 */
 
-bool THD::convert_string(String *s, CHARSET_INFO *from_cs, CHARSET_INFO *to_cs)
+bool THD::convert_string(String *s, const CHARSET_INFO * const from_cs,
+                         const CHARSET_INFO * const to_cs)
 {
   uint dummy_errors;
   if (convert_buffer.copy(s->ptr(), s->length(), from_cs, to_cs, &dummy_errors))
@@ -1195,7 +1196,7 @@
 {
   List<Item> field_list;
   Item *item;
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
   field_list.push_back(new Item_return_int("id",3, DRIZZLE_TYPE_LONGLONG));
   field_list.push_back(new Item_empty_string("select_type", 19, cs));
   field_list.push_back(item= new Item_empty_string("table", NAME_CHAR_LEN, cs));
@@ -1726,9 +1727,9 @@
            escape_char != -1)
       {
         char *pos, *start, *end;
-        CHARSET_INFO *res_charset= res->charset();
-        CHARSET_INFO *character_set_client= thd->variables.
-                                            character_set_client;
+        const CHARSET_INFO * const res_charset= res->charset();
+        const CHARSET_INFO * const character_set_client= thd->variables.
+                                                            character_set_client;
         bool check_second_byte= (res_charset == &my_charset_bin) &&
                                  character_set_client->
                                  escape_with_backslash_is_dangerous;
@@ -2384,7 +2385,7 @@
 
 
 #ifdef INNODB_COMPATIBILITY_HOOKS
-extern "C" struct charset_info_st *thd_charset(MYSQL_THD thd)
+extern "C" const struct charset_info_st *thd_charset(MYSQL_THD thd)
 {
   return(thd->charset());
 }

=== modified file 'drizzled/sql_class.h'
--- drizzled/sql_class.h	2008-08-05 02:31:51 +0000
+++ drizzled/sql_class.h	2008-08-06 00:04:45 +0000
@@ -338,14 +338,14 @@
   plugin_ref table_plugin;
 
   /* Only charset part of these variables is sensible */
-  CHARSET_INFO  *character_set_filesystem;
-  CHARSET_INFO  *character_set_client;
-  CHARSET_INFO  *character_set_results;
+  const CHARSET_INFO  *character_set_filesystem;
+  const CHARSET_INFO  *character_set_client;
+  const CHARSET_INFO  *character_set_results;
 
   /* Both charset and collation parts of these variables are important */
-  CHARSET_INFO	*collation_server;
-  CHARSET_INFO	*collation_database;
-  CHARSET_INFO  *collation_connection;
+  const CHARSET_INFO	*collation_server;
+  const CHARSET_INFO	*collation_database;
+  const CHARSET_INFO  *collation_connection;
 
   /* Locale Support */
   MY_LOCALE *lc_time_names;
@@ -1387,7 +1387,7 @@
   */
   table_map  used_tables;
   USER_CONN *user_connect;
-  CHARSET_INFO *db_charset;
+  const CHARSET_INFO *db_charset;
   /*
     FIXME: this, and some other variables like 'count_cuted_fields'
     maybe should be statement/cursor local, that is, moved to Statement
@@ -1686,11 +1686,11 @@
                               const char* str, uint length,
                               bool allocate_lex_string);
 
-  bool convert_string(LEX_STRING *to, CHARSET_INFO *to_cs,
+  bool convert_string(LEX_STRING *to, const CHARSET_INFO * const to_cs,
 		      const char *from, uint from_length,
-		      CHARSET_INFO *from_cs);
+		      const CHARSET_INFO * const from_cs);
 
-  bool convert_string(String *s, CHARSET_INFO *from_cs, CHARSET_INFO *to_cs);
+  bool convert_string(String *s, const CHARSET_INFO * const from_cs, const CHARSET_INFO * const to_cs);
 
   void add_changed_table(TABLE *table);
   void add_changed_table(const char *key, long key_length);
@@ -1737,7 +1737,7 @@
     To raise this flag, use my_error().
   */
   inline bool is_error() const { return main_da.is_error(); }
-  inline CHARSET_INFO *charset() { return variables.character_set_client; }
+  inline const CHARSET_INFO *charset() { return variables.character_set_client; }
   void update_charset();
 
   void change_item_tree(Item **place, Item *new_value)
@@ -1968,7 +1968,7 @@
   bool opt_enclosed;
   bool dumpfile;
   ulong skip_lines;
-  CHARSET_INFO *cs;
+  const CHARSET_INFO *cs;
   sql_exchange(char *name, bool dumpfile_flag,
                enum_filetype filetype_arg= FILETYPE_CSV);
 };
@@ -2225,7 +2225,7 @@
   bool  using_indirect_summary_function;
   /* If >0 convert all blob fields to varchar(convert_blob_length) */
   uint  convert_blob_length; 
-  CHARSET_INFO *table_charset; 
+  const CHARSET_INFO *table_charset; 
   bool schema_table;
   /*
     True if GROUP BY and its aggregate functions are already computed

=== modified file 'drizzled/sql_db.cc'
--- drizzled/sql_db.cc	2008-08-05 02:31:51 +0000
+++ drizzled/sql_db.cc	2008-08-06 00:04:45 +0000
@@ -35,7 +35,7 @@
 static bool rm_dir_w_symlink(const char *org_path, bool send_error);
 static void mysql_change_db_impl(THD *thd,
                                  LEX_STRING *new_db_name,
-                                 CHARSET_INFO *new_db_charset);
+                                 const CHARSET_INFO * const new_db_charset);
 
 
 /* Database lock hash */
@@ -102,7 +102,7 @@
 {
   char *name;			/* Database name                  */
   uint name_length;		/* Database length name           */
-  CHARSET_INFO *charset;	/* Database default character set */
+  const CHARSET_INFO *charset;	/* Database default character set */
 } my_dbopt_t;
 
 
@@ -506,7 +506,7 @@
     set, even if the database does not exist.
 */
 
-CHARSET_INFO *get_default_db_collation(THD *thd, const char *db_name)
+const CHARSET_INFO *get_default_db_collation(THD *thd, const char *db_name)
 {
   HA_CREATE_INFO db_info;
 
@@ -1129,7 +1129,7 @@
 
 static void mysql_change_db_impl(THD *thd,
                                  LEX_STRING *new_db_name,
-                                 CHARSET_INFO *new_db_charset)
+                                 const CHARSET_INFO * const new_db_charset)
 {
   /* 1. Change current database in THD. */
 
@@ -1294,7 +1294,7 @@
 bool mysql_change_db(THD *thd, const LEX_STRING *new_db_name, bool force_switch)
 {
   LEX_STRING new_db_file_name;
-  CHARSET_INFO *db_default_cl;
+  const CHARSET_INFO *db_default_cl;
 
   if (new_db_name == NULL ||
       new_db_name->length == 0)

=== modified file 'drizzled/sql_lex.cc'
--- drizzled/sql_lex.cc	2008-07-30 19:19:13 +0000
+++ drizzled/sql_lex.cc	2008-08-06 00:04:45 +0000
@@ -245,7 +245,7 @@
 
 void Lex_input_stream::body_utf8_append_literal(THD *thd,
                                                 const LEX_STRING *txt,
-                                                CHARSET_INFO *txt_cs,
+                                                const CHARSET_INFO * const txt_cs,
                                                 const char *end_ptr)
 {
   if (!m_cpp_utf8_processed_ptr)
@@ -479,7 +479,7 @@
 {
   register uchar c,sep;
   uint found_escape=0;
-  CHARSET_INFO *cs= lip->m_thd->charset();
+  const CHARSET_INFO * const cs= lip->m_thd->charset();
 
   lip->tok_bitmap= 0;
   sep= lip->yyGetLast();                        // String should end with this
@@ -765,7 +765,7 @@
   Lex_input_stream *lip= thd->m_lip;
   LEX *lex= thd->lex;
   YYSTYPE *yylval=(YYSTYPE*) arg;
-  CHARSET_INFO *cs= thd->charset();
+  const CHARSET_INFO * const cs= thd->charset();
   uchar *state_map= cs->state_map;
   uchar *ident_map= cs->ident_map;
 
@@ -911,8 +911,8 @@
 
       if (yylval->lex_str.str[0] == '_')
       {
-        CHARSET_INFO *cs= get_charset_by_csname(yylval->lex_str.str + 1,
-                                                MY_CS_PRIMARY, MYF(0));
+        const CHARSET_INFO * const cs= get_charset_by_csname(yylval->lex_str.str + 1,
+                                                             MY_CS_PRIMARY, MYF(0));
         if (cs)
         {
           yylval->charset= cs;
@@ -1475,7 +1475,7 @@
 }
 
 
-void trim_whitespace(CHARSET_INFO *cs, LEX_STRING *str)
+void trim_whitespace(const CHARSET_INFO * const cs, LEX_STRING *str)
 {
   /*
     TODO:

=== modified file 'drizzled/sql_lex.h'
--- drizzled/sql_lex.h	2008-08-01 22:38:22 +0000
+++ drizzled/sql_lex.h	2008-08-06 00:04:45 +0000
@@ -1244,7 +1244,7 @@
   void body_utf8_append(const char *ptr, const char *end_ptr);
   void body_utf8_append_literal(THD *thd,
                                 const LEX_STRING *txt,
-                                CHARSET_INFO *txt_cs,
+                                const CHARSET_INFO * const txt_cs,
                                 const char *end_ptr);
 
   /** Current thread. */
@@ -1367,7 +1367,7 @@
 
     NOTE: this member must be used within MYSQLlex() function only.
   */
-  CHARSET_INFO *m_underscore_cs;
+  const CHARSET_INFO *m_underscore_cs;
 };
 
 
@@ -1400,7 +1400,7 @@
   DYNAMIC_ARRAY plugins;
   plugin_ref plugins_static_buffer[INITIAL_LEX_PLUGIN_LIST_SIZE];
 
-  CHARSET_INFO *charset;
+  const CHARSET_INFO *charset;
   bool text_string_is_7bit;
   /* store original leaf_tables for INSERT SELECT and PS/SP */
   TABLE_LIST *leaf_tables_insert;
@@ -1616,7 +1616,7 @@
 extern void lex_start(THD *thd);
 extern void lex_end(LEX *lex);
 
-extern void trim_whitespace(CHARSET_INFO *cs, LEX_STRING *str);
+extern void trim_whitespace(const CHARSET_INFO * const cs, LEX_STRING *str);
 
 extern bool is_lex_native_function(const LEX_STRING *name);
 

=== modified file 'drizzled/sql_load.cc'
--- drizzled/sql_load.cc	2008-08-05 02:31:51 +0000
+++ drizzled/sql_load.cc	2008-08-06 00:04:45 +0000
@@ -58,9 +58,9 @@
   bool error,line_cuted,found_null,enclosed;
   uchar	*row_start,			/* Found row starts here */
 	*row_end;			/* Found row ends here */
-  CHARSET_INFO *read_charset;
+  const CHARSET_INFO *read_charset;
 
-  READ_INFO(File file,uint tot_length,CHARSET_INFO *cs,
+  READ_INFO(File file,uint tot_length, const CHARSET_INFO * const cs,
 	    String &field_term,String &line_start,String &line_term,
 	    String &enclosed,int escape,bool get_it_from_net, bool is_fifo);
   ~READ_INFO();
@@ -846,7 +846,7 @@
   Item *item;
   TABLE *table= table_list->table;
   bool no_trans_update_stmt;
-  CHARSET_INFO *cs= read_info.read_charset;
+  const CHARSET_INFO * const cs= read_info.read_charset;
 
   no_trans_update_stmt= !table->file->has_transactions();
 
@@ -1000,7 +1000,7 @@
 */
 
 
-READ_INFO::READ_INFO(File file_par, uint tot_length, CHARSET_INFO *cs,
+READ_INFO::READ_INFO(File file_par, uint tot_length, const CHARSET_INFO * const cs,
 		     String &field_term, String &line_start, String &line_term,
 		     String &enclosed_par, int escape, bool get_it_from_net,
 		     bool is_fifo)

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2008-08-05 02:31:51 +0000
+++ drizzled/sql_parse.cc	2008-08-06 00:04:45 +0000
@@ -3046,7 +3046,7 @@
 		       Item *default_value, Item *on_update_value,
                        LEX_STRING *comment,
 		       char *change,
-                       List<String> *interval_list, CHARSET_INFO *cs)
+                       List<String> *interval_list, const CHARSET_INFO * const cs)
 {
   register Create_field *new_field;
   LEX  *lex= thd->lex;
@@ -4401,7 +4401,7 @@
 
 
 bool check_string_char_length(LEX_STRING *str, const char *err_msg,
-                              uint max_char_length, CHARSET_INFO *cs,
+                              uint max_char_length, const CHARSET_INFO * const cs,
                               bool no_error)
 {
   int well_formed_error;
@@ -4426,9 +4426,9 @@
     so they should be prohibited until such support is done.
     This is why we use the 3-byte utf8 to check well-formedness here.
   */
-  CHARSET_INFO *cs= &my_charset_utf8mb3_general_ci;
+  const CHARSET_INFO * const cs= &my_charset_utf8mb3_general_ci;
 #else
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
 #endif
   int well_formed_error;
   uint res= cs->cset->well_formed_len(cs, str->str, str->str + str->length,

=== modified file 'drizzled/sql_parse.h'
--- drizzled/sql_parse.h	2008-08-01 04:24:45 +0000
+++ drizzled/sql_parse.h	2008-08-06 00:04:45 +0000
@@ -53,7 +53,7 @@
 bool check_string_byte_length(LEX_STRING *str, const char *err_msg,
                               uint max_byte_length);
 bool check_string_char_length(LEX_STRING *str, const char *err_msg,
-                              uint max_char_length, CHARSET_INFO *cs,
+                              uint max_char_length, const CHARSET_INFO * const cs,
                               bool no_error);
 
 #endif /* DRIZZLE_SERVER_SQL_PARSE_H */

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2008-08-05 02:31:51 +0000
+++ drizzled/sql_select.cc	2008-08-06 00:04:45 +0000
@@ -8663,7 +8663,7 @@
 
       if (field_item->result_type() == STRING_RESULT)
       {
-        CHARSET_INFO *cs= ((Field_str*) field_item->field)->charset();
+        const CHARSET_INFO * const cs= ((Field_str*) field_item->field)->charset();
         if (!item)
         {
           Item_func_eq *eq_item;
@@ -17632,7 +17632,7 @@
   THD *thd=join->thd;
   select_result *result=join->result;
   Item *item_null= new Item_null();
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
   int quick_type;
   /* Don't log this into the slow query log */
   thd->server_status&= ~(SERVER_QUERY_NO_INDEX_USED | SERVER_QUERY_NO_GOOD_INDEX_USED);

=== modified file 'drizzled/sql_show.cc'
--- drizzled/sql_show.cc	2008-08-05 06:19:05 +0000
+++ drizzled/sql_show.cc	2008-08-06 00:04:45 +0000
@@ -32,7 +32,7 @@
 
 
 
-int wild_case_compare(CHARSET_INFO *cs, const char *str,const char *wildstr)
+int wild_case_compare(const CHARSET_INFO * const cs, const char *str,const char *wildstr)
 {
   register int flag;
   while (*wildstr)
@@ -88,7 +88,7 @@
   TABLE *table= (TABLE*) arg;
   struct st_mysql_plugin *plug= plugin_decl(plugin);
   struct st_plugin_dl *plugin_dl= plugin_dlib(plugin);
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
 
   restore_record(table, s->default_values);
 
@@ -1219,7 +1219,7 @@
                             COND* cond __attribute__((unused)))
 {
   TABLE *table= tables->table;
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
   char *user;
   time_t now= my_time(0);
 
@@ -1751,7 +1751,7 @@
     char tmp[MAX_FIELD_WIDTH];
     String *tmp_str, str_buff(tmp, sizeof(tmp), system_charset_info);
     Item_field *item_field;
-    CHARSET_INFO *cs= system_charset_info;
+    const CHARSET_INFO * const cs= system_charset_info;
 
     if (item_func->arguments()[0]->type() == Item::FIELD_ITEM &&
         item_func->arguments()[1]->const_item())
@@ -1865,7 +1865,7 @@
   else if (item->type() == Item::FIELD_ITEM)
   {
     Item_field *item_field= (Item_field*)item;
-    CHARSET_INFO *cs= system_charset_info;
+    const CHARSET_INFO * const cs= system_charset_info;
     ST_SCHEMA_TABLE *schema_table= table->schema_table;
     ST_FIELD_INFO *field_info= schema_table->fields_info;
     const char *field_name1= schema_table->idx_field1 >= 0 ?
@@ -2724,7 +2724,7 @@
 
 
 bool store_schema_shemata(THD* thd, TABLE *table, LEX_STRING *db_name,
-                          CHARSET_INFO *cs)
+                          const CHARSET_INFO * const cs)
 {
   restore_record(table, s->default_values);
   table->field[1]->store(db_name->str, db_name->length, system_charset_info);
@@ -2801,7 +2801,7 @@
 {
   const char *tmp_buff;
   DRIZZLE_TIME time;
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
 
   restore_record(table, s->default_values);
   table->field[1]->store(db_name->str, db_name->length, cs);
@@ -2998,7 +2998,7 @@
   @return         void
 */
 
-void store_column_type(TABLE *table, Field *field, CHARSET_INFO *cs,
+void store_column_type(TABLE *table, Field *field, const CHARSET_INFO * const cs,
                        uint offset)
 {
   bool is_blob;
@@ -3093,7 +3093,7 @@
 {
   LEX *lex= thd->lex;
   const char *wild= lex->wild ? lex->wild->ptr() : NullS;
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
   TABLE *show_table;
   TABLE_SHARE *show_table_share;
   Field **ptr, *field, *timestamp_field;
@@ -3224,16 +3224,16 @@
   CHARSET_INFO **cs;
   const char *wild= thd->lex->wild ? thd->lex->wild->ptr() : NullS;
   TABLE *table= tables->table;
-  CHARSET_INFO *scs= system_charset_info;
+  const CHARSET_INFO * const scs= system_charset_info;
 
   for (cs= all_charsets ; cs < all_charsets+255 ; cs++)
   {
-    CHARSET_INFO *tmp_cs= cs[0];
+    const CHARSET_INFO * const tmp_cs= cs[0];
     if (tmp_cs && (tmp_cs->state & MY_CS_PRIMARY) && 
         (tmp_cs->state & MY_CS_AVAILABLE) &&
         !(tmp_cs->state & MY_CS_HIDDEN) &&
         !(wild && wild[0] &&
-	  wild_case_compare(scs, tmp_cs->csname,wild)))
+          wild_case_compare(scs, tmp_cs->csname,wild)))
     {
       const char *comment;
       restore_record(table, s->default_values);
@@ -3255,33 +3255,33 @@
   CHARSET_INFO **cs;
   const char *wild= thd->lex->wild ? thd->lex->wild->ptr() : NullS;
   TABLE *table= tables->table;
-  CHARSET_INFO *scs= system_charset_info;
+  const CHARSET_INFO * const scs= system_charset_info;
   for (cs= all_charsets ; cs < all_charsets+255 ; cs++ )
   {
     CHARSET_INFO **cl;
-    CHARSET_INFO *tmp_cs= cs[0];
+    const CHARSET_INFO *tmp_cs= cs[0];
     if (!tmp_cs || !(tmp_cs->state & MY_CS_AVAILABLE) ||
          (tmp_cs->state & MY_CS_HIDDEN) ||
         !(tmp_cs->state & MY_CS_PRIMARY))
       continue;
     for (cl= all_charsets; cl < all_charsets+255 ;cl ++)
     {
-      CHARSET_INFO *tmp_cl= cl[0];
+      const CHARSET_INFO *tmp_cl= cl[0];
       if (!tmp_cl || !(tmp_cl->state & MY_CS_AVAILABLE) || 
           !my_charset_same(tmp_cs, tmp_cl))
-	continue;
+        continue;
       if (!(wild && wild[0] &&
-	  wild_case_compare(scs, tmp_cl->name,wild)))
+          wild_case_compare(scs, tmp_cl->name,wild)))
       {
-	const char *tmp_buff;
-	restore_record(table, s->default_values);
-	table->field[0]->store(tmp_cl->name, strlen(tmp_cl->name), scs);
+        const char *tmp_buff;
+        restore_record(table, s->default_values);
+        table->field[0]->store(tmp_cl->name, strlen(tmp_cl->name), scs);
         table->field[1]->store(tmp_cl->csname , strlen(tmp_cl->csname), scs);
         table->field[2]->store((int64_t) tmp_cl->number, true);
         tmp_buff= (tmp_cl->state & MY_CS_PRIMARY) ? "Yes" : "";
-	table->field[3]->store(tmp_buff, strlen(tmp_buff), scs);
+        table->field[3]->store(tmp_buff, strlen(tmp_buff), scs);
         tmp_buff= (tmp_cl->state & MY_CS_COMPILED)? "Yes" : "";
-	table->field[4]->store(tmp_buff, strlen(tmp_buff), scs);
+        table->field[4]->store(tmp_buff, strlen(tmp_buff), scs);
         table->field[5]->store((int64_t) tmp_cl->strxfrm_multiply, true);
         if (schema_table_store_record(thd, table))
           return 1;
@@ -3296,17 +3296,17 @@
 {
   CHARSET_INFO **cs;
   TABLE *table= tables->table;
-  CHARSET_INFO *scs= system_charset_info;
+  const CHARSET_INFO * const scs= system_charset_info;
   for (cs= all_charsets ; cs < all_charsets+255 ; cs++ )
   {
     CHARSET_INFO **cl;
-    CHARSET_INFO *tmp_cs= cs[0];
+    const CHARSET_INFO *tmp_cs= cs[0];
     if (!tmp_cs || !(tmp_cs->state & MY_CS_AVAILABLE) || 
         !(tmp_cs->state & MY_CS_PRIMARY))
       continue;
     for (cl= all_charsets; cl < all_charsets+255 ;cl ++)
     {
-      CHARSET_INFO *tmp_cl= cl[0];
+      const CHARSET_INFO *tmp_cl= cl[0];
       if (!tmp_cl || !(tmp_cl->state & MY_CS_AVAILABLE) || 
           !my_charset_same(tmp_cs,tmp_cl))
 	continue;
@@ -3326,7 +3326,7 @@
 				  LEX_STRING *db_name,
 				  LEX_STRING *table_name)
 {
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
   if (res)
   {
     if (thd->lex->sql_command != SQLCOM_SHOW_KEYS)
@@ -3422,7 +3422,7 @@
                        LEX_STRING *table_name, const char *key_name,
                        uint key_len, const char *con_type, uint con_len)
 {
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
   restore_record(table, s->default_values);
   table->field[1]->store(db_name->str, db_name->length, cs);
   table->field[2]->store(key_name, key_len, cs);
@@ -3497,7 +3497,7 @@
                             uint key_len, const char *con_type, uint con_len,
                             int64_t idx)
 {
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
   table->field[1]->store(db_name->str, db_name->length, cs);
   table->field[2]->store(key_name, key_len, cs);
   table->field[4]->store(db_name->str, db_name->length, cs);
@@ -3600,7 +3600,7 @@
 {
   const char *wild= thd->lex->wild ? thd->lex->wild->ptr() : NullS;
   TABLE *table= tables->table;
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
   OPEN_TABLE_LIST *open_list;
   if (!(open_list=list_open_tables(thd,thd->lex->select_lex.db, wild))
             && thd->is_fatal_error)
@@ -3708,7 +3708,7 @@
                                    TABLE *table, bool res,
                                    LEX_STRING *db_name, LEX_STRING *table_name)
 {
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
 
   if (res)
   {
@@ -3864,7 +3864,7 @@
   List<Item> field_list;
   ST_SCHEMA_TABLE *schema_table= table_list->schema_table;
   ST_FIELD_INFO *fields_info= schema_table->fields_info;
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
 
   for (; fields_info->field_name; fields_info++)
   {

=== modified file 'drizzled/sql_string.cc'
--- drizzled/sql_string.cc	2008-08-05 02:31:51 +0000
+++ drizzled/sql_string.cc	2008-08-06 00:04:45 +0000
@@ -91,7 +91,7 @@
   return false;
 }
 
-bool String::set_int(int64_t num, bool unsigned_flag, CHARSET_INFO *cs)
+bool String::set_int(int64_t num, bool unsigned_flag, const CHARSET_INFO * const cs)
 {
   uint l=20*cs->mbmaxlen+1;
   int base= unsigned_flag ? 10 : -10;
@@ -103,7 +103,7 @@
   return false;
 }
 
-bool String::set_real(double num,uint decimals, CHARSET_INFO *cs)
+bool String::set_real(double num,uint decimals, const CHARSET_INFO * const cs)
 {
   char buff[FLOATING_POINT_BUFFER];
   uint dummy_errors;
@@ -142,7 +142,7 @@
   return false;
 }
 
-bool String::copy(const char *str,uint32_t arg_length, CHARSET_INFO *cs)
+bool String::copy(const char *str,uint32_t arg_length, const CHARSET_INFO * const cs)
 {
   if (alloc(arg_length))
     return true;
@@ -177,8 +177,8 @@
 */
 
 bool String::needs_conversion(uint32_t arg_length,
-			      CHARSET_INFO *from_cs,
-			      CHARSET_INFO *to_cs,
+			      const CHARSET_INFO * const from_cs,
+			      const CHARSET_INFO * const to_cs,
 			      uint32_t *offset)
 {
   *offset= 0;
@@ -219,7 +219,7 @@
 */
 
 bool String::copy_aligned(const char *str,uint32_t arg_length, uint32_t offset,
-			  CHARSET_INFO *cs)
+                          const CHARSET_INFO * const cs)
 {
   /* How many bytes are in incomplete character */
   offset= cs->mbmaxlen - offset; /* How many zeros we should prepend */
@@ -245,7 +245,7 @@
 
 
 bool String::set_or_copy_aligned(const char *str,uint32_t arg_length,
-				 CHARSET_INFO *cs)
+                                 const CHARSET_INFO * const cs)
 {
   /* How many bytes are in incomplete character */
   uint32_t offset= (arg_length % cs->mbminlen); 
@@ -261,7 +261,8 @@
 	/* Copy with charset conversion */
 
 bool String::copy(const char *str, uint32_t arg_length,
-		  CHARSET_INFO *from_cs, CHARSET_INFO *to_cs, uint *errors)
+		          const CHARSET_INFO * const from_cs,
+				  const CHARSET_INFO * const to_cs, uint *errors)
 {
   uint32_t offset;
   if (!needs_conversion(arg_length, from_cs, to_cs, &offset))
@@ -400,7 +401,7 @@
   with character set recoding
 */
 
-bool String::append(const char *s,uint32_t arg_length, CHARSET_INFO *cs)
+bool String::append(const char *s,uint32_t arg_length, const CHARSET_INFO * const cs)
 {
   uint32_t dummy_offset;
   
@@ -628,7 +629,7 @@
 */
 
 
-int sortcmp(const String *s,const String *t, CHARSET_INFO *cs)
+int sortcmp(const String *s,const String *t, const CHARSET_INFO * const cs)
 {
  return cs->coll->strnncollsp(cs,
                               (uchar *) s->ptr(),s->length(),
@@ -704,9 +705,10 @@
 
 
 static uint32_t
-copy_and_convert_extended(char *to, uint32_t to_length, CHARSET_INFO *to_cs, 
+copy_and_convert_extended(char *to, uint32_t to_length,
+                          const CHARSET_INFO * const to_cs, 
                           const char *from, uint32_t from_length,
-                          CHARSET_INFO *from_cs,
+                          const CHARSET_INFO * const from_cs,
                           uint *errors)
 {
   int         cnvres;
@@ -763,9 +765,9 @@
   Optimized for quick copying of ASCII characters in the range 0x00..0x7F.
 */
 uint32_t
-copy_and_convert(char *to, uint32_t to_length, CHARSET_INFO *to_cs, 
-                 const char *from, uint32_t from_length, CHARSET_INFO *from_cs,
-                 uint *errors)
+copy_and_convert(char *to, uint32_t to_length, const CHARSET_INFO * const to_cs, 
+                 const char *from, uint32_t from_length,
+				 const CHARSET_INFO * const from_cs, uint *errors)
 {
   /*
     If any of the character sets is not ASCII compatible,
@@ -839,7 +841,7 @@
 */
 
 size_t
-my_copy_with_hex_escaping(CHARSET_INFO *cs,
+my_copy_with_hex_escaping(const CHARSET_INFO * const cs,
                           char *dst, size_t dstlen,
                           const char *src, size_t srclen)
 {
@@ -908,9 +910,9 @@
 
 
 uint32_t
-well_formed_copy_nchars(CHARSET_INFO *to_cs,
+well_formed_copy_nchars(const CHARSET_INFO * const to_cs,
                         char *to, uint to_length,
-                        CHARSET_INFO *from_cs,
+                        const CHARSET_INFO * const from_cs,
                         const char *from, uint from_length,
                         uint nchars,
                         const char **well_formed_error_pos,
@@ -1086,5 +1088,5 @@
   swap_variables(uint32_t, str_length, s.str_length);
   swap_variables(uint32_t, Alloced_length, s.Alloced_length);
   swap_variables(bool, alloced, s.alloced);
-  swap_variables(CHARSET_INFO*, str_charset, s.str_charset);
+  swap_variables(const CHARSET_INFO *, str_charset, s.str_charset);
 }

=== modified file 'drizzled/sql_string.h'
--- drizzled/sql_string.h	2008-08-05 02:31:51 +0000
+++ drizzled/sql_string.h	2008-08-06 00:04:45 +0000
@@ -27,20 +27,20 @@
 #endif
 
 class String;
-int sortcmp(const String *a,const String *b, CHARSET_INFO *cs);
+int sortcmp(const String *a,const String *b, const CHARSET_INFO * const cs);
 String *copy_if_not_alloced(String *a,String *b,uint32_t arg_length);
-uint32_t copy_and_convert(char *to, uint32_t to_length, CHARSET_INFO *to_cs,
+uint32_t copy_and_convert(char *to, uint32_t to_length, const CHARSET_INFO * const to_cs,
 			const char *from, uint32_t from_length,
-			CHARSET_INFO *from_cs, uint *errors);
-uint32_t well_formed_copy_nchars(CHARSET_INFO *to_cs,
+			const CHARSET_INFO * const from_cs, uint *errors);
+uint32_t well_formed_copy_nchars(const CHARSET_INFO * const to_cs,
                                char *to, uint to_length,
-                               CHARSET_INFO *from_cs,
+                               const CHARSET_INFO * const from_cs,
                                const char *from, uint from_length,
                                uint nchars,
                                const char **well_formed_error_pos,
                                const char **cannot_convert_error_pos,
                                const char **from_end_pos);
-size_t my_copy_with_hex_escaping(CHARSET_INFO *cs,
+size_t my_copy_with_hex_escaping(const CHARSET_INFO * const cs,
                                  char *dst, size_t dstlen,
                                  const char *src, size_t srclen);
 
@@ -49,7 +49,7 @@
   char *Ptr;
   uint32_t str_length,Alloced_length;
   bool alloced;
-  CHARSET_INFO *str_charset;
+  const CHARSET_INFO *str_charset;
 public:
   String()
   { 
@@ -61,17 +61,17 @@
     alloced=0; Alloced_length=0; (void) real_alloc(length_arg); 
     str_charset= &my_charset_bin;
   }
-  String(const char *str, CHARSET_INFO *cs)
+  String(const char *str, const CHARSET_INFO * const cs)
   { 
     Ptr=(char*) str; str_length=(uint) strlen(str); Alloced_length=0; alloced=0;
     str_charset=cs;
   }
-  String(const char *str,uint32_t len, CHARSET_INFO *cs)
+  String(const char *str,uint32_t len, const CHARSET_INFO * const cs)
   { 
     Ptr=(char*) str; str_length=len; Alloced_length=0; alloced=0;
     str_charset=cs;
   }
-  String(char *str,uint32_t len, CHARSET_INFO *cs)
+  String(char *str,uint32_t len, const CHARSET_INFO * const cs)
   { 
     Ptr=(char*) str; Alloced_length=str_length=len; alloced=0;
     str_charset=cs;
@@ -92,9 +92,9 @@
   { /* never called */ }
   ~String() { free(); }
 
-  inline void set_charset(CHARSET_INFO *charset_arg)
+  inline void set_charset(const CHARSET_INFO * const charset_arg)
   { str_charset= charset_arg; }
-  inline CHARSET_INFO *charset() const { return str_charset; }
+  inline const CHARSET_INFO *charset() const { return str_charset; }
   inline uint32_t length() const { return str_length;}
   inline uint32_t alloced_length() const { return Alloced_length;}
   inline char& operator [] (uint32_t i) const { return Ptr[i]; }
@@ -135,20 +135,20 @@
       Alloced_length=0;
     str_charset=str.str_charset;
   }
-  inline void set(char *str,uint32_t arg_length, CHARSET_INFO *cs)
+  inline void set(char *str,uint32_t arg_length, const CHARSET_INFO * const cs)
   {
     free();
     Ptr=(char*) str; str_length=Alloced_length=arg_length ; alloced=0;
     str_charset=cs;
   }
-  inline void set(const char *str,uint32_t arg_length, CHARSET_INFO *cs)
+  inline void set(const char *str,uint32_t arg_length, const CHARSET_INFO * const cs)
   {
     free();
     Ptr=(char*) str; str_length=arg_length; Alloced_length=0 ; alloced=0;
     str_charset=cs;
   }
   bool set_ascii(const char *str, uint32_t arg_length);
-  inline void set_quick(char *str,uint32_t arg_length, CHARSET_INFO *cs)
+  inline void set_quick(char *str,uint32_t arg_length, const CHARSET_INFO * const cs)
   {
     if (!alloced)
     {
@@ -156,12 +156,12 @@
     }
     str_charset=cs;
   }
-  bool set_int(int64_t num, bool unsigned_flag, CHARSET_INFO *cs);
-  bool set(int64_t num, CHARSET_INFO *cs)
+  bool set_int(int64_t num, bool unsigned_flag, const CHARSET_INFO * const cs);
+  bool set(int64_t num, const CHARSET_INFO * const cs)
   { return set_int(num, false, cs); }
-  bool set(uint64_t num, CHARSET_INFO *cs)
+  bool set(uint64_t num, const CHARSET_INFO * const cs)
   { return set_int((int64_t)num, true, cs); }
-  bool set_real(double num,uint decimals, CHARSET_INFO *cs);
+  bool set_real(double num,uint decimals, const CHARSET_INFO * const cs);
 
   /*
     PMG 2004.11.12
@@ -245,19 +245,19 @@
 
   bool copy();					// Alloc string if not alloced
   bool copy(const String &s);			// Allocate new string
-  bool copy(const char *s,uint32_t arg_length, CHARSET_INFO *cs);	// Allocate new string
+  bool copy(const char *s,uint32_t arg_length, const CHARSET_INFO * const cs);	// Allocate new string
   static bool needs_conversion(uint32_t arg_length,
-  			       CHARSET_INFO *cs_from, CHARSET_INFO *cs_to,
+  			       const CHARSET_INFO * const cs_from, const CHARSET_INFO * const cs_to,
 			       uint32_t *offset);
   bool copy_aligned(const char *s, uint32_t arg_length, uint32_t offset,
-		    CHARSET_INFO *cs);
-  bool set_or_copy_aligned(const char *s, uint32_t arg_length, CHARSET_INFO *cs);
-  bool copy(const char*s,uint32_t arg_length, CHARSET_INFO *csfrom,
-	    CHARSET_INFO *csto, uint *errors);
+		    const CHARSET_INFO * const cs);
+  bool set_or_copy_aligned(const char *s, uint32_t arg_length, const CHARSET_INFO * const cs);
+  bool copy(const char*s,uint32_t arg_length, const CHARSET_INFO * const csfrom,
+	    const CHARSET_INFO * const csto, uint *errors);
   bool append(const String &s);
   bool append(const char *s);
   bool append(const char *s,uint32_t arg_length);
-  bool append(const char *s,uint32_t arg_length, CHARSET_INFO *cs);
+  bool append(const char *s,uint32_t arg_length, const CHARSET_INFO * const cs);
   bool append(IO_CACHE* file, uint32_t arg_length);
   bool append_with_prefill(const char *s, uint32_t arg_length, 
 			   uint32_t full_length, char fill_char);
@@ -281,7 +281,7 @@
   }
   bool fill(uint32_t max_length,char fill);
   void strip_sp();
-  friend int sortcmp(const String *a,const String *b, CHARSET_INFO *cs);
+  friend int sortcmp(const String *a,const String *b, const CHARSET_INFO * const cs);
   friend int stringcmp(const String *a,const String *b);
   friend String *copy_if_not_alloced(String *a,String *b,uint32_t arg_length);
   uint32_t numchars();
@@ -374,7 +374,7 @@
   }
 };
 
-static inline bool check_if_only_end_space(CHARSET_INFO *cs, char *str, 
+static inline bool check_if_only_end_space(const CHARSET_INFO * const cs, char *str, 
                                            char *end)
 {
   return str+ cs->cset->scan(cs, str, end, MY_SEQ_SPACES) == end;

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2008-08-05 06:19:05 +0000
+++ drizzled/sql_table.cc	2008-08-06 00:04:45 +0000
@@ -690,7 +690,7 @@
 
 bool check_duplicates_in_interval(const char *set_or_name,
                                   const char *name, TYPELIB *typelib,
-                                  CHARSET_INFO *cs, unsigned int *dup_val_count)
+                                  const CHARSET_INFO * const cs, unsigned int *dup_val_count)
 {
   TYPELIB tmp= *typelib;
   const char **cur_value= typelib->type_names;
@@ -731,7 +731,7 @@
   RETURN VALUES
     void
 */
-void calculate_interval_lengths(CHARSET_INFO *cs, TYPELIB *interval,
+void calculate_interval_lengths(const CHARSET_INFO * const cs, TYPELIB *interval,
                                 uint32_t *max_length, uint32_t *tot_length)
 {
   const char **pos;
@@ -922,7 +922,7 @@
 
   for (field_no=0; (sql_field=it++) ; field_no++)
   {
-    CHARSET_INFO *save_cs;
+    const CHARSET_INFO *save_cs;
 
     /*
       Initialize length from its original value (number of characters),
@@ -986,7 +986,7 @@
         sql_field->sql_type == DRIZZLE_TYPE_ENUM)
     {
       uint32_t dummy;
-      CHARSET_INFO *cs= sql_field->charset;
+      const CHARSET_INFO * const cs= sql_field->charset;
       TYPELIB *interval= sql_field->interval;
 
       /*
@@ -2454,7 +2454,7 @@
   Protocol *protocol= thd->protocol;
   LEX *lex= thd->lex;
   int result_code= 0;
-  CHARSET_INFO *cs= system_charset_info;
+  const CHARSET_INFO * const cs= system_charset_info;
 
   if (end_active_trans(thd))
     return(1);

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2008-08-05 06:19:05 +0000
+++ drizzled/sql_yacc.yy	2008-08-06 00:04:45 +0000
@@ -339,7 +339,7 @@
   enum enum_tx_isolation tx_isolation;
   enum Cast_target cast_type;
   enum ha_choice choice;
-  CHARSET_INFO *charset;
+  const CHARSET_INFO *charset;
   thr_lock_type lock_type;
   struct st_table_lock_info table_lock_info;
   interval_type interval, interval_time_st;
@@ -5870,8 +5870,8 @@
           {
             LEX_STRING tmp;
             THD *thd= YYTHD;
-            CHARSET_INFO *cs_con= thd->variables.collation_connection;
-            CHARSET_INFO *cs_cli= thd->variables.character_set_client;
+            const CHARSET_INFO * const cs_con= thd->variables.collation_connection;
+            const CHARSET_INFO * const cs_cli= thd->variables.character_set_client;
             uint repertoire= thd->lex->text_string_is_7bit &&
                              my_charset_is_ascii_based(cs_cli) ?
                              MY_REPERTOIRE_ASCII : MY_REPERTOIRE_UNICODE30;
@@ -5902,7 +5902,7 @@
                  If the string has been pure ASCII so far,
                  check the new part.
               */
-              CHARSET_INFO *cs= YYTHD->variables.collation_connection;
+              const CHARSET_INFO * const cs= YYTHD->variables.collation_connection;
               item->collation.repertoire|= my_string_repertoire(cs,
                                                                 $2.str,
                                                                 $2.length);
@@ -6209,7 +6209,7 @@
 
             if (thd->charset_is_system_charset)
             {
-              CHARSET_INFO *cs= system_charset_info;
+              const CHARSET_INFO * const cs= system_charset_info;
               int dummy_error;
               uint wlen= cs->cset->well_formed_len(cs, $1.str,
                                                    $1.str+$1.length,

=== modified file 'drizzled/strfunc.cc'
--- drizzled/strfunc.cc	2008-07-22 18:31:32 +0000
+++ drizzled/strfunc.cc	2008-08-06 00:04:45 +0000
@@ -38,10 +38,11 @@
 
 static const char field_separator=',';
 
-uint64_t find_set(TYPELIB *lib, const char *str, uint length, CHARSET_INFO *cs,
-                   char **err_pos, uint *err_len, bool *set_warning)
+uint64_t find_set(TYPELIB *lib, const char *str, uint length,
+                  const CHARSET_INFO * const cs,
+                  char **err_pos, uint *err_len, bool *set_warning)
 {
-  CHARSET_INFO *strip= cs ? cs : &my_charset_latin1;
+  const CHARSET_INFO * const strip= cs ? cs : &my_charset_latin1;
   const char *end= str + strip->cset->lengthsp(strip, str, length);
   uint64_t found= 0;
   *err_pos= 0;                  // No error yet
@@ -146,7 +147,7 @@
 */
 
 uint find_type2(const TYPELIB *typelib, const char *x, uint length,
-                CHARSET_INFO *cs)
+                const CHARSET_INFO * const cs)
 {
   int pos;
   const char *j;
@@ -254,8 +255,8 @@
 */
 
 
-uint strconvert(CHARSET_INFO *from_cs, const char *from,
-                CHARSET_INFO *to_cs, char *to, uint to_length, uint *errors)
+uint strconvert(const CHARSET_INFO * const from_cs, const char *from,
+                const CHARSET_INFO * const to_cs, char *to, uint to_length, uint *errors)
 {
   int cnvres;
   my_wc_t wc;
@@ -326,7 +327,7 @@
 */
 
 int find_string_in_array(LEX_STRING * const haystack, LEX_STRING * const needle,
-                         CHARSET_INFO * const cs)
+                         const CHARSET_INFO * const cs)
 {
   const LEX_STRING *pos;
   for (pos= haystack; pos->str; pos++)

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2008-08-05 06:19:05 +0000
+++ drizzled/table.cc	2008-08-06 00:04:45 +0000
@@ -69,7 +69,7 @@
 { }
 
 Default_object_creation_ctx::Default_object_creation_ctx(
-  CHARSET_INFO *client_cs, CHARSET_INFO *connection_cl)
+  const CHARSET_INFO * const client_cs, const CHARSET_INFO * const connection_cl)
   : m_client_cs(client_cs),
     m_connection_cl(connection_cl)
 { }
@@ -886,7 +886,7 @@
     uint pack_flag, interval_nr, unireg_type, recpos, field_length;
     enum_field_types field_type;
     enum column_format_type column_format= COLUMN_FORMAT_TYPE_DEFAULT;
-    CHARSET_INFO *charset=NULL;
+    const CHARSET_INFO *charset= NULL;
     LEX_STRING comment;
 
     if (field_extra_info)

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2008-08-05 06:19:05 +0000
+++ drizzled/table.h	2008-08-06 00:04:45 +0000
@@ -201,7 +201,7 @@
 
   uchar	*default_values;		/* row with default values */
   LEX_STRING comment;			/* Comment about table */
-  CHARSET_INFO *table_charset;		/* Default charset of string fields */
+  const CHARSET_INFO *table_charset; /* Default charset of string fields */
 
   MY_BITMAP all_set;
   /*

=== modified file 'drizzled/thr_malloc.cc'
--- drizzled/thr_malloc.cc	2008-08-04 19:45:27 +0000
+++ drizzled/thr_malloc.cc	2008-08-06 00:04:45 +0000
@@ -86,9 +86,9 @@
 
 
 char *sql_strmake_with_convert(const char *str, size_t arg_length,
-			       CHARSET_INFO *from_cs,
+			       const CHARSET_INFO * const from_cs,
 			       size_t max_res_length,
-			       CHARSET_INFO *to_cs, size_t *result_length)
+			       const CHARSET_INFO * const to_cs, size_t *result_length)
 {
   char *pos;
   size_t new_length= to_cs->mbmaxlen*arg_length;

=== modified file 'libdrizzle/client.c'
--- libdrizzle/client.c	2008-08-05 20:32:06 +0000
+++ libdrizzle/client.c	2008-08-06 00:04:45 +0000
@@ -1217,7 +1217,7 @@
                                          MY_CS_PRIMARY, MYF(MY_WME));
     if (drizzle->charset && default_collation_name)
     {
-      CHARSET_INFO *collation;
+      const CHARSET_INFO *collation;
       if ((collation=
            get_charset_by_name(default_collation_name, MYF(MY_WME))))
       {
@@ -2161,14 +2161,14 @@
 */
 int STDCALL drizzle_set_character_set(DRIZZLE *drizzle, const char *cs_name)
 {
-  struct charset_info_st *cs;
+  const CHARSET_INFO *cs;
   const char *save_csdir= charsets_dir;
 
   if (drizzle->options.charset_dir)
     charsets_dir= drizzle->options.charset_dir;
 
   if (strlen(cs_name) < MY_CS_NAME_SIZE &&
-     (cs= get_charset_by_csname(cs_name, MY_CS_PRIMARY, MYF(0))))
+      (cs= get_charset_by_csname(cs_name, MY_CS_PRIMARY, MYF(0))))
   {
     char buff[MY_CS_NAME_SIZE + 10];
     charsets_dir= save_csdir;

=== modified file 'mystrings/ctype-big5.c'
--- mystrings/ctype-big5.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-big5.c	2008-08-06 00:04:45 +0000
@@ -247,7 +247,7 @@
 
 /* Compare strings */
 
-static int my_strnncoll_big5(const CHARSET_INFO *cs __attribute__((unused)), 
+static int my_strnncoll_big5(const CHARSET_INFO * const cs __attribute__((unused)), 
 			     const uchar *a, size_t a_length,
                              const uchar *b, size_t b_length,
                              my_bool b_is_prefix)
@@ -260,7 +260,7 @@
 
 /* compare strings, ignore end space */
 
-static int my_strnncollsp_big5(const CHARSET_INFO * cs __attribute__((unused)), 
+static int my_strnncollsp_big5(const CHARSET_INFO * const  cs __attribute__((unused)), 
 			       const uchar *a, size_t a_length, 
 			       const uchar *b, size_t b_length,
                                my_bool diff_if_only_endspace_difference)
@@ -301,7 +301,7 @@
 
 
 static size_t
-my_strnxfrm_big5(const CHARSET_INFO *cs,
+my_strnxfrm_big5(const CHARSET_INFO * const cs,
                  uchar *dst, size_t dstlen, uint nweights,
                  const uchar *src, size_t srclen, uint flags)
 {
@@ -351,7 +351,7 @@
 
 #define max_sort_char ((char) 255)
 
-static my_bool my_like_range_big5(const CHARSET_INFO *cs __attribute__((unused)),
+static my_bool my_like_range_big5(const CHARSET_INFO * const cs __attribute__((unused)),
 				  const char *ptr,size_t ptr_length,
 				  char escape, char w_one, char w_many,
 				  size_t res_length,
@@ -412,14 +412,14 @@
 }
 
 
-static uint ismbchar_big5(const CHARSET_INFO *cs __attribute__((unused)),
+static uint ismbchar_big5(const CHARSET_INFO * const cs __attribute__((unused)),
                          const char* p, const char *e)
 {
   return (isbig5head(*(p)) && (e)-(p)>1 && isbig5tail(*((p)+1))? 2: 0);
 }
 
 
-static uint mbcharlen_big5(const CHARSET_INFO *cs __attribute__((unused)), uint c)
+static uint mbcharlen_big5(const CHARSET_INFO * const cs __attribute__((unused)), uint c)
 {
   return (isbig5head(c)? 2 : 1);
 }
@@ -6196,7 +6196,7 @@
 
 
 static int
-my_wc_mb_big5(const CHARSET_INFO *cs __attribute__((unused)),
+my_wc_mb_big5(const CHARSET_INFO * const cs __attribute__((unused)),
 	      my_wc_t wc, uchar *s, uchar *e)
 {
 
@@ -6225,7 +6225,7 @@
 
 
 static int 
-my_mb_wc_big5(const CHARSET_INFO *cs __attribute__((unused)),
+my_mb_wc_big5(const CHARSET_INFO * const cs __attribute__((unused)),
 	      my_wc_t *pwc,const uchar *s,const uchar *e)
 {
 
@@ -6255,7 +6255,7 @@
   CP950 and HKSCS additional characters are also accepted.
 */
 static
-size_t my_well_formed_len_big5(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_well_formed_len_big5(const CHARSET_INFO * const cs __attribute__((unused)),
                                const char *b, const char *e,
                                size_t pos, int *error)
 {

=== modified file 'mystrings/ctype-bin.c'
--- mystrings/ctype-bin.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-bin.c	2008-08-06 00:04:45 +0000
@@ -74,7 +74,7 @@
   return false;
 }
 
-static int my_strnncoll_binary(const CHARSET_INFO * cs __attribute__((unused)),
+static int my_strnncoll_binary(const CHARSET_INFO * const  cs __attribute__((unused)),
                                const uchar *s, size_t slen,
                                const uchar *t, size_t tlen,
                                my_bool t_is_prefix)
@@ -85,7 +85,7 @@
 }
 
 
-static size_t my_lengthsp_binary(const CHARSET_INFO *cs __attribute__((unused)),
+static size_t my_lengthsp_binary(const CHARSET_INFO * const cs __attribute__((unused)),
                                  const char *ptr __attribute__((unused)),
                                  size_t length)
 {
@@ -115,7 +115,7 @@
   > 0	s > t
 */
 
-static int my_strnncollsp_binary(const CHARSET_INFO * cs __attribute__((unused)),
+static int my_strnncollsp_binary(const CHARSET_INFO * const  cs __attribute__((unused)),
                                  const uchar *s, size_t slen,
                                  const uchar *t, size_t tlen,
                                  my_bool diff_if_only_endspace_difference
@@ -125,7 +125,7 @@
 }
 
 
-static int my_strnncoll_8bit_bin(const CHARSET_INFO * cs __attribute__((unused)),
+static int my_strnncoll_8bit_bin(const CHARSET_INFO * const  cs __attribute__((unused)),
                                  const uchar *s, size_t slen,
                                  const uchar *t, size_t tlen,
                                  my_bool t_is_prefix)
@@ -161,7 +161,7 @@
   > 0	s > t
 */
 
-static int my_strnncollsp_8bit_bin(const CHARSET_INFO * cs __attribute__((unused)),
+static int my_strnncollsp_8bit_bin(const CHARSET_INFO * const  cs __attribute__((unused)),
                                    const uchar *a, size_t a_length, 
                                    const uchar *b, size_t b_length,
                                    my_bool diff_if_only_endspace_difference)
@@ -210,14 +210,14 @@
 
 /* This function is used for all conversion functions */
 
-static size_t my_case_str_bin(const CHARSET_INFO *cs __attribute__((unused)),
+static size_t my_case_str_bin(const CHARSET_INFO * const cs __attribute__((unused)),
                               char *str __attribute__((unused)))
 {
   return 0;
 }
 
 
-static size_t my_case_bin(const CHARSET_INFO *cs __attribute__((unused)),
+static size_t my_case_bin(const CHARSET_INFO * const cs __attribute__((unused)),
                           char *src __attribute__((unused)),
                           size_t srclen,
                           char *dst __attribute__((unused)),
@@ -227,21 +227,21 @@
 }
 
 
-static int my_strcasecmp_bin(const CHARSET_INFO * cs __attribute__((unused)),
+static int my_strcasecmp_bin(const CHARSET_INFO * const  cs __attribute__((unused)),
 			     const char *s, const char *t)
 {
   return strcmp(s,t);
 }
 
 
-uint my_mbcharlen_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+uint my_mbcharlen_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
                       uint c __attribute__((unused)))
 {
   return 1;
 }
 
 
-static int my_mb_wc_bin(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_mb_wc_bin(const CHARSET_INFO * const cs __attribute__((unused)),
 			my_wc_t *wc,
 			const uchar *str,
 			const uchar *end __attribute__((unused)))
@@ -254,7 +254,7 @@
 }
 
 
-static int my_wc_mb_bin(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_wc_mb_bin(const CHARSET_INFO * const cs __attribute__((unused)),
 			my_wc_t wc,
 			uchar *s,
 			uchar *e __attribute__((unused)))
@@ -271,7 +271,7 @@
 }
 
 
-static void my_hash_sort_8bit_bin(const CHARSET_INFO *cs __attribute__((unused)),
+static void my_hash_sort_8bit_bin(const CHARSET_INFO * const cs __attribute__((unused)),
                                   const uchar *key, size_t len,
                                   ulong *nr1, ulong *nr2)
 {
@@ -292,7 +292,7 @@
 }
 
 
-static void my_hash_sort_bin(const CHARSET_INFO *cs __attribute__((unused)),
+static void my_hash_sort_bin(const CHARSET_INFO * const cs __attribute__((unused)),
                              const uchar *key, size_t len,
                              ulong *nr1, ulong *nr2)
 {
@@ -318,7 +318,7 @@
 #define INC_PTR(cs,A,B) (A)++
 
 
-int my_wildcmp_bin(const CHARSET_INFO *cs,
+int my_wildcmp_bin(const CHARSET_INFO * const cs,
                    const char *str,const char *str_end,
                    const char *wildstr,const char *wildend,
                    int escape, int w_one, int w_many)
@@ -397,7 +397,7 @@
 
 
 static size_t
-my_strnxfrm_8bit_bin(const CHARSET_INFO *cs,
+my_strnxfrm_8bit_bin(const CHARSET_INFO * const cs,
                      uchar * dst, size_t dstlen, uint nweights,
                      const uchar *src, size_t srclen, uint flags)
 {
@@ -411,7 +411,7 @@
 
 
 static
-uint my_instr_bin(const CHARSET_INFO *cs __attribute__((unused)),
+uint my_instr_bin(const CHARSET_INFO * const cs __attribute__((unused)),
 		  const char *b, size_t b_length,
 		  const char *s, size_t s_length,
 		  my_match_t *match, uint nmatch)

=== modified file 'mystrings/ctype-cp932.c'
--- mystrings/ctype-cp932.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-cp932.c	2008-08-06 00:04:45 +0000
@@ -181,13 +181,13 @@
                        (0x80<=(c) && (c)<=0xfc))
 
 
-static uint ismbchar_cp932(const CHARSET_INFO *cs __attribute__((unused)),
+static uint ismbchar_cp932(const CHARSET_INFO * const cs __attribute__((unused)),
 			 const char* p, const char *e)
 {
   return (iscp932head((uchar) *p) && (e-p)>1 && iscp932tail((uchar)p[1]) ? 2: 0);
 }
 
-static uint mbcharlen_cp932(const CHARSET_INFO *cs __attribute__((unused)),uint c)
+static uint mbcharlen_cp932(const CHARSET_INFO * const cs __attribute__((unused)),uint c)
 {
   return (iscp932head((uchar) c) ? 2 : 1);
 }
@@ -196,7 +196,7 @@
 #define cp932code(c,d)	((((uint) (uchar)(c)) << 8) | (uint) (uchar) (d))
 
 
-static int my_strnncoll_cp932_internal(const CHARSET_INFO *cs,
+static int my_strnncoll_cp932_internal(const CHARSET_INFO * const cs,
 				      const uchar **a_res, size_t a_length,
 				      const uchar **b_res, size_t b_length)
 {
@@ -228,7 +228,7 @@
 }
 
 
-static int my_strnncoll_cp932(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_strnncoll_cp932(const CHARSET_INFO * const cs __attribute__((unused)),
 			      const uchar *a, size_t a_length, 
 			      const uchar *b, size_t b_length,
                               my_bool b_is_prefix)
@@ -240,7 +240,7 @@
 }
 
 
-static int my_strnncollsp_cp932(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_strnncollsp_cp932(const CHARSET_INFO * const cs __attribute__((unused)),
                                 const uchar *a, size_t a_length, 
                                 const uchar *b, size_t b_length,
                                 my_bool diff_if_only_endspace_difference
@@ -300,7 +300,7 @@
 
 #define max_sort_char ((char) 255)
 
-static my_bool my_like_range_cp932(const CHARSET_INFO *cs __attribute__((unused)),
+static my_bool my_like_range_cp932(const CHARSET_INFO * const cs __attribute__((unused)),
                                    const char *ptr,size_t ptr_length,
                                    char escape, char w_one, char w_many,
                                    size_t res_length,
@@ -5303,7 +5303,7 @@
 
 
 static int
-my_wc_mb_cp932(const CHARSET_INFO *cs  __attribute__((unused)),
+my_wc_mb_cp932(const CHARSET_INFO * const cs  __attribute__((unused)),
 	      my_wc_t wc, uchar *s, uchar *e)
 {
   int code;
@@ -5333,7 +5333,7 @@
 
 
 static int 
-my_mb_wc_cp932(const CHARSET_INFO *cs  __attribute__((unused)),
+my_mb_wc_cp932(const CHARSET_INFO * const cs  __attribute__((unused)),
 	      my_wc_t *pwc, const uchar *s, const uchar *e){
   int hi;
   
@@ -5362,7 +5362,7 @@
 }
 
 static
-size_t my_numcells_cp932(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_numcells_cp932(const CHARSET_INFO * const cs __attribute__((unused)),
                       const char *str, const char *str_end)
 {
   size_t clen= 0;
@@ -5396,7 +5396,7 @@
 */
 
 static
-size_t my_well_formed_len_cp932(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_well_formed_len_cp932(const CHARSET_INFO * const cs __attribute__((unused)),
                                 const char *b, const char *e,
                                 size_t pos, int *error)
 {

=== modified file 'mystrings/ctype-czech.c'
--- mystrings/ctype-czech.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-czech.c	2008-08-06 00:04:45 +0000
@@ -340,7 +340,7 @@
   the length of the strings being specified
 */
 
-static int my_strnncoll_czech(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_strnncoll_czech(const CHARSET_INFO * const cs __attribute__((unused)),
 			      const uchar *s1, size_t len1, 
 			      const uchar *s2, size_t len2,
                               my_bool s2_is_prefix)
@@ -374,7 +374,7 @@
 */
 
 static int
-my_strnncollsp_czech(const CHARSET_INFO * cs __attribute__((unused)),
+my_strnncollsp_czech(const CHARSET_INFO * const  cs __attribute__((unused)),
                      const uchar *s, size_t slen,
                      const uchar *t, size_t tlen,
                      my_bool diff_if_only_endspace_difference
@@ -427,7 +427,7 @@
   Returns the number of bytes required for strnxfrm().
 */
 static size_t
-my_strnxfrmlen_czech(const CHARSET_INFO *cs __attribute__((unused)), size_t len)
+my_strnxfrmlen_czech(const CHARSET_INFO * const cs __attribute__((unused)), size_t len)
 {
   return len * 4 + 4;
 }
@@ -438,7 +438,7 @@
   the length of the strings being specified
 */
 static size_t
-my_strnxfrm_czech(const CHARSET_INFO * cs  __attribute__((unused)),
+my_strnxfrm_czech(const CHARSET_INFO * const  cs  __attribute__((unused)),
                   uchar *dst, size_t dstlen, uint nweights_arg,
                   const uchar *src, size_t srclen, uint flags)
 {
@@ -515,7 +515,7 @@
 #define max_sort_char 0xAE
 
 
-static my_bool my_like_range_czech(const CHARSET_INFO *cs __attribute__((unused)),
+static my_bool my_like_range_czech(const CHARSET_INFO * const cs __attribute__((unused)),
 				   const char *ptr,size_t ptr_length,
 				   char escape, char w_one, char w_many,
 				   size_t res_length, char *min_str,

=== modified file 'mystrings/ctype-euc_kr.c'
--- mystrings/ctype-euc_kr.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-euc_kr.c	2008-08-06 00:04:45 +0000
@@ -201,7 +201,7 @@
                               iseuc_kr_tail3(c))
 
 
-static uint ismbchar_euc_kr(const CHARSET_INFO *cs __attribute__((unused)),
+static uint ismbchar_euc_kr(const CHARSET_INFO * const cs __attribute__((unused)),
                             const char* p, const char *e)
 {
   return ((*(uchar*)(p)<0x80)? 0:\
@@ -209,7 +209,7 @@
           0);
 }
 
-static uint mbcharlen_euc_kr(const CHARSET_INFO *cs __attribute__((unused)),uint c)
+static uint mbcharlen_euc_kr(const CHARSET_INFO * const cs __attribute__((unused)),uint c)
 {
   return (iseuc_kr_head(c) ? 2 : 1);
 }
@@ -8601,7 +8601,7 @@
 
 
 static int
-my_wc_mb_euc_kr(const CHARSET_INFO *cs __attribute__((unused)),
+my_wc_mb_euc_kr(const CHARSET_INFO * const cs __attribute__((unused)),
 		 my_wc_t wc, uchar *s, uchar *e)
 {
   int code;
@@ -8629,7 +8629,7 @@
 
 
 static int 
-my_mb_wc_euc_kr(const CHARSET_INFO *cs __attribute__((unused)),
+my_mb_wc_euc_kr(const CHARSET_INFO * const cs __attribute__((unused)),
 		 my_wc_t *pwc, const uchar *s, const uchar *e)
 {
   
@@ -8658,7 +8658,7 @@
   Returns well formed length of a EUC-KR string.
 */
 static size_t
-my_well_formed_len_euckr(const CHARSET_INFO *cs __attribute__((unused)),
+my_well_formed_len_euckr(const CHARSET_INFO * const cs __attribute__((unused)),
                          const char *b, const char *e,
                          size_t pos, int *error)
 {

=== modified file 'mystrings/ctype-eucjpms.c'
--- mystrings/ctype-eucjpms.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-eucjpms.c	2008-08-06 00:04:45 +0000
@@ -184,7 +184,7 @@
 #define iseucjpms_ss3(c) (((c)&0xff) == 0x8f)
 
 
-static uint ismbchar_eucjpms(const CHARSET_INFO *cs __attribute__((unused)),
+static uint ismbchar_eucjpms(const CHARSET_INFO * const cs __attribute__((unused)),
 		  const char* p, const char *e)
 {
   return ((*(uchar*)(p)<0x80)? 0:\
@@ -194,7 +194,7 @@
     0);
 }
 
-static uint mbcharlen_eucjpms(const CHARSET_INFO *cs __attribute__((unused)),uint c)
+static uint mbcharlen_eucjpms(const CHARSET_INFO * const cs __attribute__((unused)),uint c)
 {
   return (iseucjpms(c)? 2: iseucjpms_ss2(c)? 2: iseucjpms_ss3(c)? 3: 1);
 }
@@ -237,7 +237,7 @@
 
 
 static int 
-my_mb_wc_jisx0201(const CHARSET_INFO *cs  __attribute__((unused)),
+my_mb_wc_jisx0201(const CHARSET_INFO * const cs  __attribute__((unused)),
 		  my_wc_t *wc,const uchar *s,
 		  const uchar *e __attribute__((unused)))
 {
@@ -247,7 +247,7 @@
 
 
 static int
-my_wc_mb_jisx0201(const CHARSET_INFO *cs __attribute__((unused)),
+my_wc_mb_jisx0201(const CHARSET_INFO * const cs __attribute__((unused)),
 		  my_wc_t wc, uchar *s, 
 		  uchar *e __attribute__((unused)))
 {
@@ -8386,7 +8386,7 @@
 */
 
 static
-size_t my_well_formed_len_eucjpms(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_well_formed_len_eucjpms(const CHARSET_INFO * const cs __attribute__((unused)),
                                   const char *beg, const char *end, size_t pos,
                                   int *error)
 {
@@ -8434,7 +8434,7 @@
 
 
 static
-size_t my_numcells_eucjp(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_numcells_eucjp(const CHARSET_INFO * const cs __attribute__((unused)),
                          const char *str, const char *str_end)
 {
   size_t clen;
@@ -8468,7 +8468,7 @@
 }
 
 static int
-my_mb_wc_euc_jp(const CHARSET_INFO *cs,my_wc_t *pwc, const uchar *s, const uchar *e)
+my_mb_wc_euc_jp(const CHARSET_INFO * const cs,my_wc_t *pwc, const uchar *s, const uchar *e)
 {
   int c1,c2,c3;
   
@@ -8555,7 +8555,7 @@
 }
 
 static int
-my_wc_mb_euc_jp(const CHARSET_INFO *c,my_wc_t wc, uchar *s, uchar *e)
+my_wc_mb_euc_jp(const CHARSET_INFO * const c,my_wc_t wc, uchar *s, uchar *e)
 {
   uchar c1;
   int jp;

=== modified file 'mystrings/ctype-gb2312.c'
--- mystrings/ctype-gb2312.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-gb2312.c	2008-08-06 00:04:45 +0000
@@ -164,13 +164,13 @@
 #define isgb2312tail(c) (0xa1<=(uchar)(c) && (uchar)(c)<=0xfe)
 
 
-static uint ismbchar_gb2312(const CHARSET_INFO *cs __attribute__((unused)),
+static uint ismbchar_gb2312(const CHARSET_INFO * const cs __attribute__((unused)),
 		    const char* p, const char *e)
 {
   return (isgb2312head(*(p)) && (e)-(p)>1 && isgb2312tail(*((p)+1))? 2: 0);
 }
 
-static uint mbcharlen_gb2312(const CHARSET_INFO *cs __attribute__((unused)),uint c)
+static uint mbcharlen_gb2312(const CHARSET_INFO * const cs __attribute__((unused)),uint c)
 {
   return (isgb2312head(c)? 2 : 1);
 }
@@ -5631,7 +5631,7 @@
 
 
 static int
-my_wc_mb_gb2312(const CHARSET_INFO *cs  __attribute__((unused)),
+my_wc_mb_gb2312(const CHARSET_INFO * const cs  __attribute__((unused)),
 		my_wc_t wc, uchar *s, uchar *e)
 {
   int code;
@@ -5659,7 +5659,7 @@
 
 
 static int 
-my_mb_wc_gb2312(const CHARSET_INFO *cs  __attribute__((unused)),
+my_mb_wc_gb2312(const CHARSET_INFO * const cs  __attribute__((unused)),
 		my_wc_t *pwc, const uchar *s, const uchar *e){
   int hi;
   
@@ -5686,7 +5686,7 @@
   Returns well formed length of a EUC-KR string.
 */
 static size_t
-my_well_formed_len_gb2312(const CHARSET_INFO *cs __attribute__((unused)),
+my_well_formed_len_gb2312(const CHARSET_INFO * const cs __attribute__((unused)),
                           const char *b, const char *e,
                           size_t pos, int *error)
 {

=== modified file 'mystrings/ctype-gbk.c'
--- mystrings/ctype-gbk.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-gbk.c	2008-08-06 00:04:45 +0000
@@ -2610,7 +2610,7 @@
 
 
 
-static int my_strnncoll_gbk(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_strnncoll_gbk(const CHARSET_INFO * const cs __attribute__((unused)),
 		     const uchar *a, size_t a_length,
                      const uchar *b, size_t b_length,
                      my_bool b_is_prefix)
@@ -2621,7 +2621,7 @@
 }
 
 
-static int my_strnncollsp_gbk(const CHARSET_INFO * cs __attribute__((unused)),
+static int my_strnncollsp_gbk(const CHARSET_INFO * const  cs __attribute__((unused)),
 			      const uchar *a, size_t a_length, 
 			      const uchar *b, size_t b_length,
                               my_bool diff_if_only_endspace_difference)
@@ -2662,7 +2662,7 @@
 
 
 static size_t
-my_strnxfrm_gbk(const CHARSET_INFO *cs,
+my_strnxfrm_gbk(const CHARSET_INFO * const cs,
                 uchar *dst, size_t dstlen, uint nweights,
                 const uchar *src, size_t srclen, uint flags)
 {
@@ -2712,7 +2712,7 @@
 
 #define max_sort_char ((uchar) 255)
 
-static my_bool my_like_range_gbk(const CHARSET_INFO *cs __attribute__((unused)),
+static my_bool my_like_range_gbk(const CHARSET_INFO * const cs __attribute__((unused)),
                                  const char *ptr,size_t ptr_length,
                                  char escape, char w_one, char w_many,
                                  size_t res_length,
@@ -2773,13 +2773,13 @@
 }
 
 
-static uint ismbchar_gbk(const CHARSET_INFO *cs __attribute__((unused)),
+static uint ismbchar_gbk(const CHARSET_INFO * const cs __attribute__((unused)),
 		 const char* p, const char *e)
 {
   return (isgbkhead(*(p)) && (e)-(p)>1 && isgbktail(*((p)+1))? 2: 0);
 }
 
-static uint mbcharlen_gbk(const CHARSET_INFO *cs __attribute__((unused)),uint c)
+static uint mbcharlen_gbk(const CHARSET_INFO * const cs __attribute__((unused)),uint c)
 {
   return (isgbkhead(c)? 2 : 1);
 }
@@ -9889,7 +9889,7 @@
 }
 
 static int
-my_wc_mb_gbk(const CHARSET_INFO *cs  __attribute__((unused)),
+my_wc_mb_gbk(const CHARSET_INFO * const cs  __attribute__((unused)),
 	      my_wc_t wc, uchar *s, uchar *e)
 {
   int code;
@@ -9915,7 +9915,7 @@
 }
 
 static int
-my_mb_wc_gbk(const CHARSET_INFO *cs __attribute__((unused)),
+my_mb_wc_gbk(const CHARSET_INFO * const cs __attribute__((unused)),
 	      my_wc_t *pwc, const uchar *s, const uchar *e)
 {
   int hi;
@@ -9946,7 +9946,7 @@
   Returns well formed length of a GBK string.
 */
 static
-size_t my_well_formed_len_gbk(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_well_formed_len_gbk(const CHARSET_INFO * const cs __attribute__((unused)),
                               const char *b, const char *e,
                               size_t pos, int *error)
 {

=== modified file 'mystrings/ctype-latin1.c'
--- mystrings/ctype-latin1.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-latin1.c	2008-08-06 00:04:45 +0000
@@ -355,7 +355,7 @@
 };
 
 static
-int my_mb_wc_latin1(const CHARSET_INFO *cs  __attribute__((unused)),
+int my_mb_wc_latin1(const CHARSET_INFO * const cs  __attribute__((unused)),
 		    my_wc_t *wc,
 		    const uchar *str,
 		    const uchar *end __attribute__((unused)))
@@ -368,7 +368,7 @@
 }
 
 static
-int my_wc_mb_latin1(const CHARSET_INFO *cs  __attribute__((unused)),
+int my_wc_mb_latin1(const CHARSET_INFO * const cs  __attribute__((unused)),
 		    my_wc_t wc,
 		    uchar *str,
 		    uchar *end __attribute__((unused)))
@@ -543,7 +543,7 @@
 */
 
 
-static int my_strnncoll_latin1_de(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_strnncoll_latin1_de(const CHARSET_INFO * const cs __attribute__((unused)),
 				  const uchar *a, size_t a_length,
 				  const uchar *b, size_t b_length,
                                   my_bool b_is_prefix)
@@ -584,7 +584,7 @@
 }
 
 
-static int my_strnncollsp_latin1_de(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_strnncollsp_latin1_de(const CHARSET_INFO * const cs __attribute__((unused)),
 				    const uchar *a, size_t a_length,
 				    const uchar *b, size_t b_length,
                                     my_bool diff_if_only_endspace_difference)
@@ -657,7 +657,7 @@
 
 
 static size_t
-my_strnxfrm_latin1_de(const CHARSET_INFO *cs,
+my_strnxfrm_latin1_de(const CHARSET_INFO * const cs,
                       uchar *dst, size_t dstlen, uint nweights,
                       const uchar* src, size_t srclen, uint flags)
 {
@@ -678,7 +678,7 @@
 }
 
 
-static void my_hash_sort_latin1_de(const CHARSET_INFO *cs __attribute__((unused)),
+static void my_hash_sort_latin1_de(const CHARSET_INFO * const cs __attribute__((unused)),
 			    const uchar *key, size_t len,
 			    ulong *nr1, ulong *nr2)
 {

=== modified file 'mystrings/ctype-mb.c'
--- mystrings/ctype-mb.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-mb.c	2008-08-06 00:04:45 +0000
@@ -19,7 +19,7 @@
 #ifdef USE_MB
 
 
-size_t my_caseup_str_mb(const CHARSET_INFO * cs, char *str)
+size_t my_caseup_str_mb(const CHARSET_INFO * const  cs, char *str)
 {
   register uint32_t l;
   register uchar *map= cs->to_upper;
@@ -40,7 +40,7 @@
 }
 
 
-size_t my_casedn_str_mb(const CHARSET_INFO * cs, char *str)
+size_t my_casedn_str_mb(const CHARSET_INFO * const  cs, char *str)
 {
   register uint32_t l;
   register uchar *map= cs->to_lower;
@@ -61,7 +61,7 @@
 }
 
 
-size_t my_caseup_mb(const CHARSET_INFO * cs, char *src, size_t srclen,
+size_t my_caseup_mb(const CHARSET_INFO * const  cs, char *src, size_t srclen,
                     char *dst __attribute__((unused)),
                     size_t dstlen __attribute__((unused)))
 {
@@ -84,7 +84,7 @@
 }
 
 
-size_t my_casedn_mb(const CHARSET_INFO * cs, char *src, size_t srclen,
+size_t my_casedn_mb(const CHARSET_INFO * const  cs, char *src, size_t srclen,
                     char *dst __attribute__((unused)),
                     size_t dstlen __attribute__((unused)))
 {
@@ -111,7 +111,7 @@
   my_strcasecmp_mb() returns 0 if strings are equal, non-zero otherwise.
  */
 
-int my_strcasecmp_mb(const CHARSET_INFO * cs,const char *s, const char *t)
+int my_strcasecmp_mb(const CHARSET_INFO * const  cs,const char *s, const char *t)
 {
   register uint32_t l;
   register uchar *map=cs->to_upper;
@@ -146,7 +146,7 @@
 
 #define likeconv(s,A) (uchar) (s)->sort_order[(uchar) (A)]
 
-int my_wildcmp_mb(const CHARSET_INFO *cs,
+int my_wildcmp_mb(const CHARSET_INFO * const cs,
 		  const char *str,const char *str_end,
 		  const char *wildstr,const char *wildend,
 		  int escape, int w_one, int w_many)
@@ -254,7 +254,7 @@
 }
 
 
-size_t my_numchars_mb(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_numchars_mb(const CHARSET_INFO * const cs __attribute__((unused)),
 		      const char *pos, const char *end)
 {
   register size_t count= 0;
@@ -268,7 +268,7 @@
 }
 
 
-size_t my_charpos_mb(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_charpos_mb(const CHARSET_INFO * const cs __attribute__((unused)),
 		     const char *pos, const char *end, size_t length)
 {
   const char *start= pos;
@@ -283,7 +283,7 @@
 }
 
 
-size_t my_well_formed_len_mb(const CHARSET_INFO *cs, const char *b, const char *e,
+size_t my_well_formed_len_mb(const CHARSET_INFO * const cs, const char *b, const char *e,
                              size_t pos, int *error)
 {
   const char *b_start= b;
@@ -305,7 +305,7 @@
 }
 
 
-uint my_instr_mb(const CHARSET_INFO *cs,
+uint my_instr_mb(const CHARSET_INFO * const cs,
                  const char *b, size_t b_length, 
                  const char *s, size_t s_length,
                  my_match_t *match, uint nmatch)
@@ -362,7 +362,7 @@
 
 /* BINARY collations handlers for MB charsets */
 
-int my_strnncoll_mb_bin(const CHARSET_INFO * cs __attribute__((unused)),
+int my_strnncoll_mb_bin(const CHARSET_INFO * const  cs __attribute__((unused)),
                         const uchar *s, size_t slen,
                         const uchar *t, size_t tlen,
                         my_bool t_is_prefix)
@@ -398,7 +398,7 @@
     0 if strings are equal
 */
 
-int my_strnncollsp_mb_bin(const CHARSET_INFO * cs __attribute__((unused)),
+int my_strnncollsp_mb_bin(const CHARSET_INFO * const  cs __attribute__((unused)),
                           const uchar *a, size_t a_length,
                           const uchar *b, size_t b_length,
                           my_bool diff_if_only_endspace_difference)
@@ -477,7 +477,7 @@
   cp932, euckr, gb2312, sjis, eucjpms, ujis.
 */
 size_t
-my_strnxfrm_mb(const CHARSET_INFO *cs,
+my_strnxfrm_mb(const CHARSET_INFO * const cs,
                uchar *dst, size_t dstlen, uint nweights,
                const uchar *src, size_t srclen, uint flags)
 {
@@ -552,14 +552,14 @@
 }
 
 
-int my_strcasecmp_mb_bin(const CHARSET_INFO * cs __attribute__((unused)),
+int my_strcasecmp_mb_bin(const CHARSET_INFO * const  cs __attribute__((unused)),
                          const char *s, const char *t)
 {
   return strcmp(s,t);
 }
 
 
-void my_hash_sort_mb_bin(const CHARSET_INFO *cs __attribute__((unused)),
+void my_hash_sort_mb_bin(const CHARSET_INFO * const cs __attribute__((unused)),
                          const uchar *key, size_t len,ulong *nr1, ulong *nr2)
 {
   const uchar *pos = key;
@@ -595,7 +595,7 @@
         create a buffer with multibyte representation of the max_sort_char
         character, and copy it into max_str in a loop. 
 */
-static void pad_max_char(const CHARSET_INFO *cs, char *str, char *end)
+static void pad_max_char(const CHARSET_INFO * const cs, char *str, char *end)
 {
   char buf[10];
   char buflen;
@@ -649,7 +649,7 @@
 ** optimized !
 */
 
-my_bool my_like_range_mb(const CHARSET_INFO *cs,
+my_bool my_like_range_mb(const CHARSET_INFO * const cs,
                          const char *ptr,size_t ptr_length,
                          char escape, char w_one, char w_many,
                          size_t res_length,
@@ -781,7 +781,7 @@
 }
 
 
-int my_wildcmp_mb_bin(const CHARSET_INFO *cs,
+int my_wildcmp_mb_bin(const CHARSET_INFO * const cs,
                       const char *str,const char *str_end,
                       const char *wildstr,const char *wildend,
                       int escape, int w_one, int w_many)
@@ -1095,7 +1095,7 @@
 };
 
 
-size_t my_numcells_mb(const CHARSET_INFO *cs, const char *b, const char *e)
+size_t my_numcells_mb(const CHARSET_INFO * const cs, const char *b, const char *e)
 {
   my_wc_t wc;
   size_t clen= 0;
@@ -1124,7 +1124,7 @@
 }
 
 
-int my_mb_ctype_mb(const CHARSET_INFO *cs, int *ctype,
+int my_mb_ctype_mb(const CHARSET_INFO * const cs, int *ctype,
                    const uchar *s, const uchar *e)
 {
   my_wc_t wc;

=== modified file 'mystrings/ctype-simple.c'
--- mystrings/ctype-simple.c	2008-07-31 21:08:38 +0000
+++ mystrings/ctype-simple.c	2008-08-06 00:04:45 +0000
@@ -23,7 +23,7 @@
   Returns the number of bytes required for strnxfrm().
 */
 
-size_t my_strnxfrmlen_simple(const CHARSET_INFO *cs, size_t len)
+size_t my_strnxfrmlen_simple(const CHARSET_INFO * const cs, size_t len)
 {
   return len * (cs->strxfrm_multiply ? cs->strxfrm_multiply : 1);
 }
@@ -69,7 +69,7 @@
 */
 
 
-size_t my_strnxfrm_simple(const CHARSET_INFO * cs,
+size_t my_strnxfrm_simple(const CHARSET_INFO * const  cs,
                        uchar *dst, size_t dstlen, uint nweights,
                        const uchar *src, size_t srclen, uint flags)
 {
@@ -95,7 +95,7 @@
 }
 
 
-int my_strnncoll_simple(const CHARSET_INFO * cs, const uchar *s, size_t slen, 
+int my_strnncoll_simple(const CHARSET_INFO * const  cs, const uchar *s, size_t slen, 
                         const uchar *t, size_t tlen,
                         my_bool t_is_prefix)
 {
@@ -146,7 +146,7 @@
     > 0	 a > b
 */
 
-int my_strnncollsp_simple(const CHARSET_INFO * cs, const uchar *a, size_t a_length, 
+int my_strnncollsp_simple(const CHARSET_INFO * const  cs, const uchar *a, size_t a_length, 
 			  const uchar *b, size_t b_length,
                           my_bool diff_if_only_endspace_difference)
 {
@@ -192,7 +192,7 @@
 }
 
 
-size_t my_caseup_str_8bit(const CHARSET_INFO * cs,char *str)
+size_t my_caseup_str_8bit(const CHARSET_INFO * const  cs,char *str)
 {
   register uchar *map= cs->to_upper;
   char *str_orig= str;
@@ -202,7 +202,7 @@
 }
 
 
-size_t my_casedn_str_8bit(const CHARSET_INFO * cs,char *str)
+size_t my_casedn_str_8bit(const CHARSET_INFO * const  cs,char *str)
 {
   register uchar *map= cs->to_lower;
   char *str_orig= str;
@@ -212,7 +212,7 @@
 }
 
 
-size_t my_caseup_8bit(const CHARSET_INFO * cs, char *src, size_t srclen,
+size_t my_caseup_8bit(const CHARSET_INFO * const  cs, char *src, size_t srclen,
                       char *dst __attribute__((unused)),
                       size_t dstlen __attribute__((unused)))
 {
@@ -225,7 +225,7 @@
 }
 
 
-size_t my_casedn_8bit(const CHARSET_INFO * cs, char *src, size_t srclen,
+size_t my_casedn_8bit(const CHARSET_INFO * const  cs, char *src, size_t srclen,
                       char *dst __attribute__((unused)),
                       size_t dstlen __attribute__((unused)))
 {
@@ -237,7 +237,7 @@
   return srclen;
 }
 
-int my_strcasecmp_8bit(const CHARSET_INFO * cs,const char *s, const char *t)
+int my_strcasecmp_8bit(const CHARSET_INFO * const  cs,const char *s, const char *t)
 {
   register uchar *map=cs->to_upper;
   while (map[(uchar) *s] == map[(uchar) *t++])
@@ -246,7 +246,7 @@
 }
 
 
-int my_mb_wc_8bit(const CHARSET_INFO *cs,my_wc_t *wc,
+int my_mb_wc_8bit(const CHARSET_INFO * const cs,my_wc_t *wc,
 		  const uchar *str,
 		  const uchar *end __attribute__((unused)))
 {
@@ -257,7 +257,7 @@
   return (!wc[0] && str[0]) ? -1 : 1;
 }
 
-int my_wc_mb_8bit(const CHARSET_INFO *cs,my_wc_t wc,
+int my_wc_mb_8bit(const CHARSET_INFO * const cs,my_wc_t wc,
 		  uchar *str,
 		  uchar *end)
 {
@@ -285,7 +285,7 @@
    end buffer must be checked.
 */
 
-size_t my_snprintf_8bit(const CHARSET_INFO *cs  __attribute__((unused)),
+size_t my_snprintf_8bit(const CHARSET_INFO * const cs  __attribute__((unused)),
                         char* to, size_t n  __attribute__((unused)),
 		     const char* fmt, ...)
 {
@@ -298,7 +298,7 @@
 }
 
 
-void my_hash_sort_simple(const CHARSET_INFO *cs,
+void my_hash_sort_simple(const CHARSET_INFO * const cs,
 			 const uchar *key, size_t len,
 			 ulong *nr1, ulong *nr2)
 {
@@ -320,7 +320,7 @@
 }
 
 
-long my_strntol_8bit(const CHARSET_INFO *cs,
+long my_strntol_8bit(const CHARSET_INFO * const cs,
 		     const char *nptr, size_t l, int base,
 		     char **endptr, int *err)
 {
@@ -443,7 +443,7 @@
 }
 
 
-ulong my_strntoul_8bit(const CHARSET_INFO *cs,
+ulong my_strntoul_8bit(const CHARSET_INFO * const cs,
 		       const char *nptr, size_t l, int base,
 		       char **endptr, int *err)
 {
@@ -557,7 +557,7 @@
 }
 
 
-int64_t my_strntoll_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+int64_t my_strntoll_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
 			  const char *nptr, size_t l, int base,
 			  char **endptr,int *err)
 {
@@ -680,7 +680,7 @@
 }
 
 
-uint64_t my_strntoull_8bit(const CHARSET_INFO *cs,
+uint64_t my_strntoull_8bit(const CHARSET_INFO * const cs,
 			   const char *nptr, size_t l, int base,
 			   char **endptr, int *err)
 {
@@ -819,7 +819,7 @@
 */
 
 
-double my_strntod_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+double my_strntod_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
 		       char *str, size_t length,
 		       char **end, int *err)
 {
@@ -836,7 +836,7 @@
   Assume len >= 1
 */
 
-size_t my_long10_to_str_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_long10_to_str_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
                              char *dst, size_t len, int radix, long int val)
 {
   char buffer[66];
@@ -877,7 +877,7 @@
 }
 
 
-size_t my_int64_t10_to_str_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_int64_t10_to_str_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
                                  char *dst, size_t len, int radix,
                                  int64_t val)
 {
@@ -948,7 +948,7 @@
 #define INC_PTR(cs,A,B) (A)++
 
 
-int my_wildcmp_8bit(const CHARSET_INFO *cs,
+int my_wildcmp_8bit(const CHARSET_INFO * const cs,
 		    const char *str,const char *str_end,
 		    const char *wildstr,const char *wildend,
 		    int escape, int w_one, int w_many)
@@ -1045,7 +1045,7 @@
 ** optimized !
 */
 
-my_bool my_like_range_simple(const CHARSET_INFO *cs,
+my_bool my_like_range_simple(const CHARSET_INFO * const cs,
                              const char *ptr, size_t ptr_length,
                              char escape, char w_one, char w_many,
                              size_t res_length,
@@ -1095,7 +1095,7 @@
 }
 
 
-size_t my_scan_8bit(const CHARSET_INFO *cs, const char *str, const char *end, int sq)
+size_t my_scan_8bit(const CHARSET_INFO * const cs, const char *str, const char *end, int sq)
 {
   const char *str0= str;
   switch (sq)
@@ -1121,28 +1121,28 @@
 }
 
 
-void my_fill_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+void my_fill_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
 		   char *s, size_t l, int fill)
 {
   memset((uchar*) s, fill, l);
 }
 
 
-size_t my_numchars_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_numchars_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
 		      const char *b, const char *e)
 {
   return (size_t) (e - b);
 }
 
 
-size_t my_numcells_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_numcells_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
                         const char *b, const char *e)
 {
   return (size_t) (e - b);
 }
 
 
-size_t my_charpos_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_charpos_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
                        const char *b  __attribute__((unused)),
                        const char *e  __attribute__((unused)),
                        size_t pos)
@@ -1151,7 +1151,7 @@
 }
 
 
-size_t my_well_formed_len_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_well_formed_len_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
                                const char *start, const char *end,
                                size_t nchars, int *error)
 {
@@ -1161,7 +1161,7 @@
 }
 
 
-size_t my_lengthsp_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_lengthsp_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
                         const char *ptr, size_t length)
 {
   const char *end;
@@ -1170,7 +1170,7 @@
 }
 
 
-uint my_instr_simple(const CHARSET_INFO *cs,
+uint my_instr_simple(const CHARSET_INFO * const cs,
                      const char *b, size_t b_length, 
                      const char *s, size_t s_length,
                      my_match_t *match, uint nmatch)
@@ -1365,14 +1365,14 @@
 }
 
 
-int64_t my_strtoll10_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+int64_t my_strtoll10_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
                            const char *nptr, char **endptr, int *error)
 {
   return my_strtoll10(nptr, endptr, error);
 }
 
 
-int my_mb_ctype_8bit(const CHARSET_INFO *cs, int *ctype,
+int my_mb_ctype_8bit(const CHARSET_INFO * const cs, int *ctype,
                    const uchar *s, const uchar *e)
 {
   if (s >= e)
@@ -1474,7 +1474,7 @@
 */
 
 uint64_t
-my_strntoull10rnd_8bit(const CHARSET_INFO *cs __attribute__((unused)),
+my_strntoull10rnd_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
                        const char *str, size_t length, int unsigned_flag,
                        char **endptr, int *error)
 {
@@ -1752,7 +1752,7 @@
 
 
 
-my_bool my_propagate_simple(const CHARSET_INFO *cs __attribute__((unused)),
+my_bool my_propagate_simple(const CHARSET_INFO * const cs __attribute__((unused)),
                             const uchar *str __attribute__((unused)),
                             size_t length __attribute__((unused)))
 {
@@ -1760,7 +1760,7 @@
 }
 
 
-my_bool my_propagate_complex(const CHARSET_INFO *cs __attribute__((unused)),
+my_bool my_propagate_complex(const CHARSET_INFO * const cs __attribute__((unused)),
                              const uchar *str __attribute__((unused)),
                              size_t length __attribute__((unused)))
 {
@@ -1888,7 +1888,7 @@
 
 
 size_t
-my_strxfrm_pad_desc_and_reverse(const CHARSET_INFO *cs,
+my_strxfrm_pad_desc_and_reverse(const CHARSET_INFO * const cs,
                                 uchar *str, uchar *frmend, uchar *strend,
                                 uint nweights, uint flags, uint level)
 {

=== modified file 'mystrings/ctype-sjis.c'
--- mystrings/ctype-sjis.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-sjis.c	2008-08-06 00:04:45 +0000
@@ -181,13 +181,13 @@
                        (0x80<=(c) && (c)<=0xfc))
 
 
-static uint ismbchar_sjis(const CHARSET_INFO *cs __attribute__((unused)),
+static uint ismbchar_sjis(const CHARSET_INFO * const cs __attribute__((unused)),
 			 const char* p, const char *e)
 {
   return (issjishead((uchar) *p) && (e-p)>1 && issjistail((uchar)p[1]) ? 2: 0);
 }
 
-static uint mbcharlen_sjis(const CHARSET_INFO *cs __attribute__((unused)),uint c)
+static uint mbcharlen_sjis(const CHARSET_INFO * const cs __attribute__((unused)),uint c)
 {
   return (issjishead((uchar) c) ? 2 : 1);
 }
@@ -196,7 +196,7 @@
 #define sjiscode(c,d)	((((uint) (uchar)(c)) << 8) | (uint) (uchar) (d))
 
 
-static int my_strnncoll_sjis_internal(const CHARSET_INFO *cs,
+static int my_strnncoll_sjis_internal(const CHARSET_INFO * const cs,
 				      const uchar **a_res, size_t a_length,
 				      const uchar **b_res, size_t b_length)
 {
@@ -228,7 +228,7 @@
 }
 
 
-static int my_strnncoll_sjis(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_strnncoll_sjis(const CHARSET_INFO * const cs __attribute__((unused)),
                              const uchar *a, size_t a_length, 
                              const uchar *b, size_t b_length,
                              my_bool b_is_prefix)
@@ -240,7 +240,7 @@
 }
 
 
-static int my_strnncollsp_sjis(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_strnncollsp_sjis(const CHARSET_INFO * const cs __attribute__((unused)),
 			       const uchar *a, size_t a_length, 
 			       const uchar *b, size_t b_length,
                                my_bool diff_if_only_endspace_difference)
@@ -298,7 +298,7 @@
 
 #define max_sort_char ((char) 255)
 
-static my_bool my_like_range_sjis(const CHARSET_INFO *cs __attribute__((unused)),
+static my_bool my_like_range_sjis(const CHARSET_INFO * const cs __attribute__((unused)),
 				  const char *ptr,size_t ptr_length,
 				  char escape, char w_one, char w_many,
 				  size_t res_length,
@@ -4461,7 +4461,7 @@
 
 
 static int
-my_wc_mb_sjis(const CHARSET_INFO *cs  __attribute__((unused)),
+my_wc_mb_sjis(const CHARSET_INFO * const cs  __attribute__((unused)),
 	      my_wc_t wc, uchar *s, uchar *e)
 {
   int code;
@@ -4500,7 +4500,7 @@
 
 
 static int 
-my_mb_wc_sjis(const CHARSET_INFO *cs  __attribute__((unused)),
+my_mb_wc_sjis(const CHARSET_INFO * const cs  __attribute__((unused)),
 	      my_wc_t *pwc, const uchar *s, const uchar *e){
   int hi;
   
@@ -4529,7 +4529,7 @@
 }
 
 static
-size_t my_numcells_sjis(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_numcells_sjis(const CHARSET_INFO * const cs __attribute__((unused)),
                       const char *str, const char *str_end)
 {
   size_t clen;
@@ -4562,7 +4562,7 @@
   CP932 additional characters are also accepted.
 */
 static
-size_t my_well_formed_len_sjis(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_well_formed_len_sjis(const CHARSET_INFO * const cs __attribute__((unused)),
                                const char *b, const char *e,
                                size_t pos, int *error)
 {

=== modified file 'mystrings/ctype-tis620.c'
--- mystrings/ctype-tis620.c	2008-07-31 21:07:41 +0000
+++ mystrings/ctype-tis620.c	2008-08-06 00:04:45 +0000
@@ -524,7 +524,7 @@
 */
 
 static
-int my_strnncoll_tis620(const CHARSET_INFO *cs __attribute__((unused)),
+int my_strnncoll_tis620(const CHARSET_INFO * const cs __attribute__((unused)),
                         const uchar *s1, size_t len1, 
                         const uchar *s2, size_t len2,
                         my_bool s2_is_prefix)
@@ -554,7 +554,7 @@
 
 
 static
-int my_strnncollsp_tis620(const CHARSET_INFO * cs __attribute__((unused)),
+int my_strnncollsp_tis620(const CHARSET_INFO * const  cs __attribute__((unused)),
 			  const uchar *a0, size_t a_length, 
 			  const uchar *b0, size_t b_length,
                           my_bool diff_if_only_endspace_difference)
@@ -631,7 +631,7 @@
 */
 
 static
-size_t my_strnxfrm_tis620(const CHARSET_INFO *cs,
+size_t my_strnxfrm_tis620(const CHARSET_INFO * const cs,
                        uchar *dst, size_t dstlen, uint nweights,
                        const uchar *src, size_t srclen, uint flags)
 {
@@ -819,7 +819,7 @@
 
 
 static
-int my_mb_wc_tis620(const CHARSET_INFO *cs  __attribute__((unused)),
+int my_mb_wc_tis620(const CHARSET_INFO * const cs  __attribute__((unused)),
 		  my_wc_t *wc,
 		  const uchar *str,
 		  const uchar *end __attribute__((unused)))
@@ -832,7 +832,7 @@
 }
 
 static
-int my_wc_mb_tis620(const CHARSET_INFO *cs  __attribute__((unused)),
+int my_wc_mb_tis620(const CHARSET_INFO * const cs  __attribute__((unused)),
 		  my_wc_t wc,
 		  uchar *str,
 		  uchar *end __attribute__((unused)))

=== modified file 'mystrings/ctype-uca.c'
--- mystrings/ctype-uca.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-uca.c	2008-08-06 00:04:45 +0000
@@ -6757,7 +6757,7 @@
   uint16_t implicit[2];
   int page;
   int code;
-  const CHARSET_INFO *cs;
+  const CHARSET_INFO * cs;
 } my_uca_scanner;
 
 /*
@@ -6766,7 +6766,7 @@
 */
 typedef struct my_uca_scanner_handler_st 
 {
-  void (*init)(my_uca_scanner *scanner, const CHARSET_INFO *cs, 
+  void (*init)(my_uca_scanner *scanner, const CHARSET_INFO * const cs, 
                const uchar *str, size_t length);
   int (*next)(my_uca_scanner *scanner);
 } my_uca_scanner_handler;
@@ -6793,7 +6793,7 @@
 */
 
 static void my_uca_scanner_init_ucs2(my_uca_scanner *scanner,
-                                     const CHARSET_INFO *cs __attribute__((unused)),
+                                     const CHARSET_INFO * const cs __attribute__((unused)),
                                      const uchar *str, size_t length)
 {
   scanner->wbeg= nochar; 
@@ -6945,7 +6945,7 @@
   The same two functions for any character set
 */
 static void my_uca_scanner_init_any(my_uca_scanner *scanner,
-				    const CHARSET_INFO *cs __attribute__((unused)),
+				    const CHARSET_INFO * const cs __attribute__((unused)),
 				    const uchar *str, size_t length)
 {
   /* Note, no needs to initialize scanner->wbeg */
@@ -7089,7 +7089,7 @@
     positive number - means the first string is bigger
 */
 
-static int my_strnncoll_uca(const CHARSET_INFO *cs, 
+static int my_strnncoll_uca(const CHARSET_INFO * const cs, 
                             my_uca_scanner_handler *scanner_handler,
 			    const uchar *s, size_t slen,
                             const uchar *t, size_t tlen,
@@ -7160,7 +7160,7 @@
     positive number - means the first string is bigger
 */
 
-static int my_strnncollsp_uca(const CHARSET_INFO *cs, 
+static int my_strnncollsp_uca(const CHARSET_INFO * const cs, 
                               my_uca_scanner_handler *scanner_handler,
                               const uchar *s, size_t slen,
                               const uchar *t, size_t tlen,
@@ -7238,7 +7238,7 @@
     N/A
 */
 
-static void my_hash_sort_uca(const CHARSET_INFO *cs,
+static void my_hash_sort_uca(const CHARSET_INFO * const cs,
                              my_uca_scanner_handler *scanner_handler,
 			     const uchar *s, size_t slen,
 			     ulong *n1, ulong *n2)
@@ -7290,7 +7290,7 @@
     Number of bytes that have been written into the binary image.
 */
 
-static size_t my_strnxfrm_uca(const CHARSET_INFO *cs, 
+static size_t my_strnxfrm_uca(const CHARSET_INFO * const cs, 
                            my_uca_scanner_handler *scanner_handler,
                            uchar *dst, size_t dstlen, uint nweights,
                            const uchar *src, size_t srclen, uint flags)
@@ -7332,7 +7332,7 @@
   little-endian and big-endian machines.
 */
 
-static int my_uca_charcmp(const CHARSET_INFO *cs, my_wc_t wc1, my_wc_t wc2)
+static int my_uca_charcmp(const CHARSET_INFO * const cs, my_wc_t wc1, my_wc_t wc2)
 {
   size_t page1= wc1 >> MY_UCA_PSHIFT;
   size_t page2= wc2 >> MY_UCA_PSHIFT;
@@ -7365,7 +7365,7 @@
 */
 
 static
-int my_wildcmp_uca(const CHARSET_INFO *cs,
+int my_wildcmp_uca(const CHARSET_INFO * const cs,
 		   const char *str,const char *str_end,
 		   const char *wildstr,const char *wildend,
 		   int escape, int w_one, int w_many)
@@ -8032,7 +8032,7 @@
   return create_tailoring(cs, alloc);
 }
 
-static int my_strnncoll_any_uca(const CHARSET_INFO *cs,
+static int my_strnncoll_any_uca(const CHARSET_INFO * const cs,
                                 const uchar *s, size_t slen,
                                 const uchar *t, size_t tlen,
                                 my_bool t_is_prefix)
@@ -8041,7 +8041,7 @@
                           s, slen, t, tlen, t_is_prefix);
 }
 
-static int my_strnncollsp_any_uca(const CHARSET_INFO *cs,
+static int my_strnncollsp_any_uca(const CHARSET_INFO * const cs,
                                   const uchar *s, size_t slen,
                                   const uchar *t, size_t tlen,
                                   my_bool diff_if_only_endspace_difference)
@@ -8051,14 +8051,14 @@
                             diff_if_only_endspace_difference);
 }   
 
-static void my_hash_sort_any_uca(const CHARSET_INFO *cs,
+static void my_hash_sort_any_uca(const CHARSET_INFO * const cs,
                                  const uchar *s, size_t slen,
                                  ulong *n1, ulong *n2)
 {
   my_hash_sort_uca(cs, &my_any_uca_scanner_handler, s, slen, n1, n2); 
 }
 
-static size_t my_strnxfrm_any_uca(const CHARSET_INFO *cs, 
+static size_t my_strnxfrm_any_uca(const CHARSET_INFO * const cs, 
                                   uchar *dst, size_t dstlen, uint nweights,
                                   const uchar *src, size_t srclen, uint flags)
 {
@@ -8071,7 +8071,7 @@
 /*
   UCS2 optimized CHARSET_INFO compatible wrappers.
 */
-static int my_strnncoll_ucs2_uca(const CHARSET_INFO *cs,
+static int my_strnncoll_ucs2_uca(const CHARSET_INFO * const cs,
                                  const uchar *s, size_t slen,
                                  const uchar *t, size_t tlen,
                                  my_bool t_is_prefix)
@@ -8080,7 +8080,7 @@
                           s, slen, t, tlen, t_is_prefix);
 }
 
-static int my_strnncollsp_ucs2_uca(const CHARSET_INFO *cs,
+static int my_strnncollsp_ucs2_uca(const CHARSET_INFO * const cs,
                                    const uchar *s, size_t slen,
                                    const uchar *t, size_t tlen,
                                    my_bool diff_if_only_endspace_difference)
@@ -8090,14 +8090,14 @@
                             diff_if_only_endspace_difference);
 }   
 
-static void my_hash_sort_ucs2_uca(const CHARSET_INFO *cs,
+static void my_hash_sort_ucs2_uca(const CHARSET_INFO * const cs,
                                   const uchar *s, size_t slen,
                                   ulong *n1, ulong *n2)
 {
   my_hash_sort_uca(cs, &my_ucs2_uca_scanner_handler, s, slen, n1, n2); 
 }
 
-static size_t my_strnxfrm_ucs2_uca(const CHARSET_INFO *cs,
+static size_t my_strnxfrm_ucs2_uca(const CHARSET_INFO * const cs,
                                    uchar *dst, size_t dstlen, uint nweights,
                                    const uchar *src, size_t srclen, uint flags)
 {

=== modified file 'mystrings/ctype-ucs2.c'
--- mystrings/ctype-ucs2.c	2008-08-02 18:45:47 +0000
+++ mystrings/ctype-ucs2.c	2008-08-06 00:04:45 +0000
@@ -69,7 +69,7 @@
 
 
 static size_t
-my_caseup_str_mb2_or_mb4(const CHARSET_INFO * cs  __attribute__((unused)), 
+my_caseup_str_mb2_or_mb4(const CHARSET_INFO * const  cs  __attribute__((unused)), 
                          char * s __attribute__((unused)))
 {
   assert(0);
@@ -78,7 +78,7 @@
 
 
 static size_t
-my_casedn_str_mb2_or_mb4(const CHARSET_INFO *cs __attribute__((unused)), 
+my_casedn_str_mb2_or_mb4(const CHARSET_INFO * const cs __attribute__((unused)), 
                          char * s __attribute__((unused)))
 {
   assert(0);
@@ -87,7 +87,7 @@
 
 
 static int
-my_strcasecmp_mb2_or_mb4(const CHARSET_INFO *cs __attribute__((unused)),
+my_strcasecmp_mb2_or_mb4(const CHARSET_INFO * const cs __attribute__((unused)),
                          const char *s __attribute__((unused)),
                          const char *t __attribute__((unused)))
 {
@@ -97,7 +97,7 @@
 
 
 static long
-my_strntol_mb2_or_mb4(const CHARSET_INFO *cs,
+my_strntol_mb2_or_mb4(const CHARSET_INFO * const cs,
                       const char *nptr, size_t l, int base,
                       char **endptr, int *err)
 {
@@ -213,7 +213,7 @@
 
 
 static ulong
-my_strntoul_mb2_or_mb4(const CHARSET_INFO *cs,
+my_strntoul_mb2_or_mb4(const CHARSET_INFO * const cs,
                        const char *nptr, size_t l, int base, 
                        char **endptr, int *err)
 {
@@ -322,7 +322,7 @@
 
 
 static int64_t 
-my_strntoll_mb2_or_mb4(const CHARSET_INFO *cs,
+my_strntoll_mb2_or_mb4(const CHARSET_INFO * const cs,
                        const char *nptr, size_t l, int base,
                        char **endptr, int *err)
 {
@@ -438,7 +438,7 @@
 
 
 static uint64_t
-my_strntoull_mb2_or_mb4(const CHARSET_INFO *cs,
+my_strntoull_mb2_or_mb4(const CHARSET_INFO * const cs,
                         const char *nptr, size_t l, int base,
                         char **endptr, int *err)
 {
@@ -547,7 +547,7 @@
 
 
 static double
-my_strntod_mb2_or_mb4(const CHARSET_INFO *cs,
+my_strntod_mb2_or_mb4(const CHARSET_INFO * const cs,
                       char *nptr, size_t length, 
                       char **endptr, int *err)
 {
@@ -581,7 +581,7 @@
 
 
 static uint64_t
-my_strntoull10rnd_mb2_or_mb4(const CHARSET_INFO *cs,
+my_strntoull10rnd_mb2_or_mb4(const CHARSET_INFO * const cs,
                              const char *nptr, size_t length,
                              int unsign_fl,
                              char **endptr, int *err)
@@ -616,7 +616,7 @@
 */
 
 static size_t
-my_l10tostr_mb2_or_mb4(const CHARSET_INFO *cs,
+my_l10tostr_mb2_or_mb4(const CHARSET_INFO * const cs,
                        char *dst, size_t len, int radix, long int val)
 {
   char buffer[66];
@@ -667,7 +667,7 @@
 
 
 static size_t
-my_ll10tostr_mb2_or_mb4(const CHARSET_INFO *cs,
+my_ll10tostr_mb2_or_mb4(const CHARSET_INFO * const cs,
                         char *dst, size_t len, int radix, int64_t val)
 {
   char buffer[65];
@@ -733,7 +733,7 @@
 
 #ifdef HAVE_CHARSET_mb2
 static int64_t
-my_strtoll10_mb2(const CHARSET_INFO *cs __attribute__((unused)),
+my_strtoll10_mb2(const CHARSET_INFO * const cs __attribute__((unused)),
                  const char *nptr, char **endptr, int *error)
 {
   const char *s, *end, *start, *n_end, *true_end;
@@ -902,7 +902,7 @@
 
 
 static size_t
-my_scan_mb2(const CHARSET_INFO *cs __attribute__((unused)),
+my_scan_mb2(const CHARSET_INFO * const cs __attribute__((unused)),
             const char *str, const char *end, int sequence_type)
 {
   const char *str0= str;
@@ -924,7 +924,7 @@
 
 
 static void
-my_fill_mb2(const CHARSET_INFO *cs __attribute__((unused)),
+my_fill_mb2(const CHARSET_INFO * const cs __attribute__((unused)),
             char *s, size_t l, int fill)
 {
   for ( ; l >= 2; s[0]= 0, s[1]= fill, s+= 2, l-= 2);
@@ -1010,7 +1010,7 @@
 
 
 static size_t
-my_snprintf_mb2(const CHARSET_INFO *cs __attribute__((unused)),
+my_snprintf_mb2(const CHARSET_INFO * const cs __attribute__((unused)),
              char* to, size_t n, const char* fmt, ...)
 {
   va_list args;
@@ -1020,7 +1020,7 @@
 
 
 static size_t
-my_lengthsp_mb2(const CHARSET_INFO *cs __attribute__((unused)),
+my_lengthsp_mb2(const CHARSET_INFO * const cs __attribute__((unused)),
                 const char *ptr, size_t length)
 {
   const char *end= ptr + length;
@@ -1045,7 +1045,7 @@
 #define MY_UTF16_SURROGATE(x)  (((x) & 0xF800) == 0xD800)
 
 static int
-my_utf16_uni(const CHARSET_INFO *cs __attribute__((unused)),
+my_utf16_uni(const CHARSET_INFO * const cs __attribute__((unused)),
              my_wc_t *pwc, const uchar *s, const uchar *e)
 {
   if (s + 2 > e)
@@ -1087,7 +1087,7 @@
 
 
 static int
-my_uni_utf16(const CHARSET_INFO *cs __attribute__((unused)),
+my_uni_utf16(const CHARSET_INFO * const cs __attribute__((unused)),
              my_wc_t wc, uchar *s, uchar *e)
 {
   if (wc <= 0xFFFF)
@@ -1151,7 +1151,7 @@
 
 
 static size_t
-my_caseup_utf16(const CHARSET_INFO *cs, char *src, size_t srclen,
+my_caseup_utf16(const CHARSET_INFO * const cs, char *src, size_t srclen,
                 char *dst __attribute__((unused)),
                 size_t dstlen __attribute__((unused)))
 {
@@ -1174,7 +1174,7 @@
 
 
 static void
-my_hash_sort_utf16(const CHARSET_INFO *cs, const uchar *s, size_t slen,
+my_hash_sort_utf16(const CHARSET_INFO * const cs, const uchar *s, size_t slen,
                    ulong *n1, ulong *n2)
 {
   my_wc_t wc;
@@ -1198,7 +1198,7 @@
 
 
 static size_t
-my_casedn_utf16(const CHARSET_INFO *cs, char *src, size_t srclen,
+my_casedn_utf16(const CHARSET_INFO * const cs, char *src, size_t srclen,
                 char *dst __attribute__((unused)),
                 size_t dstlen __attribute__((unused)))
 {
@@ -1221,7 +1221,7 @@
 
 
 static int
-my_strnncoll_utf16(const CHARSET_INFO *cs, 
+my_strnncoll_utf16(const CHARSET_INFO * const cs, 
                    const uchar *s, size_t slen, 
                    const uchar *t, size_t tlen,
                    my_bool t_is_prefix)
@@ -1285,7 +1285,7 @@
 */
 
 static int
-my_strnncollsp_utf16(const CHARSET_INFO *cs,
+my_strnncollsp_utf16(const CHARSET_INFO * const cs,
                      const uchar *s, size_t slen,
                      const uchar *t, size_t tlen,
                      my_bool diff_if_only_endspace_difference)
@@ -1359,7 +1359,7 @@
 
 
 static size_t
-my_strnxfrm_utf16(const CHARSET_INFO *cs, 
+my_strnxfrm_utf16(const CHARSET_INFO * const cs, 
                   uchar *dst, size_t dstlen, uint nweights,
                   const uchar *src, size_t srclen, uint flags)
 {
@@ -1392,7 +1392,7 @@
 
 
 static uint
-my_ismbchar_utf16(const CHARSET_INFO *cs __attribute__((unused)),
+my_ismbchar_utf16(const CHARSET_INFO * const cs __attribute__((unused)),
                   const char *b __attribute__((unused)),
                   const char *e __attribute__((unused)))
 {
@@ -1412,7 +1412,7 @@
 
 
 static uint
-my_mbcharlen_utf16(const CHARSET_INFO *cs  __attribute__((unused)),
+my_mbcharlen_utf16(const CHARSET_INFO * const cs  __attribute__((unused)),
                    uint c __attribute__((unused)))
 {
   return MY_UTF16_HIGH_HEAD(c) ? 4 : 2;
@@ -1420,7 +1420,7 @@
 
 
 static size_t
-my_numchars_utf16(const CHARSET_INFO *cs,
+my_numchars_utf16(const CHARSET_INFO * const cs,
                   const char *b, const char *e)
 {
   size_t nchars= 0;
@@ -1436,7 +1436,7 @@
 
 
 static size_t
-my_charpos_utf16(const CHARSET_INFO *cs,
+my_charpos_utf16(const CHARSET_INFO * const cs,
                  const char *b, const char *e, size_t pos)
 {
   const char *b0= b;
@@ -1452,7 +1452,7 @@
 
 
 static size_t
-my_well_formed_len_utf16(const CHARSET_INFO *cs,
+my_well_formed_len_utf16(const CHARSET_INFO * const cs,
                          const char *b, const char *e,
                          size_t nchars, int *error)
 {
@@ -1473,7 +1473,7 @@
 
 
 static int
-my_wildcmp_utf16_ci(const CHARSET_INFO *cs,
+my_wildcmp_utf16_ci(const CHARSET_INFO * const cs,
                     const char *str,const char *str_end,
                     const char *wildstr,const char *wildend,
                     int escape, int w_one, int w_many)
@@ -1485,7 +1485,7 @@
 
 
 static int
-my_wildcmp_utf16_bin(const CHARSET_INFO *cs,
+my_wildcmp_utf16_bin(const CHARSET_INFO * const cs,
                      const char *str,const char *str_end,
                      const char *wildstr,const char *wildend,
                      int escape, int w_one, int w_many)
@@ -1496,7 +1496,7 @@
 
 
 static int
-my_strnncoll_utf16_bin(const CHARSET_INFO *cs, 
+my_strnncoll_utf16_bin(const CHARSET_INFO * const cs, 
                        const uchar *s, size_t slen,
                        const uchar *t, size_t tlen,
                        my_bool t_is_prefix)
@@ -1529,7 +1529,7 @@
 
 
 static int
-my_strnncollsp_utf16_bin(const CHARSET_INFO *cs,
+my_strnncollsp_utf16_bin(const CHARSET_INFO * const cs,
                          const uchar *s, size_t slen,
                          const uchar *t, size_t tlen,
                          my_bool diff_if_only_endspace_difference)
@@ -1599,7 +1599,7 @@
 
 
 static size_t
-my_strnxfrm_utf16_bin(const CHARSET_INFO *cs,
+my_strnxfrm_utf16_bin(const CHARSET_INFO * const cs,
                       uchar *dst, size_t dstlen, uint nweights,
                       const uchar *src, size_t srclen, uint flags)
 {
@@ -1615,7 +1615,7 @@
 
 
 static void
-my_hash_sort_utf16_bin(const CHARSET_INFO *cs __attribute__((unused)),
+my_hash_sort_utf16_bin(const CHARSET_INFO * const cs __attribute__((unused)),
                        const uchar *key, size_t len,ulong *nr1, ulong *nr2)
 {
   const uchar *pos = key;
@@ -1654,7 +1654,7 @@
 */
 
 my_bool
-my_like_range_utf16(const CHARSET_INFO *cs,
+my_like_range_utf16(const CHARSET_INFO * const cs,
                     const char *ptr, size_t ptr_length,
                     char escape, char w_one, char w_many,
                     size_t res_length,
@@ -1865,7 +1865,7 @@
 #ifdef HAVE_CHARSET_utf32
 
 static int
-my_utf32_uni(const CHARSET_INFO *cs __attribute__((unused)),
+my_utf32_uni(const CHARSET_INFO * const cs __attribute__((unused)),
              my_wc_t *pwc, const uchar *s, const uchar *e)
 {
   if (s + 4 > e)
@@ -1876,7 +1876,7 @@
 
 
 static int
-my_uni_utf32(const CHARSET_INFO *cs __attribute__((unused)),
+my_uni_utf32(const CHARSET_INFO * const cs __attribute__((unused)),
              my_wc_t wc, uchar *s, uchar *e)
 {
   if (s + 4 > e) 
@@ -1925,7 +1925,7 @@
 
 
 static size_t
-my_caseup_utf32(const CHARSET_INFO *cs, char *src, size_t srclen,
+my_caseup_utf32(const CHARSET_INFO * const cs, char *src, size_t srclen,
                 char *dst __attribute__((unused)),
                 size_t dstlen __attribute__((unused)))
 {
@@ -1956,7 +1956,7 @@
 
 
 static void
-my_hash_sort_utf32(const CHARSET_INFO *cs, const uchar *s, size_t slen,
+my_hash_sort_utf32(const CHARSET_INFO * const cs, const uchar *s, size_t slen,
                    ulong *n1, ulong *n2)
 {
   my_wc_t wc;
@@ -1981,7 +1981,7 @@
 
 
 static size_t
-my_casedn_utf32(const CHARSET_INFO *cs, char *src, size_t srclen,
+my_casedn_utf32(const CHARSET_INFO * const cs, char *src, size_t srclen,
                 char *dst __attribute__((unused)),
                 size_t dstlen __attribute__((unused)))
 {
@@ -2003,7 +2003,7 @@
 
 
 static int
-my_strnncoll_utf32(const CHARSET_INFO *cs, 
+my_strnncoll_utf32(const CHARSET_INFO * const cs, 
                    const uchar *s, size_t slen, 
                    const uchar *t, size_t tlen,
                    my_bool t_is_prefix)
@@ -2067,7 +2067,7 @@
 
 
 static int
-my_strnncollsp_utf32(const CHARSET_INFO *cs,
+my_strnncollsp_utf32(const CHARSET_INFO * const cs,
                      const uchar *s, size_t slen,
                      const uchar *t, size_t tlen,
                      my_bool diff_if_only_endspace_difference)
@@ -2141,14 +2141,14 @@
 
 
 static size_t
-my_strnxfrmlen_utf32(const CHARSET_INFO *cs __attribute__((unused)), size_t len)
+my_strnxfrmlen_utf32(const CHARSET_INFO * const cs __attribute__((unused)), size_t len)
 {
   return len / 2;
 }
 
 
 static void
-my_fill_utf32_for_strxfrm(const CHARSET_INFO *cs __attribute__((unused)),
+my_fill_utf32_for_strxfrm(const CHARSET_INFO * const cs __attribute__((unused)),
                           char *s, size_t slen, int fill)
 {
   assert(fill <= 0xFFFF);
@@ -2164,7 +2164,7 @@
 
 
 static size_t
-my_strxfrm_pad_desc_and_reverse_utf32(const CHARSET_INFO *cs,
+my_strxfrm_pad_desc_and_reverse_utf32(const CHARSET_INFO * const cs,
                                       uchar *str, uchar *frmend, uchar *strend,
                                       uint nweights, uint flags, uint level)
 {
@@ -2180,7 +2180,7 @@
 
 
 static size_t
-my_strnxfrm_utf32(const CHARSET_INFO *cs, 
+my_strnxfrm_utf32(const CHARSET_INFO * const cs, 
                   uchar *dst, size_t dstlen, uint nweights,
                   const uchar *src, size_t srclen, uint flags)
 {
@@ -2213,7 +2213,7 @@
 
 
 static uint
-my_ismbchar_utf32(const CHARSET_INFO *cs __attribute__((unused)),
+my_ismbchar_utf32(const CHARSET_INFO * const cs __attribute__((unused)),
                   const char *b __attribute__((unused)),
                   const char *e __attribute__((unused)))
 {
@@ -2222,7 +2222,7 @@
 
 
 static uint
-my_mbcharlen_utf32(const CHARSET_INFO *cs  __attribute__((unused)) , 
+my_mbcharlen_utf32(const CHARSET_INFO * const cs  __attribute__((unused)) , 
                    uint c __attribute__((unused)))
 {
   return 4;
@@ -2319,7 +2319,7 @@
 
 
 static size_t
-my_snprintf_utf32(const CHARSET_INFO *cs __attribute__((unused)),
+my_snprintf_utf32(const CHARSET_INFO * const cs __attribute__((unused)),
                   char* to, size_t n, const char* fmt, ...)
 {
   va_list args;
@@ -2329,7 +2329,7 @@
 
 
 static int64_t
-my_strtoll10_utf32(const CHARSET_INFO *cs __attribute__((unused)),
+my_strtoll10_utf32(const CHARSET_INFO * const cs __attribute__((unused)),
                    const char *nptr, char **endptr, int *error)
 {
   const char *s, *end, *start, *n_end, *true_end;
@@ -2499,7 +2499,7 @@
 
 
 static size_t
-my_numchars_utf32(const CHARSET_INFO *cs __attribute__((unused)),
+my_numchars_utf32(const CHARSET_INFO * const cs __attribute__((unused)),
                   const char *b, const char *e)
 {
   return (size_t) (e - b) / 4;
@@ -2507,7 +2507,7 @@
 
 
 static size_t
-my_charpos_utf32(const CHARSET_INFO *cs __attribute__((unused)),
+my_charpos_utf32(const CHARSET_INFO * const cs __attribute__((unused)),
                  const char *b, const char *e, size_t pos)
 {
   size_t string_length= (size_t) (e - b);
@@ -2516,7 +2516,7 @@
 
 
 static size_t
-my_well_formed_len_utf32(const CHARSET_INFO *cs __attribute__((unused)),
+my_well_formed_len_utf32(const CHARSET_INFO * const cs __attribute__((unused)),
                          const char *b, const char *e,
                          size_t nchars, int *error)
 {
@@ -2544,7 +2544,7 @@
 
 
 static
-void my_fill_utf32(const CHARSET_INFO *cs,
+void my_fill_utf32(const CHARSET_INFO * const cs,
                    char *s, size_t slen, int fill)
 {
   char buf[10];
@@ -2565,7 +2565,7 @@
 
 
 static size_t
-my_lengthsp_utf32(const CHARSET_INFO *cs __attribute__((unused)),
+my_lengthsp_utf32(const CHARSET_INFO * const cs __attribute__((unused)),
                   const char *ptr, size_t length)
 {
   const char *end= ptr + length;
@@ -2577,7 +2577,7 @@
 
 
 static int
-my_wildcmp_utf32_ci(const CHARSET_INFO *cs,
+my_wildcmp_utf32_ci(const CHARSET_INFO * const cs,
                     const char *str, const char *str_end,
                     const char *wildstr, const char *wildend,
                     int escape, int w_one, int w_many)
@@ -2589,7 +2589,7 @@
 
 
 static int
-my_wildcmp_utf32_bin(const CHARSET_INFO *cs,
+my_wildcmp_utf32_bin(const CHARSET_INFO * const cs,
                      const char *str,const char *str_end,
                      const char *wildstr,const char *wildend,
                      int escape, int w_one, int w_many)
@@ -2600,7 +2600,7 @@
 
 
 static int
-my_strnncoll_utf32_bin(const CHARSET_INFO *cs, 
+my_strnncoll_utf32_bin(const CHARSET_INFO * const cs, 
                        const uchar *s, size_t slen,
                        const uchar *t, size_t tlen,
                        my_bool t_is_prefix)
@@ -2643,7 +2643,7 @@
 
 
 static int
-my_strnncollsp_utf32_bin(const CHARSET_INFO *cs __attribute__((unused)), 
+my_strnncollsp_utf32_bin(const CHARSET_INFO * const cs __attribute__((unused)), 
                          const uchar *s, size_t slen, 
                          const uchar *t, size_t tlen,
                          my_bool diff_if_only_endspace_difference
@@ -2710,7 +2710,7 @@
 */
 
 my_bool
-my_like_range_utf32(const CHARSET_INFO *cs,
+my_like_range_utf32(const CHARSET_INFO * const cs,
                     const char *ptr, size_t ptr_length,
                     char escape, char w_one, char w_many,
                     size_t res_length,
@@ -2798,7 +2798,7 @@
 
 
 static size_t
-my_scan_utf32(const CHARSET_INFO *cs,
+my_scan_utf32(const CHARSET_INFO * const cs,
               const char *str, const char *end, int sequence_type)
 {
   const char *str0= str;
@@ -3019,7 +3019,7 @@
 };
 
 
-static int my_ucs2_uni(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_ucs2_uni(const CHARSET_INFO * const cs __attribute__((unused)),
 		       my_wc_t * pwc, const uchar *s, const uchar *e)
 {
   if (s+2 > e) /* Need 2 characters */
@@ -3029,7 +3029,7 @@
   return 2;
 }
 
-static int my_uni_ucs2(const CHARSET_INFO *cs __attribute__((unused)) ,
+static int my_uni_ucs2(const CHARSET_INFO * const cs __attribute__((unused)) ,
 		       my_wc_t wc, uchar *r, uchar *e)
 {
   if ( r+2 > e ) 
@@ -3041,7 +3041,7 @@
 }
 
 
-static size_t my_caseup_ucs2(const CHARSET_INFO *cs, char *src, size_t srclen,
+static size_t my_caseup_ucs2(const CHARSET_INFO * const cs, char *src, size_t srclen,
                            char *dst __attribute__((unused)),
                            size_t dstlen __attribute__((unused)))
 {
@@ -3064,7 +3064,7 @@
 }
 
 
-static void my_hash_sort_ucs2(const CHARSET_INFO *cs, const uchar *s, size_t slen,
+static void my_hash_sort_ucs2(const CHARSET_INFO * const cs, const uchar *s, size_t slen,
 			      ulong *n1, ulong *n2)
 {
   my_wc_t wc;
@@ -3088,7 +3088,7 @@
 }
 
 
-static size_t my_casedn_ucs2(const CHARSET_INFO *cs, char *src, size_t srclen,
+static size_t my_casedn_ucs2(const CHARSET_INFO * const cs, char *src, size_t srclen,
                            char *dst __attribute__((unused)),
                            size_t dstlen __attribute__((unused)))
 {
@@ -3111,7 +3111,7 @@
 }
 
 
-static int my_strnncoll_ucs2(const CHARSET_INFO *cs, 
+static int my_strnncoll_ucs2(const CHARSET_INFO * const cs, 
 			     const uchar *s, size_t slen, 
                              const uchar *t, size_t tlen,
                              my_bool t_is_prefix)
@@ -3176,7 +3176,7 @@
     @retval Positive number, if a > b
 */
 
-static int my_strnncollsp_ucs2(const CHARSET_INFO *cs __attribute__((unused)),
+static int my_strnncollsp_ucs2(const CHARSET_INFO * const cs __attribute__((unused)),
                                const uchar *s, size_t slen,
                                const uchar *t, size_t tlen,
                                my_bool diff_if_only_endspace_difference
@@ -3228,7 +3228,7 @@
 
 
 static size_t
-my_strnxfrm_ucs2(const CHARSET_INFO *cs, 
+my_strnxfrm_ucs2(const CHARSET_INFO * const cs, 
                  uchar *dst, size_t dstlen, uint nweights,
                  const uchar *src, size_t srclen, uint flags)
 {
@@ -3262,7 +3262,7 @@
 }
 
 
-static uint my_ismbchar_ucs2(const CHARSET_INFO *cs __attribute__((unused)),
+static uint my_ismbchar_ucs2(const CHARSET_INFO * const cs __attribute__((unused)),
                              const char *b __attribute__((unused)),
                              const char *e __attribute__((unused)))
 {
@@ -3270,7 +3270,7 @@
 }
 
 
-static uint my_mbcharlen_ucs2(const CHARSET_INFO *cs  __attribute__((unused)) , 
+static uint my_mbcharlen_ucs2(const CHARSET_INFO * const cs  __attribute__((unused)) , 
                               uint c __attribute__((unused)))
 {
   return 2;
@@ -3278,7 +3278,7 @@
 
 
 static
-size_t my_numchars_ucs2(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_numchars_ucs2(const CHARSET_INFO * const cs __attribute__((unused)),
                         const char *b, const char *e)
 {
   return (size_t) (e-b)/2;
@@ -3286,7 +3286,7 @@
 
 
 static
-size_t my_charpos_ucs2(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_charpos_ucs2(const CHARSET_INFO * const cs __attribute__((unused)),
                        const char *b, const char *e, size_t pos)
 {
   size_t string_length= (size_t) (e - b);
@@ -3295,7 +3295,7 @@
 
 
 static
-size_t my_well_formed_len_ucs2(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_well_formed_len_ucs2(const CHARSET_INFO * const cs __attribute__((unused)),
                                const char *b, const char *e,
                                size_t nchars, int *error)
 {
@@ -3308,7 +3308,7 @@
 
 
 static
-int my_wildcmp_ucs2_ci(const CHARSET_INFO *cs,
+int my_wildcmp_ucs2_ci(const CHARSET_INFO * const cs,
 		    const char *str,const char *str_end,
 		    const char *wildstr,const char *wildend,
 		    int escape, int w_one, int w_many)
@@ -3320,7 +3320,7 @@
 
 
 static
-int my_wildcmp_ucs2_bin(const CHARSET_INFO *cs,
+int my_wildcmp_ucs2_bin(const CHARSET_INFO * const cs,
 		    const char *str,const char *str_end,
 		    const char *wildstr,const char *wildend,
 		    int escape, int w_one, int w_many)
@@ -3331,7 +3331,7 @@
 
 
 static
-int my_strnncoll_ucs2_bin(const CHARSET_INFO *cs, 
+int my_strnncoll_ucs2_bin(const CHARSET_INFO * const cs, 
                           const uchar *s, size_t slen,
                           const uchar *t, size_t tlen,
                           my_bool t_is_prefix)
@@ -3362,7 +3362,7 @@
   return (int) (t_is_prefix ? t-te : ((se-s) - (te-t)));
 }
 
-static int my_strnncollsp_ucs2_bin(const CHARSET_INFO *cs __attribute__((unused)), 
+static int my_strnncollsp_ucs2_bin(const CHARSET_INFO * const cs __attribute__((unused)), 
                                    const uchar *s, size_t slen, 
                                    const uchar *t, size_t tlen,
                                    my_bool diff_if_only_endspace_difference
@@ -3410,7 +3410,7 @@
 
 
 static
-size_t my_strnxfrm_ucs2_bin(const CHARSET_INFO *cs,
+size_t my_strnxfrm_ucs2_bin(const CHARSET_INFO * const cs,
                             uchar *dst, size_t dstlen, uint nweights,
                             const uchar *src, size_t srclen, uint flags)
 {
@@ -3425,7 +3425,7 @@
 
 
 static
-void my_hash_sort_ucs2_bin(const CHARSET_INFO *cs __attribute__((unused)),
+void my_hash_sort_ucs2_bin(const CHARSET_INFO * const cs __attribute__((unused)),
 			   const uchar *key, size_t len,ulong *nr1, ulong *nr2)
 {
   const uchar *pos = key;
@@ -3463,7 +3463,7 @@
      @rerval TRUE if LIKE can't be optimized.
 */
 
-my_bool my_like_range_ucs2(const CHARSET_INFO *cs,
+my_bool my_like_range_ucs2(const CHARSET_INFO * const cs,
 			   const char *ptr, size_t ptr_length,
 			   char escape, char w_one, char w_many,
 			   size_t res_length,

=== modified file 'mystrings/ctype-ujis.c'
--- mystrings/ctype-ujis.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-ujis.c	2008-08-06 00:04:45 +0000
@@ -183,7 +183,7 @@
 #define isujis_ss3(c) (((c)&0xff) == 0x8f)
 
 
-static uint ismbchar_ujis(const CHARSET_INFO *cs __attribute__((unused)),
+static uint ismbchar_ujis(const CHARSET_INFO * const cs __attribute__((unused)),
 		  const char* p, const char *e)
 {
   return ((*(uchar*)(p)<0x80)? 0:\
@@ -193,7 +193,7 @@
     0);
 }
 
-static uint mbcharlen_ujis(const CHARSET_INFO *cs __attribute__((unused)),uint c)
+static uint mbcharlen_ujis(const CHARSET_INFO * const cs __attribute__((unused)),uint c)
 {
   return (isujis(c)? 2: isujis_ss2(c)? 2: isujis_ss3(c)? 3: 1);
 }
@@ -236,7 +236,7 @@
 
 
 static int 
-my_mb_wc_jisx0201(const CHARSET_INFO *cs  __attribute__((unused)),
+my_mb_wc_jisx0201(const CHARSET_INFO * const cs  __attribute__((unused)),
 		  my_wc_t *wc,const uchar *s,
 		  const uchar *e __attribute__((unused)))
 {
@@ -246,7 +246,7 @@
 
 
 static int
-my_wc_mb_jisx0201(const CHARSET_INFO *cs __attribute__((unused)),
+my_wc_mb_jisx0201(const CHARSET_INFO * const cs __attribute__((unused)),
 		  my_wc_t wc, uchar *s, 
 		  uchar *e __attribute__((unused)))
 {
@@ -8239,7 +8239,7 @@
 */
 
 static
-size_t my_well_formed_len_ujis(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_well_formed_len_ujis(const CHARSET_INFO * const cs __attribute__((unused)),
                                const char *beg, const char *end,
                                size_t pos, int *error)
 {
@@ -8289,7 +8289,7 @@
 
 
 static
-size_t my_numcells_eucjp(const CHARSET_INFO *cs __attribute__((unused)),
+size_t my_numcells_eucjp(const CHARSET_INFO * const cs __attribute__((unused)),
                        const char *str, const char *str_end)
 {
   size_t clen;
@@ -8324,7 +8324,7 @@
 
 
 static int
-my_mb_wc_euc_jp(const CHARSET_INFO *cs,my_wc_t *pwc, const uchar *s, const uchar *e)
+my_mb_wc_euc_jp(const CHARSET_INFO * const cs,my_wc_t *pwc, const uchar *s, const uchar *e)
 {
   int c1,c2,c3;
   
@@ -8412,7 +8412,7 @@
 
 
 static int
-my_wc_mb_euc_jp(const CHARSET_INFO *c,my_wc_t wc, uchar *s, uchar *e)
+my_wc_mb_euc_jp(const CHARSET_INFO * const c,my_wc_t wc, uchar *s, uchar *e)
 {
   uchar c1;
   int jp;

=== modified file 'mystrings/ctype-utf8.c'
--- mystrings/ctype-utf8.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-utf8.c	2008-08-06 00:04:45 +0000
@@ -1738,7 +1738,7 @@
     @retval  1 if matched with wildcard.
 */
 
-int my_wildcmp_unicode(const CHARSET_INFO *cs,
+int my_wildcmp_unicode(const CHARSET_INFO * const cs,
 		       const char *str,const char *str_end,
 		       const char *wildstr,const char *wildend,
 		       int escape, int w_one, int w_many,
@@ -1979,7 +1979,7 @@
 
 
 static int
-my_mb_wc_utf8mb4(const CHARSET_INFO *cs __attribute__((unused)),
+my_mb_wc_utf8mb4(const CHARSET_INFO * const cs __attribute__((unused)),
                  my_wc_t * pwc, const uchar *s, const uchar *e)
 {
   uchar c;
@@ -2045,7 +2045,7 @@
   for example, for a null-terminated string
 */
 static int
-my_mb_wc_utf8mb4_no_range(const CHARSET_INFO *cs __attribute__((unused)),
+my_mb_wc_utf8mb4_no_range(const CHARSET_INFO * const cs __attribute__((unused)),
                           my_wc_t *pwc, const uchar *s)
 {
   uchar c;
@@ -2099,7 +2099,7 @@
 
 
 static int
-my_wc_mb_utf8mb4(const CHARSET_INFO *cs __attribute__((unused)),
+my_wc_mb_utf8mb4(const CHARSET_INFO * const cs __attribute__((unused)),
                  my_wc_t wc, uchar *r, uchar *e)
 {
   int count;
@@ -2135,7 +2135,7 @@
   The same as above, but without range check.
 */
 static int
-my_wc_mb_utf8mb4_no_range(const CHARSET_INFO *cs __attribute__((unused)),
+my_wc_mb_utf8mb4_no_range(const CHARSET_INFO * const cs __attribute__((unused)),
                           my_wc_t wc, uchar *r)
 {
   int count;
@@ -2201,7 +2201,7 @@
 
 
 static size_t
-my_caseup_utf8mb4(const CHARSET_INFO *cs, char *src, size_t srclen,
+my_caseup_utf8mb4(const CHARSET_INFO * const cs, char *src, size_t srclen,
                   char *dst, size_t dstlen)
 {
   my_wc_t wc;
@@ -2233,7 +2233,7 @@
 
 
 static void
-my_hash_sort_utf8mb4(const CHARSET_INFO *cs, const uchar *s, size_t slen,
+my_hash_sort_utf8mb4(const CHARSET_INFO * const cs, const uchar *s, size_t slen,
                      ulong *n1, ulong *n2)
 {
   my_wc_t wc;
@@ -2270,7 +2270,7 @@
 
 
 static size_t
-my_caseup_str_utf8mb4(const CHARSET_INFO *cs, char *src)
+my_caseup_str_utf8mb4(const CHARSET_INFO * const cs, char *src)
 {
   my_wc_t wc;
   int srcres, dstres;
@@ -2293,7 +2293,7 @@
 
 
 static size_t
-my_casedn_utf8mb4(const CHARSET_INFO *cs,
+my_casedn_utf8mb4(const CHARSET_INFO * const cs,
                   char *src, size_t srclen,
                   char *dst, size_t dstlen)
 {
@@ -2318,7 +2318,7 @@
 
 
 static size_t
-my_casedn_str_utf8mb4(const CHARSET_INFO *cs, char *src)
+my_casedn_str_utf8mb4(const CHARSET_INFO * const cs, char *src)
 {
   my_wc_t wc;
   int srcres, dstres;
@@ -2357,7 +2357,7 @@
 
 
 static int
-my_strnncoll_utf8mb4(const CHARSET_INFO *cs,
+my_strnncoll_utf8mb4(const CHARSET_INFO * const cs,
                      const uchar *s, size_t slen,
                      const uchar *t, size_t tlen,
                      my_bool t_is_prefix)
@@ -2421,7 +2421,7 @@
 */
 
 static int
-my_strnncollsp_utf8mb4(const CHARSET_INFO *cs,
+my_strnncollsp_utf8mb4(const CHARSET_INFO * const cs,
                        const uchar *s, size_t slen,
                        const uchar *t, size_t tlen,
                        my_bool diff_if_only_endspace_difference)
@@ -2509,7 +2509,7 @@
 */
 
 static int
-my_strcasecmp_utf8mb4(const CHARSET_INFO *cs, const char *s, const char *t)
+my_strcasecmp_utf8mb4(const CHARSET_INFO * const cs, const char *s, const char *t)
 {
   MY_UNICASE_INFO **uni_plane= cs->caseinfo;
   while (s[0] && t[0])
@@ -2569,7 +2569,7 @@
 
 
 static int
-my_wildcmp_utf8mb4(const CHARSET_INFO *cs,
+my_wildcmp_utf8mb4(const CHARSET_INFO * const cs,
                    const char *str, const char *strend,
                    const char *wildstr, const char *wildend,
                    int escape, int w_one, int w_many)
@@ -2580,7 +2580,7 @@
 
 
 static size_t
-my_strnxfrmlen_utf8mb4(const CHARSET_INFO *cs __attribute__((unused)), size_t len)
+my_strnxfrmlen_utf8mb4(const CHARSET_INFO * const cs __attribute__((unused)), size_t len)
 {
   /* TODO: fix when working on WL "Unicode new version" */
   return (len * 2 + 2) / 4;
@@ -2588,7 +2588,7 @@
 
 
 static size_t
-my_strnxfrm_utf8mb4(const CHARSET_INFO *cs,
+my_strnxfrm_utf8mb4(const CHARSET_INFO * const cs,
                     uchar *dst, size_t dstlen, uint nweights,
                     const uchar *src, size_t srclen, uint flags)
 {
@@ -2633,7 +2633,7 @@
 
 
 static uint
-my_ismbchar_utf8mb4(const CHARSET_INFO *cs, const char *b, const char *e)
+my_ismbchar_utf8mb4(const CHARSET_INFO * const cs, const char *b, const char *e)
 {
   my_wc_t wc;
   int res= my_mb_wc_utf8mb4(cs,&wc, (const uchar*)b, (const uchar*)e);
@@ -2642,7 +2642,7 @@
 
 
 static uint
-my_mbcharlen_utf8mb4(const CHARSET_INFO *cs  __attribute__((unused)), uint c)
+my_mbcharlen_utf8mb4(const CHARSET_INFO * const cs  __attribute__((unused)), uint c)
 {
   if (c < 0x80)
     return 1;
@@ -2874,7 +2874,7 @@
 
 
 static int
-my_mb_wc_utf8mb3(const CHARSET_INFO *cs __attribute__((unused)),
+my_mb_wc_utf8mb3(const CHARSET_INFO * const cs __attribute__((unused)),
                  my_wc_t * pwc, const uchar *s, const uchar *e)
 {
   uchar c;
@@ -2985,7 +2985,7 @@
   for example, for a null-terminated string
 */
 static int
-my_mb_wc_utf8mb3_no_range(const CHARSET_INFO *cs __attribute__((unused)),
+my_mb_wc_utf8mb3_no_range(const CHARSET_INFO * const cs __attribute__((unused)),
                           my_wc_t * pwc, const uchar *s)
 {
   uchar c;
@@ -3027,7 +3027,7 @@
 
 
 static int
-my_wc_mb_utf8mb3(const CHARSET_INFO *cs __attribute__((unused)),
+my_wc_mb_utf8mb3(const CHARSET_INFO * const cs __attribute__((unused)),
                  my_wc_t wc, uchar *r, uchar *e)
 {
   int count;
@@ -3077,7 +3077,7 @@
   The same as above, but without range check.
 */
 static int
-my_wc_mb_utf8mb3_no_range(const CHARSET_INFO *cs __attribute__((unused)),
+my_wc_mb_utf8mb3_no_range(const CHARSET_INFO * const cs __attribute__((unused)),
                           my_wc_t wc, uchar *r)
 {
   int count;
@@ -3103,7 +3103,7 @@
 
 
 static size_t
-my_caseup_utf8mb3(const CHARSET_INFO *cs, char *src, size_t srclen,
+my_caseup_utf8mb3(const CHARSET_INFO * const cs, char *src, size_t srclen,
                   char *dst, size_t dstlen)
 {
   my_wc_t wc;
@@ -3128,7 +3128,7 @@
 
 
 static void
-my_hash_sort_utf8mb3(const CHARSET_INFO *cs, const uchar *s, size_t slen,
+my_hash_sort_utf8mb3(const CHARSET_INFO * const cs, const uchar *s, size_t slen,
                      ulong *n1, ulong *n2)
 {
   my_wc_t wc;
@@ -3158,7 +3158,7 @@
 
 
 static size_t
-my_caseup_str_utf8mb3(const CHARSET_INFO *cs, char *src)
+my_caseup_str_utf8mb3(const CHARSET_INFO * const cs, char *src)
 {
   my_wc_t wc;
   int srcres, dstres;
@@ -3182,7 +3182,7 @@
 
 
 static size_t
-my_casedn_utf8mb3(const CHARSET_INFO *cs, char *src, size_t srclen,
+my_casedn_utf8mb3(const CHARSET_INFO * const cs, char *src, size_t srclen,
                   char *dst, size_t dstlen)
 {
   my_wc_t wc;
@@ -3207,7 +3207,7 @@
 
 
 static size_t
-my_casedn_str_utf8mb3(const CHARSET_INFO *cs, char *src)
+my_casedn_str_utf8mb3(const CHARSET_INFO * const cs, char *src)
 {
   my_wc_t wc;
   int srcres, dstres;
@@ -3247,7 +3247,7 @@
 
 
 static int
-my_strnncoll_utf8mb3(const CHARSET_INFO *cs,
+my_strnncoll_utf8mb3(const CHARSET_INFO * const cs,
                      const uchar *s, size_t slen,
                      const uchar *t, size_t tlen,
                      my_bool t_is_prefix)
@@ -3314,7 +3314,7 @@
 */
 
 static int
-my_strnncollsp_utf8mb3(const CHARSET_INFO *cs,
+my_strnncollsp_utf8mb3(const CHARSET_INFO * const cs,
                        const uchar *s, size_t slen,
                        const uchar *t, size_t tlen,
                        my_bool diff_if_only_endspace_difference)
@@ -3408,7 +3408,7 @@
 */
 
 static int
-my_strcasecmp_utf8mb3(const CHARSET_INFO *cs, const char *s, const char *t)
+my_strcasecmp_utf8mb3(const CHARSET_INFO * const cs, const char *s, const char *t)
 {
   MY_UNICASE_INFO **uni_plane= cs->caseinfo;
   while (s[0] && t[0])
@@ -3491,7 +3491,7 @@
 
 
 static int
-my_wildcmp_utf8mb3(const CHARSET_INFO *cs,
+my_wildcmp_utf8mb3(const CHARSET_INFO * const cs,
 		   const char *str,const char *str_end,
 		   const char *wildstr,const char *wildend,
 		   int escape, int w_one, int w_many)
@@ -3503,14 +3503,14 @@
 
 
 static size_t
-my_strnxfrmlen_utf8mb3(const CHARSET_INFO *cs __attribute__((unused)), size_t len)
+my_strnxfrmlen_utf8mb3(const CHARSET_INFO * const cs __attribute__((unused)), size_t len)
 {
   return (len * 2 + 2) / 3;
 }
 
 
 static size_t
-my_strnxfrm_utf8mb3(const CHARSET_INFO *cs,
+my_strnxfrm_utf8mb3(const CHARSET_INFO * const cs,
                     uchar *dst, size_t dstlen, uint nweights,
                     const uchar *src, size_t srclen, uint flags)
 {
@@ -3555,7 +3555,7 @@
 
 
 static size_t
-my_strnxfrm_utf8mb3_bin(const CHARSET_INFO *cs,
+my_strnxfrm_utf8mb3_bin(const CHARSET_INFO * const cs,
                         uchar *dst, size_t dstlen, uint nweights,
                         const uchar *src, size_t srclen, uint flags)
 {
@@ -3594,7 +3594,7 @@
 
 
 static uint
-my_ismbchar_utf8mb3(const CHARSET_INFO *cs, const char *b, const char *e)
+my_ismbchar_utf8mb3(const CHARSET_INFO * const cs, const char *b, const char *e)
 {
   my_wc_t wc;
   int  res= my_mb_wc_utf8mb3(cs, &wc, (const uchar*) b, (const uchar*) e);
@@ -3603,7 +3603,7 @@
 
 
 static uint
-my_mbcharlen_utf8mb3(const CHARSET_INFO *cs  __attribute__((unused)), uint c)
+my_mbcharlen_utf8mb3(const CHARSET_INFO * const cs  __attribute__((unused)), uint c)
 {
   if (c < 0x80)
     return 1;
@@ -5068,7 +5068,7 @@
 #define MY_FILENAME_ESCAPE '@'
 
 static int
-my_mb_wc_filename(const CHARSET_INFO *cs __attribute__((unused)),
+my_mb_wc_filename(const CHARSET_INFO * const cs __attribute__((unused)),
                   my_wc_t *pwc, const uchar *s, const uchar *e)
 {
   int byte1, byte2;
@@ -5126,7 +5126,7 @@
 
 
 static int
-my_wc_mb_filename(const CHARSET_INFO *cs __attribute__((unused)),
+my_wc_mb_filename(const CHARSET_INFO * const cs __attribute__((unused)),
                   my_wc_t wc, uchar *s, uchar *e)
 {
   int code;

=== modified file 'mystrings/ctype-win1250ch.c'
--- mystrings/ctype-win1250ch.c	2008-07-31 19:53:42 +0000
+++ mystrings/ctype-win1250ch.c	2008-08-06 00:04:45 +0000
@@ -459,7 +459,7 @@
 
 #define IS_END(p, src, len)	(((char *)p - (char *)src) >= (len))
 
-static int my_strnncoll_win1250ch(const CHARSET_INFO *cs __attribute__((unused)), 
+static int my_strnncoll_win1250ch(const CHARSET_INFO * const cs __attribute__((unused)), 
 				  const uchar *s1, size_t len1,
                                   const uchar *s2, size_t len2,
                                   my_bool s2_is_prefix)
@@ -490,7 +490,7 @@
 */
 
 static int
-my_strnncollsp_win1250ch(const CHARSET_INFO * cs __attribute__((unused)),
+my_strnncollsp_win1250ch(const CHARSET_INFO * const  cs __attribute__((unused)),
                          const uchar *s, size_t slen,
                          const uchar *t, size_t tlen,
                          my_bool diff_if_only_endspace_difference
@@ -540,7 +540,7 @@
 
 
 static size_t
-my_strnxfrm_win1250ch(const CHARSET_INFO * cs  __attribute__((unused)),
+my_strnxfrm_win1250ch(const CHARSET_INFO * const  cs  __attribute__((unused)),
                       uchar *dst, size_t dstlen, uint nweights_arg,
                       const uchar *src, size_t srclen, uint flags)
 {
@@ -686,7 +686,7 @@
 */
 
 static my_bool
-my_like_range_win1250ch(const CHARSET_INFO *cs __attribute__((unused)),
+my_like_range_win1250ch(const CHARSET_INFO * const cs __attribute__((unused)),
 			const char *ptr, size_t ptr_length,
 			char escape, char w_one, char w_many,
 			size_t res_length,

=== modified file 'mystrings/ctype.c'
--- mystrings/ctype.c	2008-07-30 05:33:20 +0000
+++ mystrings/ctype.c	2008-08-06 00:04:45 +0000
@@ -310,7 +310,7 @@
   Check repertoire: detect pure ascii strings
 */
 uint
-my_string_repertoire(CHARSET_INFO *cs, const char *str, ulong length)
+my_string_repertoire(const CHARSET_INFO * const cs, const char *str, ulong length)
 {
   const char *strend= str + length;
   if (cs->mbminlen == 1)
@@ -362,7 +362,7 @@
   to introduce new tricky character sets between 5.0 and 5.2.
 */
 my_bool
-my_charset_is_ascii_based(CHARSET_INFO *cs)
+my_charset_is_ascii_based(const CHARSET_INFO * const cs)
 {
   return 
     (cs->mbmaxlen == 1 && cs->tab_to_uni && cs->tab_to_uni['{'] == '{') ||
@@ -378,7 +378,7 @@
   and dynamic charsets loader in "mysqld".
 */
 my_bool
-my_charset_is_8bit_pure_ascii(CHARSET_INFO *cs)
+my_charset_is_8bit_pure_ascii(const CHARSET_INFO * const cs)
 {
   size_t code;
   if (!cs->tab_to_uni)
@@ -398,7 +398,7 @@
   ascii on the range 0x00..0x7F.
 */
 my_bool
-my_charset_is_ascii_compatible(CHARSET_INFO *cs)
+my_charset_is_ascii_compatible(const CHARSET_INFO * const cs)
 {
   uint i;
   if (!cs->tab_to_uni)

=== modified file 'mystrings/m_ctype.h'
--- mystrings/m_ctype.h	2008-07-31 19:53:42 +0000
+++ mystrings/m_ctype.h	2008-08-06 00:04:45 +0000
@@ -164,29 +164,29 @@
 {
   my_bool (*init)(struct charset_info_st *, void *(*alloc)(size_t));
   /* Collation routines */
-  int     (*strnncoll)(const struct charset_info_st *,
+  int     (*strnncoll)(const struct charset_info_st * const,
 		       const uchar *, size_t, const uchar *, size_t, my_bool);
-  int     (*strnncollsp)(const struct charset_info_st *,
+  int     (*strnncollsp)(const struct charset_info_st * const,
                          const uchar *, size_t, const uchar *, size_t,
                          my_bool diff_if_only_endspace_difference);
-  size_t  (*strnxfrm)(const struct charset_info_st *,
+  size_t  (*strnxfrm)(const struct charset_info_st * const,
                       uchar *dst, size_t dstlen, uint nweights,
                       const uchar *src, size_t srclen, uint flags);
-  size_t    (*strnxfrmlen)(const struct charset_info_st *, size_t);
-  my_bool (*like_range)(const struct charset_info_st *,
+  size_t    (*strnxfrmlen)(const struct charset_info_st * const, size_t);
+  my_bool (*like_range)(const struct charset_info_st * const,
                         const char *s, size_t s_length,
                         char escape, char w_one, char w_many,
                         size_t res_length,
                         char *min_str, char *max_str,
                         size_t *min_len, size_t *max_len);
-  int     (*wildcmp)(const struct charset_info_st *,
+  int     (*wildcmp)(const struct charset_info_st * const,
   		     const char *str,const char *str_end,
                      const char *wildstr,const char *wildend,
                      int escape,int w_one, int w_many);
 
-  int  (*strcasecmp)(const struct charset_info_st *, const char *, const char *);
+  int  (*strcasecmp)(const struct charset_info_st * const, const char *, const char *);
   
-  uint (*instr)(const struct charset_info_st *,
+  uint (*instr)(const struct charset_info_st * const,
                 const char *b, size_t b_length,
                 const char *s, size_t s_length,
                 my_match_t *match, uint nmatch);
@@ -203,11 +203,11 @@
 extern MY_COLLATION_HANDLER my_collation_ucs2_uca_handler;
 
 /* Some typedef to make it easy for C++ to make function pointers */
-typedef int (*my_charset_conv_mb_wc)(const struct charset_info_st *, my_wc_t *,
+typedef int (*my_charset_conv_mb_wc)(const struct charset_info_st * const, my_wc_t *,
                                      const uchar *, const uchar *);
-typedef int (*my_charset_conv_wc_mb)(const struct charset_info_st *, my_wc_t,
+typedef int (*my_charset_conv_wc_mb)(const struct charset_info_st * const, my_wc_t,
                                      uchar *, uchar *);
-typedef size_t (*my_charset_conv_case)(const struct charset_info_st *,
+typedef size_t (*my_charset_conv_case)(const struct charset_info_st * const,
                                        char *, size_t, char *, size_t);
 
 
@@ -216,16 +216,16 @@
 {
   my_bool (*init)(struct charset_info_st *, void *(*alloc)(size_t));
   /* Multibyte routines */
-  uint    (*ismbchar)(const struct charset_info_st *, const char *, const char *);
-  uint    (*mbcharlen)(const struct charset_info_st *, uint c);
-  size_t  (*numchars)(const struct charset_info_st *, const char *b, const char *e);
-  size_t  (*charpos)(const struct charset_info_st *, const char *b, const char *e,
+  uint    (*ismbchar)(const struct charset_info_st * const, const char *, const char *);
+  uint    (*mbcharlen)(const struct charset_info_st * const, uint c);
+  size_t  (*numchars)(const struct charset_info_st * const, const char *b, const char *e);
+  size_t  (*charpos)(const struct charset_info_st * const, const char *b, const char *e,
                      size_t pos);
-  size_t  (*well_formed_len)(const struct charset_info_st *,
+  size_t  (*well_formed_len)(const struct charset_info_st * const,
                              const char *b,const char *e,
                              size_t nchars, int *error);
-  size_t  (*lengthsp)(const struct charset_info_st *, const char *ptr, size_t length);
-  size_t  (*numcells)(const struct charset_info_st *, const char *b, const char *e);
+  size_t  (*lengthsp)(const struct charset_info_st * const, const char *ptr, size_t length);
+  size_t  (*numcells)(const struct charset_info_st * const, const char *b, const char *e);
   
   /* Unicode conversion */
   my_charset_conv_mb_wc mb_wc;
@@ -236,33 +236,33 @@
                const uchar *s, const uchar *e);
   
   /* Functions for case and sort conversion */
-  size_t  (*caseup_str)(const struct charset_info_st *, char *);
-  size_t  (*casedn_str)(const struct charset_info_st *, char *);
+  size_t  (*caseup_str)(const struct charset_info_st * const, char *);
+  size_t  (*casedn_str)(const struct charset_info_st * const, char *);
 
   my_charset_conv_case caseup;
   my_charset_conv_case casedn;
 
   /* Charset dependant snprintf() */
-  size_t (*snprintf)(const struct charset_info_st *, char *to, size_t n,
+  size_t (*snprintf)(const struct charset_info_st * const, char *to, size_t n,
                      const char *fmt,
                      ...) __attribute__((format(printf, 4, 5)));
-  size_t (*long10_to_str)(const struct charset_info_st *, char *to, size_t n,
+  size_t (*long10_to_str)(const struct charset_info_st * const, char *to, size_t n,
                           int radix, long int val);
-  size_t (*int64_t10_to_str)(const struct charset_info_st *, char *to, size_t n,
+  size_t (*int64_t10_to_str)(const struct charset_info_st * const, char *to, size_t n,
                               int radix, int64_t val);
   
-  void (*fill)(const struct charset_info_st *, char *to, size_t len, int fill);
+  void (*fill)(const struct charset_info_st * const, char *to, size_t len, int fill);
   
   /* String-to-number conversion routines */
-  long        (*strntol)(const struct charset_info_st *, const char *s, size_t l,
-			 int base, char **e, int *err);
-  ulong      (*strntoul)(const struct charset_info_st *, const char *s, size_t l,
-			 int base, char **e, int *err);
-  int64_t   (*strntoll)(const struct charset_info_st *, const char *s, size_t l,
-			 int base, char **e, int *err);
-  uint64_t (*strntoull)(const struct charset_info_st *, const char *s, size_t l,
-			 int base, char **e, int *err);
-  double      (*strntod)(const struct charset_info_st *, char *s, size_t l, char **e,
+  long        (*strntol)(const struct charset_info_st * const, const char *s, size_t l,
+			 int base, char **e, int *err);
+  ulong      (*strntoul)(const struct charset_info_st * const, const char *s, size_t l,
+			 int base, char **e, int *err);
+  int64_t   (*strntoll)(const struct charset_info_st * const, const char *s, size_t l,
+			 int base, char **e, int *err);
+  uint64_t (*strntoull)(const struct charset_info_st * const, const char *s, size_t l,
+			 int base, char **e, int *err);
+  double      (*strntod)(const struct charset_info_st * const, char *s, size_t l, char **e,
 			 int *err);
   int64_t    (*strtoll10)(const struct charset_info_st *cs,
                            const char *nptr, char **endptr, int *error);
@@ -270,7 +270,7 @@
                                 const char *str, size_t length,
                                 int unsigned_fl,
                                 char **endptr, int *error);
-  size_t        (*scan)(const struct charset_info_st *, const char *b, const char *e,
+  size_t        (*scan)(const struct charset_info_st * const, const char *b, const char *e,
                         int sq);
 } MY_CHARSET_HANDLER;
 
@@ -367,183 +367,183 @@
 
 
 /* declarations for simple charsets */
-extern size_t my_strnxfrm_simple(const CHARSET_INFO *,
+extern size_t my_strnxfrm_simple(const CHARSET_INFO * const,
                                  uchar *dst, size_t dstlen, uint nweights,
                                  const uchar *src, size_t srclen, uint flags);
-size_t my_strnxfrmlen_simple(const CHARSET_INFO *, size_t);
-extern int  my_strnncoll_simple(const CHARSET_INFO *, const uchar *, size_t,
+size_t my_strnxfrmlen_simple(const CHARSET_INFO * const, size_t);
+extern int  my_strnncoll_simple(const CHARSET_INFO * const, const uchar *, size_t,
 				const uchar *, size_t, my_bool);
 
-extern int  my_strnncollsp_simple(const CHARSET_INFO *, const uchar *, size_t,
+extern int  my_strnncollsp_simple(const CHARSET_INFO * const, const uchar *, size_t,
                                   const uchar *, size_t,
                                   my_bool diff_if_only_endspace_difference);
 
-extern void my_hash_sort_simple(const CHARSET_INFO *cs,
+extern void my_hash_sort_simple(const CHARSET_INFO * const cs,
 				const uchar *key, size_t len,
 				ulong *nr1, ulong *nr2); 
 
-extern size_t my_lengthsp_8bit(const CHARSET_INFO *cs, const char *ptr, size_t length);
+extern size_t my_lengthsp_8bit(const CHARSET_INFO * const cs, const char *ptr, size_t length);
 
-extern uint my_instr_simple(const CHARSET_INFO *,
+extern uint my_instr_simple(const CHARSET_INFO * const,
                             const char *b, size_t b_length,
                             const char *s, size_t s_length,
                             my_match_t *match, uint nmatch);
 
 
 /* Functions for 8bit */
-extern size_t my_caseup_str_8bit(const CHARSET_INFO *, char *);
-extern size_t my_casedn_str_8bit(const CHARSET_INFO *, char *);
-extern size_t my_caseup_8bit(const CHARSET_INFO *, char *src, size_t srclen,
-                             char *dst, size_t dstlen);
-extern size_t my_casedn_8bit(const CHARSET_INFO *, char *src, size_t srclen,
-                             char *dst, size_t dstlen);
-
-extern int my_strcasecmp_8bit(const CHARSET_INFO * cs, const char *, const char *);
-
-int my_mb_wc_8bit(const CHARSET_INFO *cs,my_wc_t *wc, const uchar *s,const uchar *e);
-int my_wc_mb_8bit(const CHARSET_INFO *cs,my_wc_t wc, uchar *s, uchar *e);
-
-int my_mb_ctype_8bit(const CHARSET_INFO *,int *, const uchar *,const uchar *);
-int my_mb_ctype_mb(const CHARSET_INFO *,int *, const uchar *,const uchar *);
-
-size_t my_scan_8bit(const CHARSET_INFO *cs, const char *b, const char *e, int sq);
-
-size_t my_snprintf_8bit(const struct charset_info_st *, char *to, size_t n,
+extern size_t my_caseup_str_8bit(const CHARSET_INFO * const, char *);
+extern size_t my_casedn_str_8bit(const CHARSET_INFO * const, char *);
+extern size_t my_caseup_8bit(const CHARSET_INFO * const, char *src, size_t srclen,
+                             char *dst, size_t dstlen);
+extern size_t my_casedn_8bit(const CHARSET_INFO * const, char *src, size_t srclen,
+                             char *dst, size_t dstlen);
+
+extern int my_strcasecmp_8bit(const CHARSET_INFO * const  cs, const char *, const char *);
+
+int my_mb_wc_8bit(const CHARSET_INFO * const cs,my_wc_t *wc, const uchar *s,const uchar *e);
+int my_wc_mb_8bit(const CHARSET_INFO * const cs,my_wc_t wc, uchar *s, uchar *e);
+
+int my_mb_ctype_8bit(const CHARSET_INFO * const,int *, const uchar *,const uchar *);
+int my_mb_ctype_mb(const CHARSET_INFO * const,int *, const uchar *,const uchar *);
+
+size_t my_scan_8bit(const CHARSET_INFO * const cs, const char *b, const char *e, int sq);
+
+size_t my_snprintf_8bit(const CHARSET_INFO * const, char *to, size_t n,
                         const char *fmt, ...)
   __attribute__((format(printf, 4, 5)));
 
-long       my_strntol_8bit(const CHARSET_INFO *, const char *s, size_t l, int base,
+long       my_strntol_8bit(const CHARSET_INFO * const, const char *s, size_t l, int base,
                            char **e, int *err);
-ulong      my_strntoul_8bit(const CHARSET_INFO *, const char *s, size_t l, int base,
-			    char **e, int *err);
-int64_t   my_strntoll_8bit(const CHARSET_INFO *, const char *s, size_t l, int base,
-			    char **e, int *err);
-uint64_t my_strntoull_8bit(const CHARSET_INFO *, const char *s, size_t l, int base,
-			    char **e, int *err);
-double      my_strntod_8bit(const CHARSET_INFO *, char *s, size_t l,char **e,
+ulong      my_strntoul_8bit(const CHARSET_INFO * const, const char *s, size_t l, int base,
+			    char **e, int *err);
+int64_t   my_strntoll_8bit(const CHARSET_INFO * const, const char *s, size_t l, int base,
+			    char **e, int *err);
+uint64_t my_strntoull_8bit(const CHARSET_INFO * const, const char *s, size_t l, int base,
+			    char **e, int *err);
+double      my_strntod_8bit(const CHARSET_INFO * const, char *s, size_t l,char **e,
 			    int *err);
-size_t my_long10_to_str_8bit(const CHARSET_INFO *, char *to, size_t l, int radix,
+size_t my_long10_to_str_8bit(const CHARSET_INFO * const, char *to, size_t l, int radix,
                              long int val);
-size_t my_int64_t10_to_str_8bit(const CHARSET_INFO *, char *to, size_t l, int radix,
+size_t my_int64_t10_to_str_8bit(const CHARSET_INFO * const, char *to, size_t l, int radix,
                                  int64_t val);
 
-int64_t my_strtoll10_8bit(const CHARSET_INFO *cs,
+int64_t my_strtoll10_8bit(const CHARSET_INFO * const cs,
                            const char *nptr, char **endptr, int *error);
 int64_t my_strtoll10_ucs2(CHARSET_INFO *cs, 
                            const char *nptr, char **endptr, int *error);
 
-uint64_t my_strntoull10rnd_8bit(const CHARSET_INFO *cs,
+uint64_t my_strntoull10rnd_8bit(const CHARSET_INFO * const cs,
                                  const char *str, size_t length, int
                                  unsigned_fl, char **endptr, int *error);
 uint64_t my_strntoull10rnd_ucs2(CHARSET_INFO *cs, 
                                  const char *str, size_t length,
                                  int unsigned_fl, char **endptr, int *error);
 
-void my_fill_8bit(const CHARSET_INFO *cs, char* to, size_t l, int fill);
+void my_fill_8bit(const CHARSET_INFO * const cs, char* to, size_t l, int fill);
 
-my_bool  my_like_range_simple(const CHARSET_INFO *cs,
+my_bool  my_like_range_simple(const CHARSET_INFO * const cs,
 			      const char *ptr, size_t ptr_length,
 			      char escape, char w_one, char w_many,
 			      size_t res_length,
 			      char *min_str, char *max_str,
 			      size_t *min_length, size_t *max_length);
 
-my_bool  my_like_range_mb(const CHARSET_INFO *cs,
+my_bool  my_like_range_mb(const CHARSET_INFO * const cs,
 			  const char *ptr, size_t ptr_length,
 			  char escape, char w_one, char w_many,
 			  size_t res_length,
 			  char *min_str, char *max_str,
 			  size_t *min_length, size_t *max_length);
 
-my_bool  my_like_range_ucs2(const CHARSET_INFO *cs,
+my_bool  my_like_range_ucs2(const CHARSET_INFO * const cs,
 			    const char *ptr, size_t ptr_length,
 			    char escape, char w_one, char w_many,
 			    size_t res_length,
 			    char *min_str, char *max_str,
 			    size_t *min_length, size_t *max_length);
 
-my_bool  my_like_range_utf16(const CHARSET_INFO *cs,
-			     const char *ptr, size_t ptr_length,
-			     char escape, char w_one, char w_many,
-			     size_t res_length,
-			     char *min_str, char *max_str,
-			     size_t *min_length, size_t *max_length);
-
-my_bool  my_like_range_utf32(const CHARSET_INFO *cs,
-			     const char *ptr, size_t ptr_length,
-			     char escape, char w_one, char w_many,
-			     size_t res_length,
-			     char *min_str, char *max_str,
-			     size_t *min_length, size_t *max_length);
-
-
-int my_wildcmp_8bit(const CHARSET_INFO *,
+my_bool  my_like_range_utf16(const CHARSET_INFO * const cs,
+			     const char *ptr, size_t ptr_length,
+			     char escape, char w_one, char w_many,
+			     size_t res_length,
+			     char *min_str, char *max_str,
+			     size_t *min_length, size_t *max_length);
+
+my_bool  my_like_range_utf32(const CHARSET_INFO * const cs,
+			     const char *ptr, size_t ptr_length,
+			     char escape, char w_one, char w_many,
+			     size_t res_length,
+			     char *min_str, char *max_str,
+			     size_t *min_length, size_t *max_length);
+
+
+int my_wildcmp_8bit(const CHARSET_INFO * const,
 		    const char *str,const char *str_end,
 		    const char *wildstr,const char *wildend,
 		    int escape, int w_one, int w_many);
 
-int my_wildcmp_bin(const CHARSET_INFO *,
+int my_wildcmp_bin(const CHARSET_INFO * const,
 		   const char *str,const char *str_end,
 		   const char *wildstr,const char *wildend,
 		   int escape, int w_one, int w_many);
 
-size_t my_numchars_8bit(const CHARSET_INFO *, const char *b, const char *e);
-size_t my_numcells_8bit(const CHARSET_INFO *, const char *b, const char *e);
-size_t my_charpos_8bit(const CHARSET_INFO *, const char *b, const char *e, size_t pos);
-size_t my_well_formed_len_8bit(const CHARSET_INFO *, const char *b, const char *e,
+size_t my_numchars_8bit(const CHARSET_INFO * const, const char *b, const char *e);
+size_t my_numcells_8bit(const CHARSET_INFO * const, const char *b, const char *e);
+size_t my_charpos_8bit(const CHARSET_INFO * const, const char *b, const char *e, size_t pos);
+size_t my_well_formed_len_8bit(const CHARSET_INFO * const, const char *b, const char *e,
                              size_t pos, int *error);
-uint my_mbcharlen_8bit(const CHARSET_INFO *, uint c);
+uint my_mbcharlen_8bit(const CHARSET_INFO * const, uint c);
 
 
 /* Functions for multibyte charsets */
-extern size_t my_caseup_str_mb(const CHARSET_INFO *, char *);
-extern size_t my_casedn_str_mb(const CHARSET_INFO *, char *);
-extern size_t my_caseup_mb(const CHARSET_INFO *, char *src, size_t srclen,
-                                         char *dst, size_t dstlen);
-extern size_t my_casedn_mb(const CHARSET_INFO *, char *src, size_t srclen,
-                                         char *dst, size_t dstlen);
-extern int my_strcasecmp_mb(const CHARSET_INFO * cs, const char *s, const char *t);
+extern size_t my_caseup_str_mb(const CHARSET_INFO * const, char *);
+extern size_t my_casedn_str_mb(const CHARSET_INFO * const, char *);
+extern size_t my_caseup_mb(const CHARSET_INFO * const, char *src, size_t srclen,
+                                         char *dst, size_t dstlen);
+extern size_t my_casedn_mb(const CHARSET_INFO * const, char *src, size_t srclen,
+                                         char *dst, size_t dstlen);
+extern int my_strcasecmp_mb(const CHARSET_INFO * const  cs, const char *s, const char *t);
 
-int my_wildcmp_mb(const CHARSET_INFO *,
+int my_wildcmp_mb(const CHARSET_INFO * const,
 		  const char *str,const char *str_end,
 		  const char *wildstr,const char *wildend,
 		  int escape, int w_one, int w_many);
-size_t my_numchars_mb(const CHARSET_INFO *, const char *b, const char *e);
-size_t my_numcells_mb(const CHARSET_INFO *, const char *b, const char *e);
-size_t my_charpos_mb(const CHARSET_INFO *, const char *b, const char *e, size_t pos);
-size_t my_well_formed_len_mb(const CHARSET_INFO *, const char *b, const char *e,
+size_t my_numchars_mb(const CHARSET_INFO * const, const char *b, const char *e);
+size_t my_numcells_mb(const CHARSET_INFO * const, const char *b, const char *e);
+size_t my_charpos_mb(const CHARSET_INFO * const, const char *b, const char *e, size_t pos);
+size_t my_well_formed_len_mb(const CHARSET_INFO * const, const char *b, const char *e,
                              size_t pos, int *error);
-uint my_instr_mb(const CHARSET_INFO *,
+uint my_instr_mb(const CHARSET_INFO * const,
                  const char *b, size_t b_length,
                  const char *s, size_t s_length,
                  my_match_t *match, uint nmatch);
 
-int my_strnncoll_mb_bin(const CHARSET_INFO * cs,
+int my_strnncoll_mb_bin(const CHARSET_INFO * const  cs,
                         const uchar *s, size_t slen,
                         const uchar *t, size_t tlen,
                         my_bool t_is_prefix);
 
-int my_strnncollsp_mb_bin(const CHARSET_INFO *cs,
+int my_strnncollsp_mb_bin(const CHARSET_INFO * const cs,
                           const uchar *a, size_t a_length,
                           const uchar *b, size_t b_length,
                           my_bool diff_if_only_endspace_difference);
 
-int my_wildcmp_mb_bin(const CHARSET_INFO *cs,
+int my_wildcmp_mb_bin(const CHARSET_INFO * const cs,
                       const char *str,const char *str_end,
                       const char *wildstr,const char *wildend,
                       int escape, int w_one, int w_many);
 
-int my_strcasecmp_mb_bin(const CHARSET_INFO * cs __attribute__((unused)),
+int my_strcasecmp_mb_bin(const CHARSET_INFO * const  cs __attribute__((unused)),
                          const char *s, const char *t);
 
-void my_hash_sort_mb_bin(const CHARSET_INFO *cs __attribute__((unused)),
+void my_hash_sort_mb_bin(const CHARSET_INFO * const cs __attribute__((unused)),
                          const uchar *key, size_t len,ulong *nr1, ulong *nr2);
 
-size_t my_strnxfrm_mb(const CHARSET_INFO *,
+size_t my_strnxfrm_mb(const CHARSET_INFO * const,
                       uchar *dst, size_t dstlen, uint nweights,
                       const uchar *src, size_t srclen, uint flags);
 
-int my_wildcmp_unicode(const CHARSET_INFO *cs,
+int my_wildcmp_unicode(const CHARSET_INFO * const cs,
                        const char *str, const char *str_end,
                        const char *wildstr, const char *wildend,
                        int escape, int w_one, int w_many,
@@ -551,26 +551,26 @@
 
 extern my_bool my_parse_charset_xml(const char *bug, size_t len,
 				    int (*add)(CHARSET_INFO *cs));
-extern char *my_strchr(CHARSET_INFO *cs, const char *str, const char *end,
+extern char *my_strchr(const CHARSET_INFO * const cs, const char *str, const char *end,
                        char c);
 
-my_bool my_propagate_simple(const CHARSET_INFO *cs, const uchar *str, size_t len);
-my_bool my_propagate_complex(const CHARSET_INFO *cs, const uchar *str, size_t len);
-
-
-uint my_string_repertoire(CHARSET_INFO *cs, const char *str, ulong len);
-my_bool my_charset_is_ascii_based(CHARSET_INFO *cs);
-my_bool my_charset_is_8bit_pure_ascii(CHARSET_INFO *cs);
+my_bool my_propagate_simple(const CHARSET_INFO * const cs, const uchar *str, size_t len);
+my_bool my_propagate_complex(const CHARSET_INFO * const cs, const uchar *str, size_t len);
+
+
+uint my_string_repertoire(const CHARSET_INFO * const cs, const char *str, ulong len);
+my_bool my_charset_is_ascii_based(const CHARSET_INFO * const cs);
+my_bool my_charset_is_8bit_pure_ascii(const CHARSET_INFO * const cs);
 
 
 uint my_strxfrm_flag_normalize(uint flags, uint nlevels);
 void my_strxfrm_desc_and_reverse(uchar *str, uchar *strend,
                                  uint flags, uint level);
-size_t my_strxfrm_pad_desc_and_reverse(const CHARSET_INFO *cs,
+size_t my_strxfrm_pad_desc_and_reverse(const CHARSET_INFO * const cs,
                                        uchar *str, uchar *frmend, uchar *strend,
                                        uint nweights, uint flags, uint level);
 
-my_bool my_charset_is_ascii_compatible(CHARSET_INFO *cs);
+my_bool my_charset_is_ascii_compatible(const CHARSET_INFO * const cs);
 
 #define	_MY_U	01	/* Upper case */
 #define	_MY_L	02	/* Lower case */

=== modified file 'mystrings/my_strchr.c'
--- mystrings/my_strchr.c	2008-07-30 05:33:20 +0000
+++ mystrings/my_strchr.c	2008-08-06 00:04:45 +0000
@@ -25,7 +25,7 @@
 #include "m_ctype.h"
 
 
-char *my_strchr(CHARSET_INFO *cs, const char *str, const char *end,
+char *my_strchr(const CHARSET_INFO * const cs, const char *str, const char *end,
                 char c)
 {
   uint mbl;

=== modified file 'mysys/charset.c'
--- mysys/charset.c	2008-07-31 19:53:42 +0000
+++ mysys/charset.c	2008-08-06 00:04:45 +0000
@@ -408,9 +408,9 @@
 }
 
 CHARSET_INFO *all_charsets[256];
-CHARSET_INFO *default_charset_info = &my_charset_latin1;
+const CHARSET_INFO *default_charset_info = &my_charset_latin1;
 
-void add_compiled_collation(CHARSET_INFO *cs)
+void add_compiled_collation(CHARSET_INFO * cs)
 {
   all_charsets[cs->number]= cs;
   cs->state|= MY_CS_AVAILABLE;
@@ -498,7 +498,7 @@
 
 const char *get_charset_name(uint charset_number)
 {
-  CHARSET_INFO *cs;
+  const CHARSET_INFO *cs;
   init_available_charsets(MYF(0));
 
   cs=all_charsets[charset_number];
@@ -509,7 +509,7 @@
 }
 
 
-static CHARSET_INFO *get_internal_charset(uint cs_number, myf flags)
+static const CHARSET_INFO *get_internal_charset(uint cs_number, myf flags)
 {
   char  buf[FN_REFLEN];
   CHARSET_INFO *cs;
@@ -540,9 +540,9 @@
 }
 
 
-CHARSET_INFO *get_charset(uint cs_number, myf flags)
+const const CHARSET_INFO *get_charset(uint cs_number, myf flags)
 {
-  CHARSET_INFO *cs;
+  const CHARSET_INFO *cs;
   if (cs_number == default_charset_info->number)
     return default_charset_info;
 
@@ -564,10 +564,10 @@
   return cs;
 }
 
-CHARSET_INFO *get_charset_by_name(const char *cs_name, myf flags)
+const CHARSET_INFO *get_charset_by_name(const char *cs_name, myf flags)
 {
   uint cs_number;
-  CHARSET_INFO *cs;
+  const CHARSET_INFO *cs;
   (void) init_available_charsets(MYF(0));	/* If it isn't initialized */
 
   cs_number=get_collation_number(cs_name);
@@ -584,12 +584,12 @@
 }
 
 
-CHARSET_INFO *get_charset_by_csname(const char *cs_name,
+const CHARSET_INFO *get_charset_by_csname(const char *cs_name,
 				    uint cs_flags,
 				    myf flags)
 {
   uint cs_number;
-  CHARSET_INFO *cs;
+  const CHARSET_INFO *cs;
 
   (void) init_available_charsets(MYF(0));	/* If it isn't initialized */
 
@@ -624,8 +624,8 @@
 */
 
 bool resolve_charset(const char *cs_name,
-                        CHARSET_INFO *default_cs,
-                        CHARSET_INFO **cs)
+                     const CHARSET_INFO *default_cs,
+                     const CHARSET_INFO **cs)
 {
   *cs= get_charset_by_csname(cs_name, MY_CS_PRIMARY, MYF(0));
 
@@ -656,8 +656,8 @@
 */
 
 bool resolve_collation(const char *cl_name,
-                          CHARSET_INFO *default_cl,
-                          CHARSET_INFO **cl)
+                       const CHARSET_INFO *default_cl,
+                       const CHARSET_INFO **cl)
 {
   *cl= get_charset_by_name(cl_name, MYF(0));
 

=== modified file 'mysys/hash.c'
--- mysys/hash.c	2008-08-01 23:59:59 +0000
+++ mysys/hash.c	2008-08-06 00:04:45 +0000
@@ -46,7 +46,7 @@
 }
 
 bool
-_hash_init(HASH *hash,uint growth_size, CHARSET_INFO *charset,
+_hash_init(HASH *hash,uint growth_size, const CHARSET_INFO * const charset,
 	   ulong size, size_t key_offset, size_t key_length,
 	   hash_get_key get_key,
 	   void (*free_element)(void*),uint flags CALLER_INFO_PROTO)

=== modified file 'mysys/hash.h'
--- mysys/hash.h	2008-07-29 07:47:38 +0000
+++ mysys/hash.h	2008-08-06 00:04:45 +0000
@@ -41,7 +41,7 @@
   DYNAMIC_ARRAY array;				/* Place for hash_keys */
   hash_get_key get_key;
   void (*free)(void *);
-  CHARSET_INFO *charset;
+  const CHARSET_INFO *charset;
 } HASH;
 
 /* A search iterator state */
@@ -49,7 +49,7 @@
 
 #define hash_init(A,B,C,D,E,F,G,H) _hash_init(A,0,B,C,D,E,F,G,H CALLER_INFO)
 #define hash_init2(A,B,C,D,E,F,G,H,I) _hash_init(A,B,C,D,E,F,G,H,I CALLER_INFO)
-bool _hash_init(HASH *hash, uint growth_size,CHARSET_INFO *charset,
+bool _hash_init(HASH *hash, uint growth_size, const CHARSET_INFO * const charset,
 		   ulong default_array_elements, size_t key_offset,
 		   size_t key_length, hash_get_key get_key,
 		   void (*free_element)(void*), uint flags CALLER_INFO_PROTO);

=== modified file 'mysys/my_handler.c'
--- mysys/my_handler.c	2008-07-30 05:33:20 +0000
+++ mysys/my_handler.c	2008-08-06 00:04:45 +0000
@@ -24,7 +24,7 @@
 
 #include "my_handler_errors.h"
 
-int ha_compare_text(CHARSET_INFO *charset_info, uchar *a, uint a_length,
+int ha_compare_text(const CHARSET_INFO * const charset_info, uchar *a, uint a_length,
 		    uchar *b, uint b_length, bool part_key,
 		    bool skip_end_space)
 {

=== modified file 'mysys/my_handler.h'
--- mysys/my_handler.h	2008-07-29 02:48:34 +0000
+++ mysys/my_handler.h	2008-08-06 00:04:45 +0000
@@ -47,7 +47,7 @@
 
 typedef struct st_HA_KEYSEG		/* Key-portion */
 {
-  CHARSET_INFO *charset;
+  const CHARSET_INFO *charset;
   uint32_t start;				/* Start of key in record */
   uint32_t null_pos;			/* position to NULL indicator */
   uint16_t bit_pos;                       /* Position to bit part */
@@ -106,7 +106,7 @@
 #define clr_rec_bits(bit_ptr, bit_ofs, bit_len) \
   set_rec_bits(0, bit_ptr, bit_ofs, bit_len)
 
-extern int ha_compare_text(CHARSET_INFO *, uchar *, uint, uchar *, uint, bool, bool);
+extern int ha_compare_text(const CHARSET_INFO * const, uchar *, uint, uchar *, uint, bool, bool);
 
 extern HA_KEYSEG *ha_find_null(HA_KEYSEG *keyseg, uchar *a);
 extern void my_handler_error_register(void);

=== modified file 'mysys/my_sys.h'
--- mysys/my_sys.h	2008-08-02 04:28:28 +0000
+++ mysys/my_sys.h	2008-08-06 00:04:45 +0000
@@ -178,7 +178,7 @@
 extern ulong my_thread_stack_size;
 
 /* charsets */
-extern CHARSET_INFO *default_charset_info;
+extern const CHARSET_INFO *default_charset_info;
 extern CHARSET_INFO *all_charsets[256];
 extern CHARSET_INFO compiled_charsets[];
 
@@ -814,17 +814,17 @@
 extern uint get_collation_number(const char *name);
 extern const char *get_charset_name(uint cs_number);
 
-extern CHARSET_INFO *get_charset(uint cs_number, myf flags);
-extern CHARSET_INFO *get_charset_by_name(const char *cs_name, myf flags);
-extern CHARSET_INFO *get_charset_by_csname(const char *cs_name,
-					   uint cs_flags, myf my_flags);
+extern const CHARSET_INFO *get_charset(uint cs_number, myf flags);
+extern const CHARSET_INFO *get_charset_by_name(const char *cs_name, myf flags);
+extern const CHARSET_INFO *get_charset_by_csname(const char *cs_name,
+					                             uint cs_flags, myf my_flags);
 
 extern bool resolve_charset(const char *cs_name,
-                               CHARSET_INFO *default_cs,
-                               CHARSET_INFO **cs);
+                            const CHARSET_INFO *default_cs,
+                            const CHARSET_INFO **cs);
 extern bool resolve_collation(const char *cl_name,
-                                 CHARSET_INFO *default_cl,
-                                 CHARSET_INFO **cl);
+                             const CHARSET_INFO *default_cl,
+                             const CHARSET_INFO **cl);
 
 extern void free_charsets(void);
 extern char *get_charsets_dir(char *buf);

=== modified file 'storage/heap/hp_hash.c'
--- storage/heap/hp_hash.c	2008-08-02 19:53:06 +0000
+++ storage/heap/hp_hash.c	2008-08-06 00:04:45 +0000
@@ -254,7 +254,7 @@
     }
     if (seg->type == HA_KEYTYPE_TEXT)
     {
-       CHARSET_INFO *cs= seg->charset;
+       const CHARSET_INFO * const cs= seg->charset;
        uint length= seg->length;
        if (cs->mbmaxlen > 1)
        {
@@ -266,7 +266,7 @@
     }
     else if (seg->type == HA_KEYTYPE_VARTEXT1)  /* Any VARCHAR segments */
     {
-       CHARSET_INFO *cs= seg->charset;
+       const CHARSET_INFO * const cs= seg->charset;
        uint pack_length= 2;                     /* Key packing is constant */
        uint length= uint2korr(pos);
        if (cs->mbmaxlen > 1)
@@ -312,7 +312,7 @@
     }
     if (seg->type == HA_KEYTYPE_TEXT)
     {
-      CHARSET_INFO *cs= seg->charset;
+      const CHARSET_INFO * const cs= seg->charset;
       uint char_length= seg->length;
       if (cs->mbmaxlen > 1)
       {
@@ -324,7 +324,7 @@
     }
     else if (seg->type == HA_KEYTYPE_VARTEXT1)  /* Any VARCHAR segments */
     {
-      CHARSET_INFO *cs= seg->charset;
+      const CHARSET_INFO * const cs= seg->charset;
       uint pack_length= seg->bit_start;
       uint length= (pack_length == 1 ? (uint) *(uchar*) pos : uint2korr(pos));
       if (cs->mbmaxlen > 1)
@@ -503,7 +503,7 @@
     }
     if (seg->type == HA_KEYTYPE_TEXT)
     {
-      CHARSET_INFO *cs= seg->charset;
+      const CHARSET_INFO * const cs= seg->charset;
       uint char_length1;
       uint char_length2;
       uchar *pos1= (uchar*)rec1 + seg->start;
@@ -531,7 +531,7 @@
       uchar *pos2= (uchar*) rec2 + seg->start;
       uint char_length1, char_length2;
       uint pack_length= seg->bit_start;
-      CHARSET_INFO *cs= seg->charset;
+      const CHARSET_INFO * const cs= seg->charset;
       if (pack_length == 1)
       {
         char_length1= (uint) *(uchar*) pos1++;
@@ -596,7 +596,7 @@
     }
     if (seg->type == HA_KEYTYPE_TEXT)
     {
-      CHARSET_INFO *cs= seg->charset;
+      const CHARSET_INFO * const cs= seg->charset;
       uint char_length_key;
       uint char_length_rec;
       uchar *pos= (uchar*) rec + seg->start;
@@ -622,7 +622,7 @@
     else if (seg->type == HA_KEYTYPE_VARTEXT1)  /* Any VARCHAR segments */
     {
       uchar *pos= (uchar*) rec + seg->start;
-      CHARSET_INFO *cs= seg->charset;
+      const CHARSET_INFO * const cs= seg->charset;
       uint pack_length= seg->bit_start;
       uint char_length_rec= (pack_length == 1 ? (uint) *(uchar*) pos :
                              uint2korr(pos));
@@ -663,7 +663,7 @@
 
   for (seg=keydef->seg,endseg=seg+keydef->keysegs ; seg < endseg ; seg++)
   {
-    CHARSET_INFO *cs= seg->charset;
+    const CHARSET_INFO * const cs= seg->charset;
     uint char_length= seg->length;
     uchar *pos= (uchar*) rec + seg->start;
     if (seg->null_bit)
@@ -748,7 +748,7 @@
       uint pack_length= seg->bit_start;
       uint tmp_length= (pack_length == 1 ? (uint) *(uchar*) pos :
                         uint2korr(pos));
-      CHARSET_INFO *cs= seg->charset;
+      const CHARSET_INFO * const cs= seg->charset;
       char_length= length/cs->mbmaxlen;
 
       pos+= pack_length;			/* Skip VARCHAR length */
@@ -811,7 +811,7 @@
       /* Length of key-part used with heap_rkey() always 2 */
       uint tmp_length=uint2korr(old);
       uint length= seg->length;
-      CHARSET_INFO *cs= seg->charset;
+      const CHARSET_INFO * const cs= seg->charset;
       char_length= length/cs->mbmaxlen;
 
       old+= 2;

=== modified file 'storage/innobase/handler/ha_innodb.cc'
--- storage/innobase/handler/ha_innodb.cc	2008-07-31 19:57:34 +0000
+++ storage/innobase/handler/ha_innodb.cc	2008-08-06 00:04:45 +0000
@@ -2507,7 +2507,7 @@
 	unsigned int	b_length)	/* in: data field length,
 					not UNIV_SQL_NULL */
 {
-	CHARSET_INFO*		charset;
+	const CHARSET_INFO*	charset;
 	enum_field_types	mysql_tp;
 	int			ret;
 
@@ -2741,7 +2741,7 @@
 			byte*	data;
 			ulint	key_len;
 			ulint	true_len;
-			CHARSET_INFO*	cs;
+			const CHARSET_INFO*	cs;
 			int	error=0;
 
 			key_len = key_part->length;
@@ -2800,7 +2800,7 @@
 
 		} else if (mysql_type == DRIZZLE_TYPE_BLOB) {
 
-			CHARSET_INFO*	cs;
+			const CHARSET_INFO*	cs;
 			ulint		key_len;
 			ulint		true_len;
 			int		error=0;
@@ -7458,7 +7458,7 @@
 {
 	ulint char_length;	/* character length in bytes */
 	ulint n_chars;		/* number of characters in prefix */
-	CHARSET_INFO* charset;	/* charset used in the field */
+	const CHARSET_INFO* charset;	/* charset used in the field */
 
 	charset = get_charset((uint) charset_id, MYF(MY_WME));
 

=== modified file 'storage/myisam/mi_key.c'
--- storage/myisam/mi_key.c	2008-08-05 02:31:51 +0000
+++ storage/myisam/mi_key.c	2008-08-06 00:04:45 +0000
@@ -60,7 +60,7 @@
     enum ha_base_keytype type=(enum ha_base_keytype) keyseg->type;
     uint length=keyseg->length;
     uint char_length;
-    CHARSET_INFO *cs=keyseg->charset;
+    const CHARSET_INFO * const cs=keyseg->charset;
 
     if (keyseg->null_bit)
     {
@@ -211,7 +211,7 @@
     uint length= keyseg->length;
     uint char_length;
     uchar *pos;
-    CHARSET_INFO *cs=keyseg->charset;
+    const CHARSET_INFO * const cs=keyseg->charset;
     keypart_map>>= 1;
     if (keyseg->null_bit)
     {

=== modified file 'storage/myisam/myisamchk.c'
--- storage/myisam/myisamchk.c	2008-08-05 02:31:51 +0000
+++ storage/myisam/myisamchk.c	2008-08-06 00:04:45 +0000
@@ -40,7 +40,7 @@
 static char **default_argv;
 static const char *load_default_groups[]= { "myisamchk", 0 };
 static const char *set_collation_name, *opt_tmpdir;
-static CHARSET_INFO *set_collation;
+static const CHARSET_INFO *set_collation;
 static long opt_myisam_block_size;
 static long opt_key_cache_block_size;
 static const char *my_progname_short;

